// -----------------------------------------------------------------
// File name:  APPSKEL.C
//
// This file contains the entry point, WinMain, to the application.
//
// Description of functions:
//
//   WinMain   -  The application's entry point function
//
//
// Development Team:  Dan Ruder
//
// Written by Microsoft Product Support Services, Windows Developer Support.
//
// Copyright (c) 1991, 1992 Microsoft Corporation.  All rights reserved.
// -----------------------------------------------------------------

#include <windows.h>
#include "globals.h"
#include "init.h"
#include "appskel.h"


   // Global variables defined here
HANDLE  ghInst;      // Initialized in InitInstance()
HWND    ghWnd;       // Initialized in InitInstance()


   // Local function prototypes
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine,  int nCmdShow);


//-----------------------------------------------------------------------
//  Function: WinMain
//
//  Purpose : Called by Windows on app startup.  Initializes everything,
//            and enters the application's message loop.
//
//  Parms   : hInstance     == Handle to _this_ instance
//            hPrevInstance == Handle to last instance of app
//            lpszCmdLine   == Command Line passed into app
//            nCmdShow      == How app should come up (i.e. minimized/normal)
//
//  Returns : Return value from PostQuitMessage.
//-----------------------------------------------------------------------

int PASCAL WinMain (HANDLE hInstance,            // This instance
                    HANDLE hPrevInstance,        // Last instance
                    LPSTR  lpszCmdLine,          // Command Line
                    int    nCmdShow)             // How the window is displayed
   {
   MSG msg;

               // Initialize the application if this is the first instance.
   if (!hPrevInstance)
      if (!InitApplication (hInstance))
         return (FALSE);

               // Initialize this instance of the application.
   if (!InitInstance (hInstance, nCmdShow))
      return (FALSE);

               // This is the application's message loop.  It examines all
               // messages.
   while (GetMessage (&msg,             // Put Message Here
                      NULL,             // Handle of win receiving msg
                      NULL,             // lowest message to examine
                      NULL))            // highest message to examine
      {
      TranslateMessage (&msg);          // Translates virtual key codes
      DispatchMessage (&msg);           // Dispatches message to window
      }

   return (msg.wParam);                // Returns the value from PostQuitMessage
   }
