/*  as30.c  <9-15-90>   <7-22-92>  TGR  */
/* MAC port and mallocs <3-23-92>  Ken Moll */
/* DOS port and mallocs <1-08-93>  Ed Rojas */

 /***************************************************************************** 
 *
 * $Id: as30.c,v 1.1 1993/01/09 10:32:00 rossin Exp rossin $
 *
 * $Log:	as30.c,v $
 * Revision 1.4  93/03/10  12:36:22  12:36:22  rossin (Ted Rossin)
 * Changed Copyright to include 1993.
 * 
 * Revision 1.3  93/03/05  13:25:28  13:25:28  rossin (Ted Rossin)
 * Fixed symbol truncation bug that caused an error instead of a warning.
 * Also fixed warning messages in assembler listing output.
 * 
 * 
 * Revision 1.2  93/02/13  14:13:50  14:13:50  rossin (Ted Rossin)
 * DOS port added.
 *             by Ed Rojas.
 * 
 * Revision 1.1  1993/01/09  10:32:00  rossin
 * Initial revision
 *
 *
 *****************************************************************************/

#include "port.h"
#include <stdio.h>
#include <time.h>

#ifdef DOS
#   include <malloc.h>
#endif

#ifdef ATARI
#include <timeb.h>
#include <osbind.h>
#endif

#ifdef MAC
#include <stdlib.h>
#include <console.h>	
#include <string.h> 
#endif

#include "as30.h"

#define DO_NOT_PUT_IN_OBJECT_MODULE 	-1
#define C_NULL		0
#define C_EXT		2
#define C_EXTDEF	5
#define C_STATLAB	20	/* Static .label */
#define C_EXTLAB	21	/* Global .label (External definition) */
#define TABSIZE		8

#ifdef UNIX

#define SORT	qsort		/* Uses lots of stack */
#define MALLOC	malloc

#endif

#ifdef DOS

#define SORT	qsort		/* Uses lots of stack */
#define MALLOC	malloc

#endif



#ifdef MAC

#define SORT	qsort		/* Uses lots of stack */
#define MALLOC	malloc

#endif


#ifdef ATARI

#define SORT	shellsort	/* Uses a little bit of the stack */
#define MALLOC	Malloc

#endif

int global_ptr;
int rel_tab_ptr;
int current_section;
long image_count;
Image *img_ptr;
int num_warnings;
int num_errors;
int page_length=65;		/* Listing page length in lines minus 1 */
int sym_ptr;
int obj_sym_tab_ptr;
int symbol_just_entered;
int pseudo_op_ptr=0;
int changed_file=0;

FILE *fp_stack[FILE_STACK+1];
int fp_stack_pointer=FILE_STACK;

int error_file_lut[FILE_STACK+1];
int error_pointer_stack[FILE_STACK+1];

static int listing=0;
static int banner=1;
static FILE *error_fp;

static char sym[MAX_SYM],op[2*MAX_SYM+2];
static char sym2[MAX_SYM],op2[MAX_SYM];
static char parms[2*MAX_LINE],parms2[MAX_LINE];
static char save[MAX_LINE],error[MAX_LINE];
static char save_stack[FILE_STACK+1][MAX_LINE];
static int line_stack[FILE_STACK+1];
char file_name_stack[FILE_STACK+1][MAX_LINE];

Pop_data *pseudo_op_image;
char *global_list[MAX_GLOBALS];
Sym_tab *sym_tab;
Image *image;
Sec_loc_cnt *sec_loc_cnt;
Rel_tab *rel_tab;

Error_Tab error_tab[MAX_ERRORS+2];

FILE *sfp;  /* current source code file pointer */

int conditional_state=0;
int generate_cond_code=0;

main(argc,argv)
int argc;
char *argv[];
{
    char s[MAX_LINE],start_time[40];
    int i,j,line,result,compare(),found,done,parallel,ext_ptr,file_index;
    int do_anyway;
    time_t nseconds;
    char *ctime();
    unsigned long msize;
    int cnt,flick=0;
    Image *ptr;

#ifdef MAC      
    argc = ccommand(&argv);
#endif
  	
    msize=(unsigned long)(MAX_SYM*sizeof(char));
    for(cnt=0; cnt<MAX_GLOBALS; cnt++){
	if( (global_list[cnt] = (char *)MALLOC(msize) ) == NULL){
	    printf("Memory allocation problem for global_list.\n"); exit(1);  
	}
    } 
    
    msize=(unsigned long)((MAX_SYM_ENTRIES+MAX_GLOBALS)*sizeof(Sym_tab));
    if( (sym_tab = (Sym_tab *)MALLOC(msize) ) == NULL){
	printf("Memory allocation problem sym_tab.\n"); exit(1); 
    }

#ifdef DOS
    if( (image = (Image *)halloc(MAX_IMAGE_DATA,sizeof(Image)) ) == NULL){
#else
    msize=(unsigned long)(MAX_IMAGE_DATA*sizeof(Image));
    if( (image = (Image *)MALLOC(msize) ) == NULL){
#endif
	printf("Memory allocation problem image.\n"); exit(1); 
    }

    msize=(unsigned long)((MAX_SECTIONS+1)*sizeof(Sec_loc_cnt));
    if( (sec_loc_cnt = (Sec_loc_cnt *)MALLOC(msize) ) == NULL){
    	printf("Memory allocation problem sec_loc_cnt.\n"); exit(1); 
    }
    
    msize=(unsigned long)(MAX_REL_ENTRIES*sizeof(Rel_tab));
    if( (rel_tab = (Rel_tab *)MALLOC(msize) ) == NULL){
	printf("Memory allocation problem rel_tab.\n"); exit(1); 
    }
		
    msize=(unsigned long)(MAX_PSEUDO_OPS*sizeof(Pop_data));
    if( (pseudo_op_image = (Pop_data *)MALLOC(msize) ) == NULL){ 
	printf("Memory allocation problem pseudo_op_image.\n"); exit(1); 
    }
    if(argc < 2){
	usage(argv[0]);
	exit(1);
    }

    file_index=0;
    for(i=1;i<argc;i++){
  	if(argv[i][0]=='-'){
	  switch(argv[i][1]){
	    case 'l': /* Generate Listing */
		if(argv[i][2]!=0){
		    printf("Unrecognized option: %s\n",argv[i]);
		    usage(argv[0]);
		    exit(1);
		}
		listing=1;
		break;
	    case 'q': /* Suppress the Banner */
		if(argv[i][2]!=0){
		    printf("Unrecognized option: %s\n",argv[i]);
		    usage(argv[0]);
		    exit(1);
		}
		banner=0;
		break;
	    default:
		printf("Unrecognized option: %s\n",argv[i]);
		usage(argv[0]);
		exit(1);
	  }
   	}
	else{
	    if(!file_index)
	        file_index=i;
	    else{
		printf("Only one source file can be specified\n");
		usage(argv[0]);
		exit(1);
	    }
	}
    }
    if( (sfp=fopen(argv[file_index],"r"))==NULL){
	printf("Can't open %s for read\n",argv[file_index]);
	exit(1);
    }
    strcpy(file_name_stack[FILE_STACK],argv[file_index]);
    fp_stack[fp_stack_pointer]=sfp;

    init();
    done=parallel=0; 

    time(&nseconds); 				/* Get time of the day */
    strcpy(start_time,ctime(&nseconds));	/* Turn into string    */


    if(banner) print_heading(stdout,-1,start_time);
    if(banner) printf("\n\nDecode Pass\n");

    if(fgets(save,MAX_LINE,sfp) == NULL){
	printf("No object file generated.  Empty input file\n");
	exit(1);
    }
    for(line=1; !done ;line++){
	if(flick){
	    flick=0;
	    line=line_stack[fp_stack_pointer]+1; 
	}
	if(fgets(s,MAX_LINE,sfp) == NULL){ /* see if really the end */
	    if(fp_stack_pointer==FILE_STACK) done=1;
	    else{
		sfp=fp_stack[++fp_stack_pointer];
		flick=1;
		strcpy(s,save_stack[fp_stack_pointer]);
	    }
	}

	if(s[0]=='|' && s[1]=='|'){ /* Parallel addressing mode */
	    result =  parse_line(1,line,save,sym,op,parms);
	    result |= parse_line(1,line+1,s,sym2,op2,parms2);
	    strcat(op,"||");  strcat(op,op2);
	    strcat(parms,","); strcat(parms,parms2);
    	    if(fgets(save,MAX_LINE,sfp) == NULL) done=1;
	    parallel=1;
	}
	else{
	    result=parse_line(1,line,save,sym,op,parms);
	    strcpy(save,s);
	}
	if(result){
	  if(!conditional_state || (conditional_state&&generate_cond_code)){
	    if(sym[0]!=0){	/* Symbol present */
		strcpy(sym_tab[sym_ptr].symbol,sym);
 		sym_tab[sym_ptr].add=sec_loc_cnt[current_section].lc;
		sym_tab[sym_ptr].section=current_section;
		sym_tab[sym_ptr].obj_index = DO_NOT_PUT_IN_OBJECT_MODULE;
		sym_tab[sym_ptr].flags = C_NULL;  /* Not a global */
		if(++sym_ptr >= MAX_SYM_ENTRIES){
		    printf("Symbol table overflow\n");
		    exit(1);
	   	}
		symbol_just_entered=1;
	    }
	    else
		symbol_just_entered=0;
	  }
	  if(op[0]!=0){	/* Op-code present */
	    do_anyway=0;
	    if(!strcmp(op,".if")) do_anyway=1;
	    if(!strcmp(op,".else")) do_anyway=1;
	    if(!strcmp(op,".endif")) do_anyway=1;
	    if(!conditional_state || do_anyway 
				  || (conditional_state&&generate_cond_code)){
	    	if(gen_op(line,op,parms,error)){
		    sprintf(s,"%02d %04d: %s %s",fp_stack_pointer,line+parallel
			,file_name_stack[fp_stack_pointer],error); 
		    log_error(s);
		}   
	        if(changed_file){
		    changed_file=0;
		    line_stack[fp_stack_pointer+1]=line;
		    line=0;
		    strcpy(save_stack[fp_stack_pointer+1],s);
    		    fgets(save,MAX_LINE,sfp);
	        }
	    }
 	  }
	}
	if(parallel){ line++;  parallel=0; }
    }

	/* Relocation Pass */

    if(banner) printf("Relocation Pass\n");

	/* For each global in list see if defined in this file */

    ext_ptr=0;
    for(i=0;i<global_ptr;i++){
	for(j=found=0;j<sym_ptr;j++){  /* for each symbol check if match */
	    if(!strcmp(sym_tab[j].symbol,global_list[i])){ /* symbol found */
		found=1;
		break;
	    }
	}
	if(found){ /* mark symbol as an external definition */
	    sym_tab[j].obj_index = obj_sym_tab_ptr++;
    	    if(sym_tab[j].flags != C_STATLAB){
    	    	sym_tab[j].flags = C_EXTDEF;
	    }
	    else{
    	    	sym_tab[j].flags = C_EXTLAB;
	    }
	}
	else{	/* Add to end of symbol table as an external reference */
	    strcpy(sym_tab[sym_ptr+ext_ptr].symbol,global_list[i]);
	    sym_tab[sym_ptr+ext_ptr].add = 0;
	    sym_tab[sym_ptr+ext_ptr].section = 0;
	    sym_tab[sym_ptr+ext_ptr].obj_index = obj_sym_tab_ptr++;
	    sym_tab[sym_ptr+ext_ptr].flags = C_EXT;
	    ext_ptr++;
	}
    }
    sym_ptr += ext_ptr;

    SORT((char *)sym_tab,sym_ptr,sizeof(sym_tab[0]),compare);

	/* Try to do relocation for as many relocation entries as possible */

    for(i=0;i<rel_tab_ptr;i++){  /* For each relocation entry */
	for(j=found=0;j<sym_ptr;j++){
	    if(!strcmp(sym_tab[j].symbol,rel_tab[i].symbol)){ /* symbol found */
		found=1;
		break;
	    }
	}
	if(!found){  
	    ptr=image+rel_tab[i].image_offset;
	    sprintf(s,"%02d %04d: %s Symbol \"%s\" undefined"
	    	,ptr->file_number,ptr->line_num
		,file_name_stack[ptr->file_number],
		rel_tab[i].symbol);
	    log_error(s);
	}
	else{ /* Symbol is found */
	    if(sym_tab[j].flags == C_EXT){ 
		rel_tab[i].image_offset=(unsigned long)sym_tab[j].obj_index;
	    }
	    else{
	      if(sym_tab[j].flags==C_STATLAB || sym_tab[j].flags==C_EXTLAB){
		if(sym_tab[j].flags==C_STATLAB){
		    sym_tab[j].obj_index=obj_sym_tab_ptr++;
		}
			/* overwrite image offset with obj sym tab index */
	        rel_tab[i].image_offset=(unsigned long)sym_tab[j].obj_index;
	      }
	      else{
	       ptr=image+rel_tab[i].image_offset;

		  /* Don't mess with symbols that are defined by .set */
		  /* commands.  These symbols are absolute.	      */

	       switch(rel_tab[i].flags){
		case R_PCRWORD:	/* 16-bit PC relative */
	    	    ptr->data += 
			((sym_tab[j].add-rel_tab[i].offset-1L) & 0x0000FFFFL);
		    rel_tab[i].flags=R_RESOLVED;
		    break;
		case R_PCRDWORD: /* 16-bit PC relative delayed */
	    	    ptr->data += 
			((sym_tab[j].add-rel_tab[i].offset-3L) & 0x0000FFFFL);
		    rel_tab[i].flags=R_RESOLVED;
		    break;
		case R_RELWORD:
	    	    ptr->data += 
						(sym_tab[j].add & 0x0000FFFFL);
		    strcpy(rel_tab[i].symbol
			,sec_loc_cnt[sym_tab[j].section].name);
		    rel_tab[i].flags=R_SECREL16;
			/* overwrite image offset with obj sym tab index */
		    rel_tab[i].image_offset=(unsigned long)sym_tab[j].section;
		    break;
		case R_RELPAGE:	/* Have to wait till link to determine value */
		    if( sym_tab[j].obj_index==DO_NOT_PUT_IN_OBJECT_MODULE){
		    	sym_tab[j].obj_index=obj_sym_tab_ptr;
		    	obj_sym_tab_ptr++;
		    }
			/* overwrite image offset with obj sym tab index */
		    rel_tab[i].image_offset=
			(unsigned long)sym_tab[j].obj_index;
		    break;
		case R_REL24:
	    	    ptr->data += (sym_tab[j].add & 0x00FFFFFFL);
		    strcpy(rel_tab[i].symbol
			,sec_loc_cnt[sym_tab[j].section].name);
		    rel_tab[i].flags=R_SECREL24;
			/* overwrite image offset with obj sym tab index */
		    rel_tab[i].image_offset=(unsigned long)sym_tab[j].section;
		    break;
		case R_RELLONG:
	    	    ptr->data=sym_tab[j].add;
		    strcpy(rel_tab[i].symbol
			,sec_loc_cnt[sym_tab[j].section].name);
		    rel_tab[i].flags=R_SECREL32;
			/* overwrite image offset with obj sym tab index */
		    rel_tab[i].image_offset=(unsigned long)sym_tab[j].section;
		    break;
		default:
		    break;
	      }
    	      if(sym_tab[j].section==SET_SYMBOL) rel_tab[i].flags=R_RESOLVED;
	     }
	    }
		    
	}
    }

    generate_object_file(argv[file_index]);

    if(listing){
        if(banner) printf("Listing Pass\n");
	generate_list(argv[file_index],sym_ptr,start_time);
    }

#ifdef DEBUG
    for(i=0;i<sym_ptr;i++){
        printf("Symbol ->%s<-  section %d\n"
	,sym_tab[i].symbol,sym_tab[i].section);
    }
    printf("Globals:\n\n");	
    for(i=0;i<global_ptr;i++){
	printf("%s\n",global_list[i]);
    }
    printf("Relocation Table:\n");
    for(i=0;i<rel_tab_ptr;i++){
	printf("sec=%d sec_off=0x%08lx i_off=0x%08lx flags=0x%04x Symbol: %s\n",
	    rel_tab[i].section,rel_tab[i].offset,rel_tab[i].image_offset,
	    rel_tab[i].flags,rel_tab[i].symbol);
    }
#endif

    if(banner) printf("\n%d Errors  %d Warnings\n",num_errors,num_warnings);
    if(num_errors) exit(1);
    exit(0);
}

int compare(s1,s2)
char *s1,*s2;
{
    int strcmp();
    return(strcmp(s1,s2));
}


init()
{
    int i;

    if( (error_fp=fopen("as30.err","w"))==NULL){
	printf("Can't open error log file as30.err for write\n");
	exit(1);
    }
    for(i=0;i<MAX_SECTIONS+1;i++){
	sec_loc_cnt[i].lc=0;
	sec_loc_cnt[i].loadable=0;
	sec_loc_cnt[i].name[0]=0;
    }
    sec_loc_cnt[SET_SYMBOL].lc=0;
    sec_loc_cnt[SET_SYMBOL].loadable=0;
    strcpy(sec_loc_cnt[SET_SYMBOL].name,".set");

    strcpy(sec_loc_cnt[0].name,".text");
    strcpy(sec_loc_cnt[1].name,".data");
    strcpy(sec_loc_cnt[2].name,".bss");
    sec_loc_cnt[0].loadable=1;
    sec_loc_cnt[1].loadable=1;
    sec_loc_cnt[2].loadable=0;

    strcpy(sym_tab[0].symbol,".text");
    strcpy(sym_tab[1].symbol,".data");
    strcpy(sym_tab[2].symbol,".bss");
    sym_tab[0].add=sym_tab[1].add=sym_tab[2].add=0L;
    sym_tab[0].section=0; sym_tab[1].section=1; sym_tab[2].section=2;
    sym_tab[0].obj_index=0;
    sym_tab[1].obj_index=1;
    sym_tab[2].obj_index=2;
    sym_tab[0].flags=C_NULL;
    sym_tab[1].flags=C_NULL;
    sym_tab[2].flags=C_NULL;

    current_section=0;
    image_count=0;
    img_ptr=image;
    num_warnings=0;
    num_errors=0;
    rel_tab_ptr=0;
    sym_ptr=3; 		
    obj_sym_tab_ptr=3;
}

inc_image_pointer()
{
    if(++image_count >= MAX_IMAGE_DATA){
	printf("Image table overflow\n");
	exit(1);
    }
    img_ptr++;
}

inc_rel_pointer()
{
    if(++rel_tab_ptr >= MAX_REL_ENTRIES){
	printf("Relocation table overflow\n");
	exit(1);
    }
}

int comp_err(line1,line2)
Error_Tab *line1,*line2;
{
    if(line1->file_num==line2->file_num){
    	if(line1->line_num==line2->line_num) return(0);
    	if(line1->line_num < line2->line_num) return(-1);
    	else return(1);
    }
    if(line1->file_num > line2->file_num) return(-1);
    else return(1);
}

generate_list(fname,max_symbols,start_time)
char *fname,*start_time;
int max_symbols;
{
    FILE *fplst;
    int a,b,i,line,result,page_num=1,page_line=3;
    unsigned long location_counter;
    char nest_level=' ',s[100],ts[100],error[100];
    unsigned int current_error_line,current_file;
    int comp_err(),new_line,skip=0,error_index=0;
    int do_anyway;

    basename(fname,s);
    strcat(s,".lst");
    if( (fplst=fopen(s,"w")) == NULL){
	printf("Can't open listing file %s for write\n",s);
	exit(1);
    }

    fclose(error_fp);	/* Close error log */
    if( (error_fp=fopen("as30.err","r"))==NULL){
	printf("Can't open error log file as30.err for read\n");
	exit(1);
    }

	/* generate sorted list of errors by line number */

    error_tab[error_index].file_position=ftell(error_fp);
    while(fgets(error,100,error_fp) != NULL){
	sscanf(error,"%d %d",&a,&b);
	error_tab[error_index].file_num=a;
	error_tab[error_index].line_num=b;
	error_index++;
        error_tab[error_index].file_position=ftell(error_fp);
    }    
    if(error_index){
        error_tab[error_index].line_num=0xFFFF;
        error_tab[error_index++].file_num=FILE_STACK;

        SORT((char *)error_tab,error_index-1,sizeof(error_tab[0]),comp_err);

	for(i=0;i<FILE_STACK+1;error_file_lut[i++]=FILE_STACK);
	a=error_tab[0].file_num;
 	error_file_lut[a]=0;
    	for(i=0;i<error_index-1;i++){
	    if(a != error_tab[i].file_num){
		error_file_lut[error_tab[i].file_num]=i;
		a=error_tab[i].file_num;
	    }
    	}
    }
    else{
        error_tab[error_index].line_num=0xFFFF;
        error_tab[error_index++].file_num=FILE_STACK;
    }
    print_heading(fplst,page_num++,start_time);
    fseek(sfp,0L,0); 
    location_counter=0;  image_count=0;  img_ptr=image;  error_index=0;
    conditional_state=0;

    current_error_line=error_tab[error_index].line_num;
    current_file=error_tab[error_index].file_num;
    fseek(error_fp,error_tab[error_index].file_position,0);
    if(current_error_line != 0xFFFF){
    	if(fgets(error,100,error_fp) == NULL){
	    printf("Unable to read error file\n"); exit(1);
    	}
	for(i=1;i<8;error[i++]='*');	/* Wipe out line number from listing */
	error[0]=' ';  error_index++;
    }

    page_line=2; pseudo_op_ptr=0;
    for(line=1; 1 ;line++){	/* loop broken by read of end of file */
	if(++page_line == page_length){
	    print_heading(fplst,page_num++,start_time);
	    page_line=3;
  	}
	while(current_file==fp_stack_pointer && line>current_error_line){	
							/* Print out error */
	    fprintf(fplst,"   %s",&error[3]);
	    if(++page_line == page_length){
	   	print_heading(fplst,page_num++,start_time);
	    	page_line=3;
  	    }

    	    current_error_line=error_tab[error_index].line_num;
    	    current_file=error_tab[error_index].file_num;
	    fseek(error_fp,error_tab[error_index].file_position,0);
	    if(current_error_line != 0xFFFF){
    		if(fgets(error,100,error_fp) == NULL){
	    	    printf("Unable to read error file\n"); exit(1);
    		}
		for(i=1;i<8;error[i++]='*'); /* Remove line number from list */
		error[0]=' ';  error_index++;
    	    }
	}

    	if(fgets(s,100,sfp) == NULL){
            if(fp_stack_pointer==FILE_STACK) break;
            else{
	    	page_line--;
                sfp=fp_stack[++fp_stack_pointer];
		line=line_stack[fp_stack_pointer];
		error_index=error_pointer_stack[fp_stack_pointer-1];
		if(error_index < 0) error_index=0;
    	    	current_error_line=error_tab[error_index].line_num;
    	        current_file=error_tab[error_index].file_num;
		i = FILE_STACK - fp_stack_pointer - 1;
		if(i<0) nest_level=' ';
		else    nest_level='A'+i;
		skip=1;
	        fseek(error_fp,error_tab[error_index].file_position,0);
	        if(current_error_line != 0xFFFF){
    		    if(fgets(error,100,error_fp) == NULL){
	    	    	printf("Unable to read error file\n"); exit(1);
    		    }
		    for(i=1;i<8;error[i++]='*');/*Remove line number from list*/
		    error[0]=' ';  error_index++;
    	    	}
	    }
	}
	if(!skip){
	  result=parse_line(3,line,s,sym,op,parms);
	  if(sym[0] == '|' && sym[1] == '|'){ sym[0]=0; result=0; }
	  if(result){
	    detab(s,ts);
	    if(    img_ptr->file_number==fp_stack_pointer
		&& img_ptr->line_num==line){
              if(!conditional_state || (conditional_state&&generate_cond_code)){
	    	fprintf(fplst,"%c %04d %06lx %08lx  %s",nest_level,line,
		    img_ptr->address,img_ptr->data,ts);
	      }
	      else{
	    	fprintf(fplst,"%c %04d                  %s",nest_level,line,ts);
	      }
	      inc_image_pointer();
	      while(img_ptr->line_num==line){ /* Multi line out */
		  if(++page_line == page_length){
	    	    print_heading(fplst,page_num++,start_time);
	    	    page_line=3;
  		  }
                  if(	   !conditional_state 
			|| (conditional_state&&generate_cond_code)){
	    	    fprintf(fplst,"%c %04d %06lx %08lx\n",nest_level,line,
		        img_ptr->address,img_ptr->data);
	      	  }
	          else{
	    	    fprintf(fplst,"%c %04d                  %s"
			,nest_level,line,ts);
	          }
	    	  inc_image_pointer();
		}
	    }
	    else{  /* Most likely a pseudo op */
		if(op[0] == '.'){ /* pseudo op */
	    	    if(!strcmp(op,".if")){
			conditional_state=1;
			generate_cond_code
			          =(pseudo_op_image[pseudo_op_ptr].address)?1:0;
			if(!generate_cond_code) pseudo_op_ptr++;
		    }
	    	    if(!strcmp(op,".else")){
			conditional_state=2;
			generate_cond_code=(generate_cond_code)?0:1;
			if(!generate_cond_code) pseudo_op_ptr++;
		    }
	    	    if(!strcmp(op,".endif")){
			conditional_state=0;
			generate_cond_code=1;
		    }
              	    if(    !conditional_state 
			|| (conditional_state&&generate_cond_code)){
		      if(!strcmp(op,".include") || !strcmp(op,".copy")){
			line_stack[fp_stack_pointer]=line;
			if(--fp_stack_pointer < 0){
		    	    printf(
			       "Too many levels of nested .include or .copy\n");
		    	    exit(1);
			}
			sfp=fp_stack[fp_stack_pointer];
			if(error_index-1<0) error_index=1;
			error_pointer_stack[fp_stack_pointer]=error_index-1;
			error_index=error_file_lut[fp_stack_pointer];
    	    		current_error_line=error_tab[error_index].line_num;
    	        	current_file=error_tab[error_index].file_num;
    			fseek(sfp,0L,0); 
			new_line=0;
	        	fseek(error_fp,error_tab[error_index].file_position,0);
	        	if(current_error_line != 0xFFFF){
    		    	    if(fgets(error,100,error_fp) == NULL){
	    	    	     	printf("Unable to read error file\n"); exit(1);
    		     	    }
		    	    for(i=1;i<8;error[i++]='*');
		    	    error[0]=' ';  error_index++;
    	    		}
		      }
		      else
			new_line=line;
		      switch(pseudo_op_image[pseudo_op_ptr].type){
			case 0: /* */
	    	            fprintf(fplst,"%c %04d                  %s"
				,nest_level,line,ts);
			    break;
			case 1: /* */
	    	    	    fprintf(fplst,"%c %04d %06lx           %s"
				 ,nest_level,line,
			         pseudo_op_image[pseudo_op_ptr].address,ts);
			    break;
			case 2: /* */
	    		    fprintf(fplst,"%c %04d        %08lx  %s",nest_level
				,line,
			         pseudo_op_image[pseudo_op_ptr].value,ts);
			    break;
			case 3: /* */
	    		    fprintf(fplst,"%c %04d %06lx %08lx  %s",nest_level
				 ,line,
			         pseudo_op_image[pseudo_op_ptr].address
				,pseudo_op_image[pseudo_op_ptr].value,ts);
			    break;
		      }
		      pseudo_op_ptr++;
		      i=FILE_STACK - fp_stack_pointer -1;
		      if(i<0) nest_level=' ';
		      else    nest_level='A'+i;
		      line=new_line;
		    }
		    else{
	    	        fprintf(fplst,"%c %04d                  %s"
			    ,nest_level,line,ts);
		    }
		}
		else{
              	    if(!conditional_state 
				    || (conditional_state&&generate_cond_code)){
	    	        fprintf(fplst,"%c %04d %06lx           %s"
			    ,nest_level,line,img_ptr->address,ts);
		    }
		    else{
	    	        fprintf(fplst,"%c %04d                  %s"
			    ,nest_level,line,ts);
		    }
		}
	    }
	  }
	  else{
	    detab(s,ts);
	    fprintf(fplst,"%c %04d                  %s",nest_level,line,ts);
	  }
	}
	else skip=0;
    }

	/* Print out symbol table */
    
    for( ; ++page_line <= page_length;) fprintf(fplst,"\n");
    print_heading(fplst,page_num++,start_time);
    fprintf(fplst,"\t\t\t\tSymbol Table\n\n");	
    page_line=5;
    for(line=0;line<max_symbols/2;line++){
	if(++page_line == page_length){
	    print_heading(fplst,page_num++,start_time);
	    page_line=3;
  	}
	fprintf(fplst,"%-16s %-10s %08lx      %-16s %-10s %08lx\n"
	    ,sym_tab[2*line].symbol,sec_loc_cnt[sym_tab[2*line].section].name
	    ,sym_tab[2*line].add,sym_tab[2*line+1].symbol
	    ,sec_loc_cnt[sym_tab[2*line+1].section].name,sym_tab[2*line+1].add);
    }
    if(++page_line == page_length){
    	print_heading(fplst,page_num++,start_time);
    	page_line=3;
    }
    if(max_symbols & 1){ /* print odd entry */
	fprintf(fplst,"%-16s %-10s %08lx\n",sym_tab[max_symbols-1].symbol,
	    sec_loc_cnt[sym_tab[max_symbols-1].section].name
	    ,sym_tab[max_symbols-1].add);
    }
    if(++page_line == page_length){
    	print_heading(fplst,page_num++,start_time);
    	page_line=3;
    }
    if(++page_line == page_length){
    	print_heading(fplst,page_num++,start_time);
    	page_line=3;
    }
    fprintf(fplst,"\n[%d Symbols]\n",max_symbols);
}

basename(source,dest)
char *source,*dest;
{
    while(*source){
	if(*source == '.'){
	    *dest=0;
	    return;
	}
     	*dest++ = *source++;
    }
    *dest=0;
}

print_heading(temp_fp,page_num,start_time)
FILE *temp_fp;
int page_num;
char *start_time;
{
  if(page_num>1) fprintf(temp_fp,"\n");
  fprintf(temp_fp,"TMS320C30 Assembler  Version %d.%d \t\t%s",MAJOR_VERSION
	,MINOR_VERSION,start_time);
  fprintf(temp_fp
          ,"(c) Copyright 1990-1993, Ted Rossin the Butt Hole not Inc.\t\t");
  if(page_num>0) fprintf(temp_fp,"Page %d\n\n",page_num);
}

/* 
   The tab size on the Macintosh is commonly set to 4.  The constant TABSIZE
   was substituted for 8 in the routine detab.  Also, the dest string was over-
   writing the source string causing an infinite loop.  The outcnt kludge was
   added as a quick and inelegant fix. 3/22/92 
*/

detab(source,dest)
char *source,*dest;
{
    int tab=0, outcnt = 0;

    while(*source){
        if (outcnt >= 99) {/*source and dest have length 100 in generate_list */
    	    printf("*** Array over-run in procedure detab. ***\n"); 
	    dest[99] = 0; return; 
    	}
	if(*source != '\t'){
	    *dest++ = *source++;  tab++;
	    tab &= 7;
	    outcnt++;
	}
	else{
	    source++;
	    for( ; tab<TABSIZE;tab++)
		*dest++ = ' ';
	    tab=0;
	    outcnt+=TABSIZE;
	}
    }
    *dest=0;
}

log_error(s)
char *s;
{
    num_errors++;

    printf("%s\n",&s[2]);
    if(listing){
	if(num_errors<MAX_ERRORS)
      	    fprintf(error_fp,"%s ****\n",s);
	else{
	    printf("Maximum Error count reached!\n");
	    exit(1);
	}
    }
}

log_warning(s)
char *s;
{
    num_warnings++;
    
    printf("%s\n",&s[2]);
    if(listing){
	if(num_warnings<MAX_WARNINGS)
      	    fprintf(error_fp,"%s ****\n",s);
	else{
	    printf("Maximum Error count reached!\n");
	    exit(1);
	}
    }
}

usage(name)
char *name;
{
    printf("Usage: %s [options] source_file_name\n",name);
    printf("Options: -l (generates listing)\n");
    printf("         -q (suppresses banner)\n");
}
