/* as30.h <9-30-90> <7-22-92> TGR */

 /***************************************************************************** 
 *
 * $Id: as30.h,v 1.1 1993/01/09 10:33:56 rossin Exp rossin $
 *
 * $Log:	as30.h,v $
 * Revision 1.3  93/03/10  11:06:26  11:06:26  rossin (Ted Rossin)
 * Fixed bug of not dealing with spaces and tabs before and after parameters.
 * 
 * Revision 1.2  93/01/09  10:37:12  10:37:12  rossin (Ted Rossin)
 * Bumped minor rev
 * 
 * Revision 1.1  1993/01/09  10:33:56  rossin
 * Initial revision
 *
 *****************************************************************************/

#define MAJOR_VERSION	2
#define MINOR_VERSION	2

#define MAX_SYM		16
#define FILE_STACK	4


/*************************************************************************
**									**
**	Pop_data.type  Line #	Address	  Value				**
**	     0	  	Yes	  No	    No				**
**	     1	  	Yes	  Yes       No				**
**	     2	  	Yes	  No	    Yes				**
**	     3	  	Yes	  Yes	    Yes				**
**									**
*************************************************************************/

typedef struct{
    unsigned short file_number;  
    unsigned short type;  
    unsigned long address;
    unsigned long value; 
} Pop_data;

typedef struct{
    char mnemonic[14];
    unsigned short group;
    unsigned short special_number;
    unsigned long operation;
} Op_table;

typedef struct{
    char symbol[MAX_SYM];
    unsigned long add;
    unsigned short section;
    short obj_index;
    short flags;
} Sym_tab;

typedef struct{
    unsigned short file_number;
    unsigned short line_num;
    unsigned short section;
    unsigned long address;
    unsigned long data;
} Image;

typedef struct{
    char name[9];
    char loadable;
    unsigned long lc;
} Sec_loc_cnt;

typedef struct{
    unsigned short section;
    unsigned short flags;
    unsigned long offset;
    unsigned long image_offset;
    char symbol[MAX_SYM];
} Rel_tab;

typedef struct{
    unsigned short file_num;
    unsigned short line_num;
    long file_position;
} Error_Tab;

#define R_RELLONG	0x0011
#define R_SECREL32	0x0030
#define R_RELWORD	0x0010
#define R_RELPAGE	0x0033
#define R_REL24		0x0005
#define R_PCRWORD	0x0013
#define R_PCRDWORD	0x0014
#define R_RESOLVED	0xFFFF
#define R_SECREL16	0x0031
#define R_SECREL24	0x0032

#define MAX_GLOBALS	100

#define MAX_REL_ENTRIES	800
#define MAX_ERRORS	50
#define MAX_WARNINGS	100
#define MAX_SYM_ENTRIES	200
#define MAX_IMAGE_DATA	8000L
#define MAX_SECTIONS	32
#define MAX_LINE	100
#define MAX_PSEUDO_OPS	1000

#define SET_SYMBOL	MAX_SECTIONS

#define LONG		0
#define SHORT		1

/* Opcode table defines */

#define NUM_PSEUDO_OPS	38

#define IACK		0
#define NOP		1
#define POP		2
#define POPF		3
#define PUSH		4
#define PUSHF		5
#define ROL		6
#define ROLC		7
#define ROR		8
#define RORC		9
#define RPTS		10
#define LDP		11
