/*  Project Dialog
    Borland International
    Copyright  1994. All Rights Reserved.

    SUBSYSTEM:    dialog.exe Application
    FILE:         dialgapp.cpp
    AUTHOR:       C++ Developer Support


    OVERVIEW
    ========
    Source file for implementation of DialogApp (TApplication).
*/


#include <owl\owlpch.h>
#pragma hdrstop


#include "dialgapp.h"
#include "dlgabtdl.h"                        // Definition of about dialog.
#include "retdlg.h"


//{{DialogApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(DialogApp, TApplication)
//{{DialogAppRSP_TBL_BEGIN}}
    EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
    EV_COMMAND(CM_RETURNDIALOG, CmReturnDialog),
//{{DialogAppRSP_TBL_END}}
END_RESPONSE_TABLE;




//////////////////////////////////////////////////////////
// DialogApp
// =====
//
DialogApp::DialogApp () : TApplication("Dialog")
{
    // INSERT>> Your constructor code here.

}


DialogApp::~DialogApp ()
{
    // INSERT>> Your destructor code here.

}


void DialogApp::SetupSpeedBar (TDecoratedFrame *frame)
{
    //
    // Create default toolbar New and associate toolbar buttons with commands.
    //
    TControlBar* cb = new TControlBar(frame);
    cb->Insert(*new TButtonGadget(CM_RETURNDIALOG, CM_RETURNDIALOG));
//    cb->Insert(*new TSeparatorGadget(6));

    // Add fly-over help hints.
    cb->SetHintMode(TGadgetWindow::EnterHints);

    frame->Insert(*cb, TDecoratedFrame::Top);
}


//////////////////////////////////////////////////////////
// DialogApp
// =====
// Application intialization.
//
void DialogApp::InitMainWindow ()
{
    TDecoratedFrame *frame = new TDecoratedFrame(0, GetName(), 0);

    nCmdShow = nCmdShow != SW_SHOWMINIMIZED ? SW_SHOWNORMAL : nCmdShow;

    //
    // Assign ICON w/ this application.
    //
    frame->SetIcon(this, IDI_SDIAPPLICATION);

    //
    // Menu associated with window and accelerator table associated with table.
    //
    frame->AssignMenu(SDI_MENU);

    //
    // Associate with the accelerator table.
    //
    frame->Attr.AccelTable = SDI_MENU;

    SetupSpeedBar(frame);

    TStatusBar *sb = new TStatusBar(frame, TGadget::Recessed,
                                    TStatusBar::CapsLock        |
                                    TStatusBar::NumLock         |
                                    TStatusBar::ScrollLock      |
                                    TStatusBar::Overtype);
    frame->Insert(*sb, TDecoratedFrame::Bottom);

    SetMainWindow(frame);

    //
    // Windows 3-D controls.
    //
    EnableCtl3d(TRUE);
}


//////////////////////////////////////////////////////////
// DialogApp
// ===========
// Menu Help About dialog.exe command
void DialogApp::CmHelpAbout ()
{
    //
    // Show the modal dialog.
    //
    DialogAboutDlg(MainWindow).Execute();
}

int OwlMain (int , char* [])
{
    DialogApp     App;
    int           result;

    result = App.Run();

    return result;
}

void DialogApp::CmReturnDialog ()
{
    // INSERT>> Your code here.
    TReturnDialog *rd = new TReturnDialog(MainWindow);
    rd->Create();

//    TToolBox *tb = new
}

