;
; dllinit.asm  --  initialize a DLL for OS/2
;
; DLL initialization is called if library is INITGLOBAL or INITINSTANCE
;
;       if INITGLOBAL, then this is called once, when the DLL is loaded
;       if INITINSTANCE this is called each time a new process
;
; Grafted in selected bits of c.asm -- the zortech C run-time start up
; code.  This is to try to make malloc happier.
;
; 02/25/92
;
;    This dllinit contains what is needed to support ZORTECH 3.0r4
;    multi threaded libraries which are compiled with the _MT flag
;    turned on.
;
;    Once assembled, this module replaces c.asm in the zll.lib library
;
;
;    Philip H. Fruh                  Internet: philfruh@stfvm4.ibm.com
;

        .286P

; OS2 externals
        extrn   DOSGETINFOSEG:far


DGROUP  GROUP   _DATA
_DATA   SEGMENT WORD PUBLIC 'DATA'
;        public  __acrtused
;__acrtused     dw      1234
        public  __module_handle
__module_handle dw      ?       ;Module handle of DLL
        public  __linfoseg,__threadid
__ginfoseg      dw      ?       ;selector for global information segment
__threadid      dw      6       ;far pointer to current thread ID
__linfoseg      dw      ?       ;selector for local information segment
_DATA   ENDS

_TEXT   SEGMENT WORD PUBLIC 'CODE'
        ASSUME  CS:_TEXT, DS:DGROUP

EXTRN   _DLL_INIT__Fv:FAR      ; void DLL_INIT();

EXTRN   __cinit_f:FAR

        PUBLIC  _main
_main   PROC FAR
        ret
_main   ENDP


init    PROC FAR                ; initialization routine

        ; at this point, the following registers have:
        ;       SS:SP           current user stack
        ;       DS              selector for DLL's DGROUP, if any; otherwise
        ;                       DGROUP for process attaching to DLL
        ;       AX              Module handle of the DLL

        pusha
        push    ds
        push    es

        mov     __module_handle,AX
        push    DS
        mov     AX,offset DGROUP:__ginfoseg
        push    AX
        push    DS
        mov     AX,offset DGROUP:__linfoseg
        push    AX
        call    DOSGETINFOSEG
        call    __cinit_f               ; call static constructors
        call    _DLL_INIT__Fv   ; call cpp initialization routine DLL_INIT();

        pop     es
        pop     ds
        popa

        ret

init    ENDP

_TEXT   ENDS

END     init


