/*
	dumpcga.C

	Dump the CGA character font bytes to standard output.
	GRAFTABL must be installed prior to running DUMPCGA.
	GRAFTABL contains the latter half of the font but the
	first half is stored in ROM beginning at address f000
	:fa6e.  The dump is in hexadecimal and can be merged
	with a C program, with minor adjustments.

	Copyright (C) 1993, Geoff Friesen B.Sc.
	All rights reserved.

	Developed with: Borland C++ 3.1
*/

#if !defined(__LARGE__)
#error Large Memory Model Expected
#endif

#include <dos.H>
#include <stdio.H>

void dump (unsigned segment, unsigned offset, unsigned nbytes);

void main (void)
{
   dump (0xf000, 0xfa6e, 0x400);
   dump (peek(0, (0x001f << 2)+2), peek(0, 0x001f << 2), 0x400);
}

void dump (unsigned segment, unsigned offset, unsigned nbytes)
{
   int count = 0;

   while (nbytes--)
   {
	printf ("0x%02X, ", (unsigned char) peekb(segment, offset++));
	if (++count == 8 || !nbytes)
	{
	    printf ("\n");
	    count = 0;
	}
   }
}