/* dumpprog.c  <3-20-92>  TGR */

#include <stdio.h>
#include "ln30.h"

#define MAX_SECTIONS		90
#define MAX_SEC_NAME		8
#define MAX_SECTION_IMAGE_SIZE	8191

#define RAM_START	0L

static File_Header file_header;
static Section_Header section_header[MAX_SECTIONS];
static unsigned long section_image[MAX_SECTION_IMAGE_SIZE];

main(argc,argv)
int argc;
char *argv[];
{
    int section;
    unsigned long *ptr;
    unsigned long load_address,counter;
    FILE *fpin;

    if(argc<2){
	printf("Usage: %s filename\n",argv[0]);
	exit(1);
    }
    
    if( (fpin=fopen(argv[1],"rb"))==NULL){
	printf("Can't open %s for read\n",argv[1]);
	exit(1);
    }

    if (fread(&file_header,sizeof(file_header),1,fpin) !=1){
	printf("Error reading %s\n",argv[1]);
	exit(1);
    }

    if(file_header.magic != 0x0093){ /* Invalid file type */
      	fclose(fpin);
	printf("Invalid input file type\n");
    	exit(1);
    }

    for(section=0;section<file_header.num_sec;section++){
	if(fread(&section_header[section],sizeof(section_header[0])
		,1,fpin) != 1){
	    printf("Error reading section header from %s\n",argv[1]);
	    exit(1);
	}
    }

    for(section=0;section<file_header.num_sec;section++){
      if(section_header[section].flags != STYP_BSS){ /* Load section */
	if(fseek(fpin,section_header[section].raw_data_pointer,0)){
	    printf("Seek error in file %s\n",argv[1]);
	    exit(1);
	}
	load_address=section_header[section].physical_address;
	if(fread(section_image,sizeof(section_image[0])
		,(int)section_header[section].size,fpin) 
					!= (int)section_header[section].size){
	    printf("Error reading raw data from section %s\n"
		,section_header[section].name);
	    exit(1);
	}
 	printf("\nSection: %s\n\n",section_header[section].name);
	for(counter=0;counter<section_header[section].size;counter++){
	    printf("0x%06lx:  0x%08lx\n",load_address++,section_image[counter]);
	}
      }
    }

    fclose(fpin);
    exit(0);
}
