/* float.c  <10-16-90>  <8-04-92> TGR */

 /***************************************************************************** 
 *
 * $Id$
 *
 * $Log:	float.c,v $
 * Revision 1.1  93/01/09  10:52:52  10:52:52  rossin (Ted Rossin)
 * Initial revision
 * 
 *****************************************************************************/

#include "port.h"

#ifdef IEEE
#define	EXPONENT_OFFSET	0x7F000000L
#define	EXPONENT_BIAS	127
#endif

#ifdef DEC
#define	EXPONENT_OFFSET	0x81000000L
#define	EXPONENT_BIAS	129
#endif

convert_TI_float(short_form,f,value)
int short_form;
float f;
unsigned long *value;
{
    unsigned long float_to_ti();
    unsigned long float_to_shortti();
    float t;

    if(f==0.0){
	*value=(short_form)?0x00008000L:0x80000000L;
	return(0);
    }

    if(short_form){
        t=f;  
        if(t<0.0) t = -t;
	if(t>256.0  || t<7.8163e-3) return(-2);
        *value=float_to_shortti(f);
    }
    else{
	*value=float_to_ti(f);
    }
    return(0);   
}

unsigned long 
float_to_shortti(f)
float f;
{
    unsigned long val,val2,neg=0,exp;
    union{
	unsigned long l;
	float f;
    }u;

    u.f=f;
    u.l = (u.l & 0x007FF800L)|0x00000400L;
    u.f = f +u.f;	/* round value */
    val = u.l;
    val2 = val & 0xFF800000L;
    if(val2 & 0x80000000L) neg=1;
    if(val2 == 0) return(0x00008000L);
    val = (val>>12)&0x000007FF;
    exp = (val2 >> 23) & 0xFF;
    exp -= EXPONENT_BIAS;
    if(neg){
	val |= 0x800;
	val = ~val+1;
	if(val & 0x800) exp-=1;
	return( ((exp & 0x0F)<<12)|0x00000800L|(val & 0x7FF) );
    }
    else
    	return( ((exp & 0x0F)<<12)|val);
}

unsigned long
float_to_ti(f)
float f;
{
    unsigned long val,val2,neg=0;
    union{
	unsigned long l;
	float f;
    }u;

    u.f=f;
    val = u.l;
    val2 = val & 0xFF800000L;
    if(val2 & 0x80000000L) neg=1;
    val2+=val;  /* shift exponent left to make room for sign bit */
    if(val2 == 0) return(0x80000000L);
    if(neg){  /* take 2s comp of mantissa */
	val = (val2-EXPONENT_OFFSET) | 0x00800000L;
	val2 = (val & 0x007FFFFFL)   | 0x00800000L;
	val2 = ~val2+1;
	if(val2 & 0x00800000L) val-=0x01000000L;
	return( (val & 0xFF800000L) | (val2 & 0x007FFFFFL) );
    }
    else
	return(val2-EXPONENT_OFFSET);
}
