/*
    global.h

    Main application header file

*/

#include <windows.h>
#include <shellapi.h>
#include <commdlg.h>
#include <stdlib.h>
#include <memory.h>
#include <toolhelp.h>
#include "dialogs.h"

//
// Menu ids
//

#define IDM_SAVEAS          0x0102
#define IDM_PRINT           0x0103
#define IDM_PRINTSETUP      0x0104
#define IDM_EXIT            0x0105

#define IDM_COPY            0x0201

#define IDM_HELPCONTENTS    0x0900
#define IDM_ABOUT           0x0901

//
// general constants
//

#define MAXLISTLINES 100

//
// Child window ids
//

#define IDC_LIST 1

//
// Private messages
//

#define RW_MSG          WM_USER
#define RW_HOOK         WM_USER+1

//
// structures
//

typedef struct _RIPMSG {
    WORD wErr;                  // the error code
    LPSTR pMsg;                 // the text of the error
} RIPMSG, FAR *PRIPMSG;

//
// global data
//

char *szAppName;                    // App name
HINSTANCE hAppInstance;             // app instance
HWND hwndMain;                      // main window handle
TEXTMETRIC tmSysFont;               // system font metrics
HANDLE hAccTable;                   // accelerator table

//
// main.c
//

extern LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
extern UINT cdecl Message(UINT uiBtns, LPSTR lpFormat, ...) ;
extern void cdecl Status(LPSTR lpFormat, ...);
extern BOOL FAR PASCAL NotifyProc(WORD wID, DWORD dwData);
extern LPSTR CreateTextImage(void);
extern void DeleteTextImage(LPSTR pImage);

//
// init.c
//

extern BOOL InitFirstInstance(HANDLE hInstance);
extern BOOL InitCurrentInstance(HANDLE hInstance, LPSTR lpszCmdLine, int cmdShow);
extern void Terminate(void);
extern void HookAll(HINSTANCE hInstance);
extern void UnhookAll(void);

//
// help.c
//

extern void About(HWND hWnd);
extern void Help(HWND hWnd, WORD wParam);

//
// file.c
//

// flags for File functions
#define FILE_PROMPT_FOR_SAVE        0x0001
#define FILE_DONT_PROMPT_FOR_SAVE   0x0000
#define FILE_UPDATE_CAPTION         0x0002
#define FILE_DONT_UPDATE_CAPTION    0x0000
#define FILE_SAVE                   0x0000
#define FILE_SAVE_AS                0x0004


// functions
extern BOOL FileSave(WORD wFlags);

//
// clip.c
//

extern void ClipCommand(HWND hWnd, WPARAM aParam);
extern void InitClipMenu(HMENU hmenuPopup);

//
// print.c
//

extern void Print(HDC hDC);

