

/* A simple hearing tester. */

#include "stdio.h"
#include "dos.h"

#define DELAY 100000

/*  
If you use Microsoft C, include these #defines:

#define inportb inp
#define outportb outp
*/

void tone(int freq);

main(void)
{
  int freq;

  do {
    printf("enter frequency (0 to exit): ");
    scanf("%d", &freq);
    if(freq) tone(freq);
  } while(freq);

  return 0;
}

/* Beep the speaker using the specified frequency. */
void tone(int freq)
{
  unsigned long i;
  union {
    long divisor;
    unsigned char c[2];
  } count;

  unsigned char p;

  count.divisor = 1193280 / freq;  /* compute the proper count */
  outportb(67, 182); /* tell 8253 that a count is coming */
  outportb(66, count.c[0]); /* send low-order byte */
  outportb(66, count.c[1]); /* send high-order byte */
  p = inportb(97); /* get existing bit pattern */
  outportb(97, p | 3); /* turn on bits 0 and 1 */

  for(i=0; i<DELAY; ++i) ; /* delay loop */

  outportb(97, p); /* restore original bits to turn off speaker */
}


