+             { n1 n2 --- n1+n2 }
              "plus". Add n1 to n2. The sum is placed on the top
              of the stack.
                        1 2 +
              The result, 3, is left on the top of the stack.
-             { n1 n2 --- n1-n2 }
              "minus". Subtract n2 from n1 and place the result 
              on the top of the stack.
                        2 1 -
              The result, 1, is left on the stack.
*             { n1 n2 --- n1*n2 }
              "star". Multiply n1 times n2.
                        2 2 *
              The result, 4, is placed on the top of the stack.
/             { n1 n2 --- n1/n2 }
              "slash". Divide n1 by n2.
                        4 2 /
              Leaves 2 on the top of the stack.
rem           { n1 n2 --- remainder(n1/n2}
              "rem". Calculate the remainder of n1 divided by n2:
                        4 2 rem
              Leaves 0 on the stack.
dup           { n1 --- n1 n1 }
              "dup".  Duplicate the top stack entry:
                        1 dup
              Results in two 1s on the stack.
swap          { n1 n2 --- n2 n1 }
              "swap". Swap the top two entries on the top of the stack.
                        1 2 swap
              results in the top stack entry being 2 and the second entry
              being 1.
drop          { n1 --- }
              "drop". Remove the top number on the stack.
var           { --- }                      Compile time
              { --- addr.of.var }          Run time
              "var". At compile time, creates a variable:
                        var trash
              At run time, push the address of the
              variable onto the stack:
                        trash    { --- addr.of.trash }
const         { n --- }                    Compile time
              { --- n }                    Run time
              "constant". Create a constant.
                        5 const five       
?             { address --- }
              "query". Type the contents of the address that is on the
              top of the stack.
                        trash ?
              types the value stored in the variable trash. This is
              logically equivalent to "<- =".
<-            { address --- value }
              "fetch". Fetch the value from address and place on the top
              of the stack.
                         trash <-
              retrieves the value stored at trash and places it on the top
              of the stack.
->            { value address --- }
              "store". Store the value into address.
                         5 trash ->
              moves 5 into the variable trash.
<             { n1 n2 --- truth }
              "less than". Compare the two numbers on the top of the stack
              and return TRUE or FALSE.
                         5 6 <                 { returns true  }
                         5 5 <                 { returns false }
                         6 5 <                 { returns false }
==            { n1 n2 --- truth }
              "equals".
                         5 6 ==                { returns false }
                         5 5 ==                { returns true  }
                         6 5 ==                { returns false }
>             { n1 n2 --- truth }
              "greater than".
                         5 6 >                 { returns false }
                         5 5 >                 { returns false }
                         6 5 >                 { returns true  }
if else endif { truth --- }
              "if".
                         5 5 ==
                         if   " True comparrison"
                         else " False comparrison"
                         endif
else          { --- }
              "else". See 'if'.
endif         { --- }
              "endif". See 'if'.
=             { value --- }
              "display". Display the number at the top of the Data
              Stack to the screen.
macros        { --- }
              "macros". Display all of the currently defined macro
              names on the computer screen.
s?            { --- }
              "stack query". Non-descructive Data Stack display to
              the screen.
exit          { --- }
              "exit". Exit CALC and return to the calling function.
              Returns to DOS if stand alone program.
{             { --- }
              "left brace". Text between the braces is treated as a
              comment. Left brace starts a comment.
                        { This is a comment }
              See '}'.
}             { --- }
              "right brace". Close a comment. See '}'.
m{            { --- }
              "macro start". Start a new macro definition. The macro
              name is the next word in the input stream:
                        m{ new macro  }m
              See '}m'.
}m            { --- }
              "end macro". Finishes a macro definition and exits
              compile mode. Must be pared with m{. See 'm{'.
" text"       { --- }
              "double quote". Type a string to the screen. Used in
              the form:
                        " This goes to the screen."
cr            { --- }
              "c-r". Type a carriage return to the screen.
(             { n --- }
              "start loop". Begin a do loop. Can be used only in a
              macro definition.
                        m{ ten-dots 10 ( " ." ) }m
              See ')'.
)             { --- }
              "end loop". The end of a do loop. Can be used only inside
              a macro definition. See '('.
i             { --- n }
              "i". Push the current do loop index onto the Data Stack.
help          { --- }
              "help". Looks up the specified macro name in HELP.APP
              and prints the entry to the screen. Usage:
                     help var
              prints the help entry for "var". Use the 'macros' command
              to print the macros defined.
cls           { --- }
              "c-l-s". Clear screen.
branch        { ? }
              Internal macro that should not be used.
0bran         { ? }
              Internal macro that should not be used.
.quote        { ? }
              Internal macro that should not be used.
do_do         { ? }
              Internal macro that should not be used.
do_loop       { ? }
              Internal macro that should not be used.
quote         { ? }
              Internal macro that should not be used.
create        { ? }
              Internal macro that should not be used.
lit           { ? }
              Internal macro that should not be used.

