/*
	hlib.H

	Version 1.1

	Hercules Function Library Header File

	Copyright (C) 1993, Geoff Friesen B.Sc.
	All rights reserved.

	Developed with: Borland C++ 3.1
*/

#define	BLACK_ON_WHITE	0
#define	WHITE_ON_BLACK	!BLACK_ON_WHITE

#define	VSIZE		352

#ifdef __cplusplus
extern "C"
{
#endif

void	haspect		(double aspect);
void	hbezier1	(int x1, int y1, int x2, int y2, int x3, int y3,
			 double ss);
void	hcenter		(const char *s, int *cx, int *cy);
void	hcircle		(int cx, int cy, int radius);
void	hcls		(void);
int	hdriver		(const char *filespec);
int	hdump		(void);
int	hexist		(void);
int	hgetstate	(void);
void	hline		(int x1, int y1, int x2, int y2);
void	hlineto		(int x, int y);
void	hmoveto		(int x, int y);
void	hoff		(void);
void	hon		(void);
void	hplot		(int x, int y);
int	hpoint		(int x, int y);
void	hputc		(int c);
void	hputs		(const char *s);
void	hrectangle	(int x1, int y1, int x2, int y2);
void	hreset		(int x, int y);
void	hset		(int x, int y);
void	hsetstate	(int _state);
void	_hsetstate	(int _state);
void	hunplot		(int x, int y);
int	hversion	(void);
int	hwherex		(void);
int	hwherey		(void);

#ifdef __cplusplus
}
#endif