/*
|	FILE: IO.CPP
|
|	This program is contains the source code for the program
|	CALC.CPP. It is code from:
|
|		Writing Your Own Application Language
|
|	Published by:
|		Wordware Publishing, Inc.
|		1506 Capital Avenue
|		Plano, Texas 75074
|
|	Written by:
|		Norman E. Smith, CDP
|		Copyright 1992 
|		All Rights Reserved
|
|	Right to use, copy, and modify this code is granted
|	for personal non-commercial use, provided that this 
|	copyright disclosure remains on ALL copies. Any other 
|	use, reproduction, or distribution requires the written 
|	consent of the author.
*/

#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "until.h"
/***********************+----------------+
|			| read_next_line |
|			+----------------+
*/
void read_next_line()
{
	char *status;

ReadAgain:
	status = (READ_WA)();
	if(status == 0){
		if(INPUT_SOURCE){	// EOF on include file, back to stdin
			close_include();
			goto ReadAgain;
		}else{			// EOF on stdin, so exit
			cout << "End of File on STDIN\n";
			exit(0);
		}
	}
}
/***********************+----------------+
|			| tabs_to_blanks |
|			+----------------+
|
*/
void tabs_to_blanks(char* string)
{
	char temp[TIBSIZE*2];
	char * orig;
	char ch;
	int  len;
	int  i;
	int  j;

	temp[0]  = '\0';
	orig     = string;
	len      = strlen(string);
	for(i=0,j=0;i<len;i++){
		ch = *string++;
		if(ch == '\t'){
			temp[j++] = ' ';
			temp[j++] = ' ';
			temp[j++] = ' ';
			temp[j++] = ' ';
		}else{
			temp[j++] = ch;
		}
		if(j > (TIBSIZE*2)){
			cout << "Too many TABS in input line \n";
		}
	}
	temp[j] = '\0';
	strcpy(orig,temp);
}
/***********************+------------+
|			| read_stdin |
|			+------------+
*/
char *read_stdin()
{
	char *status;

	tib_len = 0;
	while(!tib_len){
		prompt();
		status = gets(tib);
		if(!status){			// test for I/O error
			cout << "Read Error\n";
		}
		IN = 0;
		tabs_to_blanks(tib);		// basically ignore tabs
		tib_len = strlen(tib);
	}
	return(status);
}
/***********************+--------------+
|			| read_include |
|			+--------------+
*/
char *read_include()
{
	char *status;

	tib_len = 0;
	while(!tib_len){
		IN      = 0;
		tib[0]  = NULL;
		status  = fgets(tib,TIBSIZE,FD[this_file]);
		if(status){
			tabs_to_blanks(tib);	// basically ignore tabs
			tib_len = strlen(tib);
			if(tib_len){
				tib_len--;  	// try to trash the \n
				*(tib + tib_len) = 0;
			}
		}else{				// this is really EOF
			break;
		}
	}
	return(status);
}
/***********************+-------------+
|			| do_autoload |
|			+-------------+
|
*/
void do_autoload()
{
	IN = 0;
	this_file          = INPUT_SOURCE;
	FD[INPUT_SOURCE++] = fopen("calc.app","r");
	if(FD[this_file]){			// null means error
		READ_WA    = read_include;
	}else{
		cout << "calc.app not found. \n";
		INPUT_SOURCE--;			// reset input counter
	}
	tib_len  = 0;
	IN       = 0;
}
/***********************+---------------+
|			| close_include |
|			+---------------+
*/
void close_include()
{
	fclose(FD[--INPUT_SOURCE]);
		/*
		| Go back to stdin after all files are closed
		*/
	if(INPUT_SOURCE  <= 0){
		READ_WA   = read_stdin;
	}else{
		this_file = INPUT_SOURCE - 1;
	}
	IN      = 1;
	tib_len = 0;
}
