
/* Poor man's LAN file server.  Port settings:

     9600 baud, 
     no parity, 
     eight data bits, 
     two stop bits.
*/

#define PORT 0

#include "dos.h"
#include "stdio.h"

#include "conio.h"
#include "stdlib.h"
#include "ctype.h"

void send_file(int port);
void rec_file(int port);
void get_file_name(char *f, int port);
void wait(int port), sport(int port, char c);
void port_init(int port, unsigned char code);
int rport(int port), check_stat(int port);
long filesize(FILE *fp);

main(void)
{

  printf("File server in operation.\n");
  printf("To abort, press any key.\n\n");

  port_init(PORT, 231); /* initalize the serial port */

  do {
    /* wait until a request is received */
    if(check_stat(PORT)&256) { 
      switch(rport(PORT)) {
        case 's': send_file(PORT);
          printf("\nDone. File server waiting...\n\n");
          break;
        case 'r': rec_file(PORT);
          printf("\nDone. File server waiting...\n\n");
          break;
      }
    }

/***********************************
Add additional workstations by checking more ports
as shown here.
    if(check_stat(PORT1)&256) { 
      switch(rport(PORT1)) {
        case 's': send_file(PORT1);
          printf("\nDone. File server waiting...\n\n");
          break;
        case 'r': rec_file(PORT1);
          printf("\nDone. File server waiting...\n\n");
          break;
      }
    }
 .
 .
 .
    if(check_stat(PORTn)&256) { 
      switch(rport(PORTn)) {
        case 's': send_file(PORTn);
          printf("\nDone. File server waiting...\n\n");
          break;
        case 'r': rec_file(PORTn);
          printf("\nDone. File server waiting...\n\n");
          break;
      }
    }
********************************/
  } while(!kbhit());

  return 0;
}

/* Send the specified file. */
void send_file(int port)
{
  FILE *fp;  
  char ch, fname[128];
  int i;
  union {
    char c[sizeof(long)];
    long count;
  } cnt;

  sport(port, '.'); /* acknowledge */

  get_file_name(fname, port);

  if(!(fp=fopen(fname, "rb"))) {
    printf("Cannot open input file\n");
    exit(1);
  }

  /* find out the size of the file */
  cnt.count = filesize(fp);

  printf("Sending %s\n", fname);
  printf("File size: %ld\n", cnt.count);

  /* send size */
  for(i=0; i<sizeof(long); i++) {
    sport(port, cnt.c[i]);
    wait(port);
  }

  i = 0;
  do {
    ch = getc(fp);    
    if(ferror(fp)) {
      printf("Error reading input file.");
      break;
    } 
    
    /* wait until receiver is ready */ 
    if(!feof(fp)) {
      sport(port, ch);
      wait(port);
    }
    
    i++;
    if(i==1024) {
      printf(".");
      i = 0;
    }
  } while(!feof(fp));
  fclose(fp);
}

/* Receive a file. */
void rec_file(int port)
{
  FILE *fp;  
  char ch;
  char fname[14];
  unsigned i;
  union {
    char c[sizeof(long)];
    long count;
  } cnt;

  sport(port, '.'); /* acknowledge */

  get_file_name(fname, port); /* get the file name */

  printf("Receiving file %s\n", fname);

  if(!(fp=fopen(fname, "wb"))) {
    printf("Cannot open output file\n");
    exit(1);
  }

  /* get file length */
  for(i=0; i<sizeof(long); i++) {
    cnt.c[i] = rport(port);
    sport(port, '.'); /* acknowledge */
  }
    
  printf("File size: %ld\n", cnt.count);

  for(i=0; cnt.count; cnt.count--) {
    ch = rport(port);
    putc(ch, fp);
    if(ferror(fp)) {
      printf("Error writing file");
      exit(1);
    }
    sport(port, '.'); /* acknowledge */

    i++;
    if(i==1024) {
      printf(".");
      i = 0;
    }
  }
  fclose(fp);
}

/* Return the length, in bytes, of a file. */
long filesize(FILE *fp)
{
  unsigned i;

  fseek(fp, 0, SEEK_END);
  i = ftell(fp);
  rewind(fp);
  return i;
}

/* Receive the file name */
void get_file_name(char *f, int port)
{
  while(rport(port) != '?') ;
  sport(port, '.'); /* acknowledge */
  while((*f=rport(port))) {
    if(*f != '?') {
      f++;
      sport(port, '.'); /* acknowledge */
    }
  }
  sport(port, '.'); /* acknowledge */
}

/* Wait for a response. */
void wait(int port)
{
  if(rport(port) != '.') {
    printf("Communication error\n");
    exit(1);
  }
}

/* Send a character out the serial port. */
void sport(int port, /* i/o port */
           char c) /* character to send */
{
  union REGS r;

  r.x.dx = port; /* serial port */
  r.h.al = c; /* char to send */
  r.h.ah = 1;  /* send character function */
  int86(0x14, &r, &r);
  if(r.h.ah & 128) {
    printf("Send error detected in serial port");
    exit(1);
  }
}

/* Read a character from a port. */
rport(int port) /* i/o port */
{
  union REGS r;

  /* wait for a character */
  while(!(check_stat(port)&256)) 
    if(kbhit()) { /* abort on keypress */
      getch();
      exit(1);
    }

  r.x.dx = port; /* serial port */
  r.h.ah = 2;  /* read character function */
  int86(0x14, &r, &r);
  if(r.h.ah & 128) 
    printf("Read error detected in serial port");
  return r.h.al;
}

/* Check the status of the serial port. */
check_stat(int port) /* i/o port */
{
  union REGS r;

  r.x.dx = port; /* serial port */
  r.h.ah = 3;  /* read status */
  int86(0x14, &r, &r);
  return r.x.ax;
}

/* Initialize the port. */
void port_init(int port, unsigned char code)
{
  union REGS r;

  r.x.dx = port; /* serial port */
  r.h.ah = 0;  /* initialize port function */
  r.h.al = code; /* initialization code - see text for details */
  int86(0x14, &r, &r);
}



