
#include "stdio.h"
#include "stdlib.h"
#include "dos.h"

#define DELAY 5000
#define RATE 50

/*  
If you use Microsoft C, include these #defines:

#define inportb inp
#define outportb outp
*/

void laser(void);

main(void)
{
  laser();
  laser();
  laser();
  laser();
  laser();

  return 0;
}

/* Create a laser blast effect. */
void laser(void)
{
  unsigned freq;
  unsigned long i;

  union {
    long divisor;
    unsigned char c[2];
  } count;

  unsigned char p;

  p = inportb(97); /* get existing bit pattern */
  outportb(97, p | 3); /* turn on bits 0 and 1 */
  /* laser blast */
  for(freq = 3000; freq>1000; freq-=RATE) {
    count.divisor = 1193280 / freq;  /* compute the proper count */
    outportb(67, 182); /* tell 8253 that count is coming */
    outportb(66, count.c[0]); /* send low-order byte */
    outportb(66, count.c[1]); /* send high-order byte */

    for(i=0; i<DELAY; ++i) ; 
  }
  outportb(97, p); /* restore original bits to turn off speaker */
}

