/* ln30.c  <12-11-90>   <1-01-93>  TGR */
/* MAC port and mallocs <3-23-92>  Ken Moll */
/* DOS port and mallocs <1-08-93>  Ed Rojas */

 /***************************************************************************** 
 *
 * $Id: ln30.c,v 1.4 1993/03/10 22:32:32 rossin Exp $
 *
 * $Log:	ln30.c,v $
 * Revision 1.4  93/03/11  09:04:46  09:04:46  rossin (Ted Rossin)
 * Terminated global symbols read in that were exactly MAX_SYM-1 characters
 * long.  This caused undefined symbols to pop up every now and then based
 * on how RAM was the day you ran the linker.
 * 
 * Revision 1.3  1993/03/06  09:35:04  rossin
 * Fixed problem with symbols being MAX_SYM-1 long and fixed the warning
 * handlers.
 *
 * Revision 1.2  93/02/13  14:17:36  14:17:36  rossin (Ted Rossin)
 * DOS port done by Ed Rojas.
 * 
 * Revision 1.1  1993/01/09  10:55:44  rossin
 * Initial revision
 *
 *****************************************************************************/

/* #define DEBUG	1 */

#include "port.h"
#include <stdio.h>
#include <time.h>

#ifdef DOS
#  include <malloc.h>
#endif

#ifdef ATARI
#include <timeb.h>
#include <osbind.h>
#endif

#ifdef MAC
#include <stdlib.h>
#include <console.h>	
#include <string.h> 
#endif

#include "ln30.h"

#define MAX_SECTIONS		90
#define MAX_SECTIONS_PER_FILE	20
#define MAX_FILES		10
#define MAX_SEC_NAME		8
#define MAX_SECTION_IMAGE_SIZE	16000
#define MAX_STRING_SPACE	8190

#define MAX_REL_ENTRIES		1000
#define MAX_GLOB_REL_ENTRIES	1000
#define MAX_SYM_ENTRIES		200
#define MAX_GLOB_SYM_ENTRIES	300

#ifdef UNIX
#define MALLOC	malloc
#define SORT	qsort		/* Uses lots of stack */
#endif

#ifdef DOS
#define MALLOC	malloc
#define SORT	qsort		/* Uses lots of stack */
#endif

#ifdef MAC
#define MALLOC	malloc
#define SORT	qsort		/* Uses lots of stack */
#endif

#ifdef ATARI
#define MALLOC	Malloc
#define SORT	shellsort	/* Uses a little bit of the stack */
#endif

Section_Header *section_header[MAX_FILES];
File_Header *file_header;
unsigned long *section_image;
Global_Rel_Tab *global_rel_tab;
Global_Sym_Tab *global_sym_tab;
Rel_Entry *rel_tab;
Sym_Tab_Entry *sym_tab;
char *string_tab;

static File_Header out_file_header;
static Section_Header out_section_header;
static Rel_Entry rel_entry;
static Sym_Tab_Entry sym_tab_entry;

static unsigned long sec_img_ptr;
static unsigned long rel_ptr,glob_rel_ptr;
static unsigned long sym_ptr,glob_sym_ptr;
static unsigned char glob_load[MAX_FILES];

static struct{
    unsigned long   size;
    unsigned long   address;
    unsigned long   next_address;
    unsigned long   next_address2;
    unsigned long   load_address;
    unsigned long   raw_pointer;
    unsigned short  type;
    char	    name[9];
    char 	    flag;
} sec_tab[MAX_SECTIONS];


static int current_string_tab;

static FILE *fpin[MAX_FILES];
static int argv_index[MAX_FILES];
static char outname[100]={"a.out"};
static char mapname[100];
int num_errors=0,num_warnings=0;

main(argc,argv)
int argc;
char *argv[];
{
    int i,j,k,file,sec_tab_ptr,found,num_file_headers,line,exit_status, cnt;
    unsigned long lc,address,max_lc=0,low,high,old_image_ptr,raw_ptr,raw_word;
    unsigned long load_address;
    unsigned long load_low,load_high;
    FILE *fpcmd,*outfp;
    char s[100],sec_name[10],bind;
    unsigned long msize;
    int compare(),quiet_mode=0;
    time_t nseconds;
    char *ctime(),start_time[40];

    msize=(unsigned long)MAX_SECTIONS_PER_FILE*(long)sizeof(Section_Header);
    for(cnt=0; cnt<MAX_FILES; cnt++){
	if( (section_header[cnt] = (Section_Header *)MALLOC(msize) ) == NULL){
	    printf("1. Memory allocation problem.\n"); exit(1);  
	} 
    }
    msize=(unsigned long)MAX_FILES*(long)sizeof(File_Header);
    if((file_header=(File_Header *)MALLOC(msize) ) == NULL){
	printf("2. Memory allocation problem.\n"); exit(1);  
    }
    msize=(unsigned long)MAX_SECTION_IMAGE_SIZE*(long)sizeof(unsigned long);
    if((section_image = (unsigned long *)MALLOC(msize) ) == NULL){
	printf("3. Memory allocation problem.\n"); exit(1);  
    }
    msize=(unsigned long)MAX_GLOB_REL_ENTRIES*(long)sizeof(Global_Rel_Tab);
    if((global_rel_tab = (Global_Rel_Tab *)MALLOC(msize) ) == NULL){
	printf("4. Memory allocation problem.\n"); exit(1);  
    }
    msize=(unsigned long)MAX_GLOB_SYM_ENTRIES*(long)sizeof(Global_Sym_Tab);
    if((global_sym_tab = (Global_Sym_Tab *)MALLOC(msize) ) == NULL){
	printf("5. Memory allocation problem.\n"); exit(1);  
    }
    msize=(unsigned long)MAX_REL_ENTRIES*(long)sizeof(Rel_Entry);
    if((rel_tab = (Rel_Entry *)MALLOC(msize) ) == NULL){
	printf("6. Memory allocation problem.\n"); exit(1);  
    }
    msize=(unsigned long)MAX_SYM_ENTRIES*(long)sizeof(Sym_Tab_Entry);
    if((sym_tab = (Sym_Tab_Entry *)MALLOC(msize) ) == NULL){
	printf("7. Memory allocation problem.\n"); exit(1);  
    }
    msize=(unsigned long)MAX_STRING_SPACE*(long)sizeof(char);
    if((string_tab = (char *)MALLOC(msize) ) == NULL){
	printf("8. Memory allocation problem.\n"); exit(1);  
    }

#ifdef MAC
    argc = ccommand(&argv);
#endif

    if(argc<2){
	usage();
	exit(1);
    }
    
    sec_tab_ptr=num_file_headers=0;
    rel_ptr=glob_rel_ptr=0;
    sym_ptr=glob_sym_ptr=0;
    current_string_tab = -1;
    for(i=0;i<MAX_FILES;glob_load[i++]=0);
    fpcmd=NULL;
    mapname[0]=0;

	/* Determine files that are specified */

    time(&nseconds); 				/* Get time of the day */
    strcpy(start_time,ctime(&nseconds));	/* Turn into string    */

    for(i=1;i<argc;i++){
	if(argv[i][0]=='-'){
	  switch(argv[i][1]){
	    case 'q': /* No banner */
		if(argv[i][2]!=0){
		    printf("Unrecognized option: %s\n",argv[i]);
		    exit(1);
		}
		quiet_mode=1;
		break;
	    case 'o': /* Output file name */
		if(argv[i][2]!=0){
		    printf("Unrecognized option: %s\n",argv[i]);
		    exit(1);
		}
		if(i+1 >= argc){
		    printf("No output file specified after -o\n");
		    exit(1);
	 	}
		if(strlen(argv[i+1]) > 99){
		    printf("Output File name is too damn long (max len=99)\n");
		    exit(1);
	 	}
		strcpy(outname,argv[i+1]);
		i++;
		break;
	    case 'm': /* Map file name */
		if(argv[i][2]!=0){
		    printf("Unrecognized option: %s\n",argv[i]);
		    exit(1);
		}
		if(i+1 >= argc){
		    printf("No map file specified after -m\n");
		    exit(1);
	 	}
		if(strlen(argv[i+1]) > 99){
		    printf("Map file name is too damn long (max len=99)\n");
		    exit(1);
	 	}
		strcpy(mapname,argv[i+1]);
		i++;
		break;
	    default:
		usage();
		exit(1);
	  }
	}
	else{
   	  if( (fpin[num_file_headers]=fopen(argv[i],"rb"))==NULL){
	    printf("Can't open %s for read\n",argv[i]);
	    exit(1);
    	  }
	  argv_index[num_file_headers]=i;
    	  fread(&file_header[num_file_headers],sizeof(out_file_header),1
		,fpin[num_file_headers]);
    	  if(file_header[num_file_headers].magic != 0x0093){ /* command file */
	      fclose(fpin[num_file_headers]);
	      if( (fpcmd=fopen(argv[i],"r"))==NULL){
	    	  printf("Can't open %s for read\n",argv[i]);
	    	  exit(1);
    	      }
	      num_file_headers--;  /* don't count as a file header */
    	  }
 	  num_file_headers++;
	  if(num_file_headers>=MAX_FILES){
	    printf("Too many files.  Must have less than %d files\n",MAX_FILES);
	    exit(1);
	  }
	}
    }

    if(!quiet_mode){
        printf("\n");
    	print_heading(stdout,start_time);
    }

	/* check file headers and read in section headers */

    for(i=0;i<num_file_headers;i++){
    	if(file_header[i].num_sec>=MAX_SECTIONS_PER_FILE){
	    printf("File %s has too many sections (%d is max)\n"
		,argv[argv_index[i]],MAX_SECTIONS_PER_FILE);
	    exit(1);
	}
    	for(j=0;j<file_header[i].num_sec;j++){
	    if(fread(&section_header[i][j],sizeof(section_header[0][0])
		,1,fpin[i]) != 1){
		printf("Error reading section header from file %s\n"
		   ,argv[argv_index[i]]);
		printf("\n%d Errors  %d Warnings\n",1,num_warnings);
		exit(1);
	    }
	}
    }	

      /* Now that all the section headers are known construct a section table */

    for(file=0;file<num_file_headers;file++){
    	for(i=0;i<file_header[file].num_sec;i++){
	    for(j=found=0;j<sec_tab_ptr;j++){
		if(!strncmp(sec_tab[j].name,section_header[file][i].name,8)){ 
		    found=1; break;
		}
	    }
	    if(found){  /* Add section size to section in list */
		sec_tab[j].size += section_header[file][i].size;
	    }
	    else{	/* Add section name to section list */
		strcpy(sec_tab[sec_tab_ptr].name,section_header[file][i].name);
		sec_tab[sec_tab_ptr].size=section_header[file][i].size;
		sec_tab[sec_tab_ptr].flag=0;
		sec_tab[sec_tab_ptr].type=section_header[file][i].flags;
		if(++sec_tab_ptr >= MAX_SECTIONS){
		   printf("Too many total sections (%d is max)\n",MAX_SECTIONS);
		   exit(1);
	 	}
	    }
	}
    }

	/* Determine Physical Addresses */

    if(fpcmd==NULL){  /* use default allocation */
	printf(
	    "Warning: Using default allocation since no command file found\n");
	num_warnings++;
	lc=0;
	for(i=0;i<sec_tab_ptr;i++){
	    sec_tab[i].address=lc;
	    lc += sec_tab[i].size;
	    sec_tab[i].flag=1;  /* Address assigned */
	}
	max_lc=lc-1;
    }
    else{  /* Read in addresses of sections */
	lc=max_lc=0;
	for(line=1;fgets(s,100,fpcmd)!=NULL;line++){
	    if(parse_command_string(line,s,sec_name,&address,&load_address
								      ,&bind)){
	     	for(i=found=0;i<sec_tab_ptr;i++){
		    if(!strcmp(sec_name,sec_tab[i].name)){  /* found */
			switch(bind){
			    case 0:
			    	sec_tab[i].address=lc;
				sec_tab[i].load_address=lc;
			    	lc=lc+sec_tab[i].size;
				break;
			    case 1: 
			    	sec_tab[i].address=address;
				sec_tab[i].load_address=address;
			    	lc=address+sec_tab[i].size;
				break;
			    case 2:
			    	sec_tab[i].address=address;
				sec_tab[i].load_address=load_address;
			    	lc=load_address+sec_tab[i].size;
				break;
			    case 3:
			    	sec_tab[i].address=address;
				sec_tab[i].load_address=lc;
			    	lc+=sec_tab[i].size;
				break;
			}
			if(lc>max_lc) max_lc=lc;
			sec_tab[i].flag=1;  /* Address assigned */
			found=1;
			break;
		    }
		}
		if(!found){
		   printf("Warning: Section %s is specified in the command file"
			,sec_name);
		   printf(" but is not found\n         in the object files\n");
		   num_warnings++;
		}
	    }
	}
 	max_lc--;
	fclose(fpcmd);

		/* Make sure all sections assigned */

    	for(i=0;i<sec_tab_ptr;i++){  
	    if(!sec_tab[i].flag){
		printf("Warning: Physical address of section %s not specified"
				,sec_tab[i].name);
		printf(" in the command file.\n");
		printf("         Placing section %s at address 0x%08lx\n"
			,sec_tab[i].name,max_lc+1);
		num_warnings++;
		sec_tab[i].address=max_lc+1;
		sec_tab[i].flag=1;
		max_lc += sec_tab[i].size;
	    }
    	}

		/* Make sure that sections don't overlap */

    	for(i=0;i<sec_tab_ptr;i++){
	    low=sec_tab[i].address;  
	    high=low+sec_tab[i].size-1;
	    load_low=sec_tab[i].load_address;  
	    load_high=load_low+sec_tab[i].size-1;

	    for(j=0;j<sec_tab_ptr;j++){
		if(j!=i){
		    if(sec_tab[j].address>=low && sec_tab[j].address<=high
					       && sec_tab[j].size>0        ){
			printf("Error: Section \"%s\" run space is too large "
			    ,sec_tab[i].name);
			printf("and overlaps into section\n");
			printf("       \"%s\" run space.\n"
			    ,sec_tab[j].name);
			printf("\n%d Errors  %d Warnings\n",1,num_warnings);
			exit(1);
		    }

		    if(    sec_tab[j].load_address>=load_low 
			&& sec_tab[j].load_address<=load_high 
			&& sec_tab[j].size>0){
			printf("Error: Section \"%s\" load space is too large "
			    ,sec_tab[i].name);
			printf("and overlaps into section\n");
			printf("       \"%s\" load space.\n",sec_tab[j].name);
			printf("\n%d Errors  %d Warnings\n",1,num_warnings);
			exit(1);
		    }
		    if(    sec_tab[j].address>=load_low 
			&& sec_tab[j].address<=load_high
		 	&& sec_tab[j].size>0){
			printf(
			   "Warning: Section \"%s\" load space is too large "
			    ,sec_tab[i].name);
			printf("and overlaps into section\n");
			printf("         \"%s\" run space\n"
			    ,sec_tab[j].name);
			printf(
		        "         Generate a map file (-m) and take a look.\n");
			num_warnings++;
		    }
		    if(    sec_tab[j].load_address>=low 
			&& sec_tab[j].load_address<=high
		 	&& sec_tab[j].size>0){
			printf(
			    "Warning: Section \"%s\" run space is too large "
			    ,sec_tab[i].name);
			printf("and overlaps into section\n");
			printf("         \"%s\" load space\n"
			    ,sec_tab[j].name);
			printf(
		        "         Generate a map file (-m) and take a look.\n");
			num_warnings++;
		    }
		}
	    } 
	} 
    }

	/* update section headers with physical addresses of sections */

    for(i=0;i<sec_tab_ptr;i++){
	 sec_tab[i].next_address=sec_tab[i].address;
	 sec_tab[i].next_address2=sec_tab[i].load_address;
    }
    for(j=0;j<num_file_headers;j++){  /* for each object file */
	for(k=0;k<file_header[j].num_sec;k++){ /* for each section in file */
	    for(i=0;i<sec_tab_ptr;i++){
		if(!strncmp(sec_tab[i].name,section_header[j][k].name,8) ){
		    section_header[j][k].virtual_address
						= sec_tab[i].next_address;
		    sec_tab[i].next_address += section_header[j][k].size;
		    section_header[j][k].physical_address
						= sec_tab[i].next_address2;
		    sec_tab[i].next_address2 += section_header[j][k].size;
		    break;
		}
	    }		
	}
    }
	
	/* Open up output file */

    if( (outfp=fopen(outname,"w+b"))==NULL){
	printf("Can't open output file %s for write\n",outname);
	exit(1);
    }

	/* Write out file header */

    out_file_header.magic=0x0093;
    out_file_header.num_sec=sec_tab_ptr;
    out_file_header.time=0;
    out_file_header.sym_tab_start=0;
    out_file_header.sym_tab_len=0;
    out_file_header.opt_head_size=0;
    out_file_header.flags = F_RELFLG|F_EXEC|F_LNNO|F_LSYMS;

    if(fwrite(&out_file_header,sizeof(out_file_header),1,outfp) != 1){
	printf("Write error writing output file\n");
	exit(1);
    }

	/* Write out section headers */

    raw_ptr=ftell(outfp)
		    + (unsigned long)(sizeof(out_section_header)*sec_tab_ptr);
    for(i=0;i<sec_tab_ptr;i++){
	strcpy(out_section_header.name,sec_tab[i].name);
	out_section_header.physical_address=sec_tab[i].load_address;
	out_section_header.size=sec_tab[i].size;
 	out_section_header.virtual_address=sec_tab[i].address;  /* Run address*/
 	out_section_header.relocation_pointer=0;
 	out_section_header.line_num_pointer=0;
 	out_section_header.num_relocation_entries=0;
 	out_section_header.num_line_num_entries=0;
 	out_section_header.flags=sec_tab[i].type;
 	out_section_header.reserved=0;
 	out_section_header.memory_page_number=0;

	if(out_section_header.flags!=STYP_BSS){
 	    out_section_header.raw_data_pointer=raw_ptr;
	    raw_ptr += (4*sec_tab[i].size);
	}
	else
 	    out_section_header.raw_data_pointer=0;

    	if(fwrite(&out_section_header,sizeof(out_section_header),1,outfp) != 1){
	    printf("Write error writing output file\n");
	    exit(1);
    	}
    }

	/* Get Image data for each section and relocate sections */

    for(i=0;i<sec_tab_ptr;i++){	/* for each section */
      sec_tab[i].raw_pointer=0;
      if(sec_tab[i].type != STYP_BSS){
	sec_img_ptr=0;
	for(j=0;j<num_file_headers;j++){  /* for each object file */
	    sym_ptr=0;
	    load_symbol_table(j,argv);
	    for(k=0;k<file_header[j].num_sec;k++){ /* for each section in file*/
		if(!strncmp(sec_tab[i].name,section_header[j][k].name,8) ){
		    old_image_ptr=sec_img_ptr;
		    load_image_section(i,j,k,argv);
		    load_relocation_table(old_image_ptr,j,k,i,argv);
		    break;  /* Only one section type per file */
		}
	    }
	}
	if(sec_img_ptr != sec_tab[i].size){
	    printf("Data missing from section %s should have %ld words but"
		,sec_tab[i].name,sec_tab[i].size);
	    printf(" only read in %ld words\n",sec_img_ptr);
	    exit(1);
	}
		/* Write out section */

	sec_tab[i].raw_pointer=ftell(outfp);
    	if( fwrite(section_image,sizeof(section_image[0])
		,(int)sec_img_ptr,outfp)     != (int)sec_img_ptr){
	    printf("Write error writing output file\n");
	    exit(1);
    	}
      }
    }

	/* Perform Global Relocations directly into output file */

#ifdef DEBUG
    for(i=0;i<glob_sym_ptr;i++){
        printf("i=%d\n",i);
    	printf("Symbol ->%s<- value: 0x%08lx\n",global_sym_tab[i].symbol
	    ,global_sym_tab[i].value);
    }
    for(i=0;i<glob_rel_ptr;i++){
	printf("section %d flags 0x%02x offset 0x%08lx symbol ->%s<-\n"
	    ,global_rel_tab[i].section,global_rel_tab[i].flags
	    ,global_rel_tab[i].offset,global_rel_tab[i].symbol);
    }
#endif

    exit_status=0;
    for(i=0;i<glob_rel_ptr;i++){
	found=0;
	for(j=0;j<glob_sym_ptr;j++){
	    if(!strcmp(global_sym_tab[j].symbol,global_rel_tab[i].symbol)){
		address=sec_tab[global_rel_tab[i].section].raw_pointer;
		address += 4*global_rel_tab[i].offset;
    		if(fseek(outfp,address,0)){
		    printf("Seek error to raw data output file\n");
		    exit(1);
    		}
    		if(fread(&raw_word,sizeof(raw_word),1,outfp) != 1){
		    printf("Error reading output file for relocation\n");
		    printf("\n%d Errors  %d Warnings\n",1,num_warnings);
		    exit(1);
    		}
		relocate_word(global_rel_tab[i].flags,global_sym_tab[j].value
		    ,global_rel_tab[i].offset
			+ sec_tab[global_rel_tab[i].section].address
		    ,&raw_word);

		   /* Write relocated word back to output file */

    		if(fseek(outfp,address,0)){
		    printf("Seek error to raw data output file\n");
		    exit(1);
    		}
    		if(fwrite(&raw_word,sizeof(raw_word),1,outfp) != 1){
		    printf("Error writing output file for relocation\n");
		    printf("\n%d Errors  %d Warnings\n",1,num_warnings);
		    exit(1);
    		}
		found=1;
		break;
	    }
	}
	if(!found){
	    if(exit_status == 0) printf("Unresolved Externals:\n");
	    printf("  ->%s<-\n",global_rel_tab[i].symbol);
	    exit_status = 1;  num_errors++;
	}
    }
    fclose(outfp);

	/* Print out map */

    if(mapname[0]){
   	if( (outfp=fopen(mapname,"w"))==NULL){
	    printf("Can't open map file %s for write\n",argv[i]);
	    exit(1);
	}
	print_heading(outfp,start_time);
	fprintf(outfp,"Memory Configuration\n\n");
    	fprintf(outfp,
	  "  Section  Run Address  Load Address  Size(hex)   Size(decimal)\n");
	fprintf(outfp,
	  "---------------------------------------------------------------\n");
    	for(i=0;i<sec_tab_ptr;i++){
	    fprintf(outfp,"%9s  0x%08lx    0x%08lx   0x%08lx   %08ld\n"
		,sec_tab[i].name,sec_tab[i].address
		,sec_tab[i].load_address,sec_tab[i].size,sec_tab[i].size);
    	}
	SORT((char *)global_sym_tab,glob_sym_ptr
				,sizeof(global_sym_tab[0]),compare);
	fprintf(outfp,"\n\nGlobal Symbol Table\n\n");
	fprintf(outfp,"  Name              Value");
	fprintf(outfp,"                Name              Value\n");
	fprintf(outfp,
	"------------------------------------------------------------------\n");
	for(j=0;j<glob_sym_ptr/2;j++){
	    fprintf(outfp,"  %-16s 0x%08lx          %-16s 0x%08lx\n"
            	,global_sym_tab[j*2].symbol,global_sym_tab[j*2].value
            	,global_sym_tab[j*2+1].symbol,global_sym_tab[j*2+1].value);
	}
    	if(glob_sym_ptr & 1){ /* print odd entry */
	    fprintf(outfp,"  %-16s 0x%08lx\n"
		,global_sym_tab[glob_sym_ptr-1].symbol
		,global_sym_tab[glob_sym_ptr-1].value);
    	}
	fprintf(outfp,"\n[%ld symbols]\n",glob_sym_ptr);
	fclose(outfp);
    }

    printf("\n%d Errors  %d Warnings\n",num_errors,num_warnings);
    exit(exit_status);
}

int compare(s1,s2)
char *s1,*s2;
{
    int strcmp();
    return(strcmp(s1,s2));
}


relocate_word(type,value,address,word)
unsigned short type;
unsigned long value,address,*word;
{
    unsigned long tmp_word;

    tmp_word = *word;
#ifdef DEBUG
    printf("  type: 0x%02x  value: 0x%08lx  address: 0x%08lx  word: 0x%08lx\n"
	,type,value,address,tmp_word);
#endif
    switch(type){
	case R_PCRWORD:	/* 16-bit PC relative */
	    tmp_word +=	((value-address-1L) & 0x0000FFFFL);
	    break;
	case R_PCRDWORD: /* 16-bit PC relative delayed */
	    tmp_word +=	((value-address-3L) & 0x0000FFFFL);
	    break;
	case R_RELWORD:  /* 16-bit direct reference to symbol's address */
	    tmp_word +=	(value & 0x0000FFFFL);
	    break;
	case R_RELPAGE: /* Direct page pointer */
	    tmp_word += (value>>16);
	    break;
	case R_REL24:   /* 24-bit direct reference to symbol's address */
	    tmp_word += (value & 0x00FFFFFFL);
	    break;
	case R_RELLONG: /* 32-bit direct reference to symbol's address */
	    tmp_word = value;
	    break;
	default:
	    printf("Can't do global relocation of type 0x%02x\n",type);
	    exit(1);
	    break;
   }	
   *word = tmp_word;
}

load_relocation_table(image_offset,file_index,section_index,section,argv)
unsigned long image_offset;
int file_index,section_index,section;
char *argv[];
{
    unsigned long i,num_rel,tab_ptr;
    unsigned long sym_tab_index,image_index,tmp;

    num_rel=section_header[file_index][section_index].num_relocation_entries;
#ifdef DEBUG
    printf("%s section %s: start address=0x%08lx %ld relocation entries\n"
	,argv[argv_index[file_index]]
	,section_header[file_index][section_index].name
	,section_header[file_index][section_index].virtual_address,num_rel);
#endif
    if(rel_ptr+num_rel >= MAX_REL_ENTRIES){
	printf("Relocation table overflow\n");
	exit(1);
    }
    tab_ptr=section_header[file_index][section_index].relocation_pointer;
    if(fseek(fpin[file_index],tab_ptr,0)){
	printf("Seek error to relocation table in file %s\n"
	    ,argv[argv_index[file_index]]);
	exit(1);
    }
    if(fread(&rel_tab[rel_ptr],sizeof(rel_tab[0]),(int)num_rel
		,fpin[file_index]) != (int)num_rel){
	printf("Error reading relocation table in file %s\n"
	    ,argv[argv_index[file_index]]);
	printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	exit(1);
    }
#ifdef DEBUG
    for(i=0;i<num_rel;i++){
	printf("offset=0x%08lx index=%d type=0x%04x\n",rel_tab[i].address
	   ,rel_tab[i].sym_index,rel_tab[i].type);
    }   
#endif
	/* try to perfrom relocations */

    for(i=0;i<num_rel;i++){
	sym_tab_index=rel_tab[i].sym_index;
	image_index=rel_tab[i].address+image_offset;
	if(   sym_tab[sym_tab_index].class == C_NULL 
	   || sym_tab[sym_tab_index].class == C_EXTDEF
	   || sym_tab[sym_tab_index].class == C_EXTLAB
	   || sym_tab[sym_tab_index].class == C_STATLAB){ /* update image */
	    switch(rel_tab[i].type){
		case R_SECREL32:
	    	    section_image[image_index] += sym_tab[sym_tab_index].value;
		    break;
		case R_SECREL24:
	    	    tmp = section_image[image_index];
		    tmp =    (tmp&0xFF000000L) 
			  |
			     ((  (tmp&0x00FFFFFFL) 
			       + (sym_tab[sym_tab_index].value & 0x00FFFFFFL)
			      )&0x00FFFFFFL);
	    	    section_image[image_index] = tmp;
		    break;
		case R_SECREL16:
	    	    tmp = section_image[image_index];
		    tmp =    (tmp&0xFFFF0000L) 
			  |
			     ((  (tmp&0x0000FFFFL) 
			       + (sym_tab[sym_tab_index].value & 0x0000FFFFL)
			      )&0x0000FFFFL);
	    	    section_image[image_index] = tmp;
		    break;
		case R_RELPAGE:
	    	    tmp = section_image[image_index]&0xFFFF0000L;
		    tmp |= (sym_tab[sym_tab_index].value>>16);
	    	    section_image[image_index]=tmp;
		    break;
		case R_RELWORD:/* 16-bit direct reference to symbol's address */
		    tmp =   (section_image[image_index]&0xFFFF0000L) 
			  | (sym_tab[sym_tab_index].value & 0x0000FFFFL);
	    	    section_image[image_index] = tmp;
	    	    break;
		case R_REL24: /* 24-bit direct reference to symbol's address */
		    tmp =   (section_image[image_index]&0xFF000000L) 
			  | (sym_tab[sym_tab_index].value & 0x00FFFFFFL);
	    	    section_image[image_index] = tmp;
		    break;
		case R_RELLONG:/* 32-bit direct reference to symbol's address */
	    	    section_image[image_index]=sym_tab[sym_tab_index].value;
	    	    break;
		default:
		    printf("Relocation entry in %s has invalid type 0x%04x\n"
	    		,argv[argv_index[file_index]],rel_tab[i].type);
		    exit(1);
	    }
	}
	else{	/* Add relocation entry to global relocation table */
	   global_rel_tab[glob_rel_ptr].section=section;
	   global_rel_tab[glob_rel_ptr].flags=rel_tab[i].type;
	   global_rel_tab[glob_rel_ptr].offset=rel_tab[i].address+image_offset;
	   get_symbol(rel_tab[i].sym_index,file_index,argv
		,global_rel_tab[glob_rel_ptr].symbol);
	   if(++glob_rel_ptr >= MAX_GLOB_REL_ENTRIES){
	 	printf("Too many global relocation entries(max is %d)\n"
		    ,MAX_GLOB_REL_ENTRIES);
		exit(1);
	   }
	}
    }
}

get_symbol(index,file_index,argv,symbol)
unsigned short index;
int file_index; 
char *symbol,*argv[];
{
    unsigned long tab_ptr,size;

    if(file_index != current_string_tab){ /* Load in string table */
    	tab_ptr = file_header[file_index].sym_tab_start;
    	tab_ptr += file_header[file_index].sym_tab_len*sizeof(sym_tab_entry);
    	if(fseek(fpin[file_index],tab_ptr,0)){
	    printf("Seek error to symbol table in file %s\n"
	    	,argv[argv_index[file_index]]);
 	    exit(1);
    	}
   	if(fread(&size,sizeof(size),1,fpin[file_index]) != 1){
	    printf("Error reading symbol table string size in file %s\n"
	    	,argv[argv_index[file_index]]);
	    printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	    exit(1);
    	}
 	if(size >= MAX_STRING_SPACE){
	    printf("Can't load in string table for file %s not enough space\n"
	    	,argv[argv_index[file_index]]);
	    exit(1);
    	}
   	if(fread(&string_tab[4],sizeof(char),(unsigned int)size
		,fpin[file_index]) != (unsigned int)size){
	    printf("Error reading symbol string table in file %s\n"
	    	,argv[argv_index[file_index]]);
	    printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	    exit(1);
    	}
    	current_string_tab = file_index;
    }
    strncpy(symbol,&string_tab[sym_tab[index].string_offset],MAX_SYM-1);
    symbol[MAX_SYM-1]=0;
}

load_symbol_table(file_index,argv)
int file_index;
char *argv[];
{
    unsigned long i,sym_tab_len,tab_ptr,string_tab;
    char string[MAX_SYM];

    sym_tab_len=file_header[file_index].sym_tab_len;
    tab_ptr=file_header[file_index].sym_tab_start;
#ifdef DEBUG
    printf("%ld symbol table entries in file %s\n"
	,sym_tab_len,argv[argv_index[file_index]]);
#endif
    if(fseek(fpin[file_index],tab_ptr,0)){
	printf("Seek error to symbol table in file %s\n"
	    ,argv[argv_index[file_index]]);
	exit(1);
    }
    if(fread(&sym_tab[sym_ptr],sizeof(sym_tab[0]),(int)sym_tab_len
		,fpin[file_index]) != (int)sym_tab_len){
	printf("Error reading symbol table in file %s\n"
	    ,argv[argv_index[file_index]]);
	printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	exit(1);
    }
    sym_ptr += sym_tab_len; 
    string_tab=ftell(fpin[file_index]);

		/* update symbol's values */

    for(i=0;i<sym_ptr;i++){
	if(sym_tab[i].section>MAX_SECTIONS){
	    printf(
		"symbol table entry %d of %s has invalid section number of %d\n"
		    ,i,argv[argv_index[file_index]],sym_tab[i].section);
	    exit(1);
	}
	if(sym_tab[i].class==C_NULL || sym_tab[i].class==C_EXTDEF){
	    sym_tab[i].value +=
	  	section_header[file_index][sym_tab[i].section].virtual_address;
	}
	if(sym_tab[i].class==C_STATLAB || sym_tab[i].class==C_EXTLAB){
	    sym_tab[i].value +=
	  	section_header[file_index][sym_tab[i].section].physical_address;
#ifdef DEBUG 
	    printf("C_STATLAB symbol found: value =0x%08lx\n",sym_tab[i].value);
	    printf("physical address of section %d is 0x%08lx\n"
		,sym_tab[i].section
	      ,section_header[file_index][sym_tab[i].section].physical_address);
#endif
	} 
    }

#ifdef DEBUG  
    for(i=0;i<sym_ptr;i++){
	printf("s_tab_offset=0x%08lx value=0x%08lx section=%d class=0x%04x\n"
	    ,sym_tab[i].string_offset,sym_tab[i].value,sym_tab[i].section
	    ,sym_tab[i].class);
	if(sym_tab[i].class != C_NULL){
	    string[0]=0;
    	    fseek(fpin[file_index],sym_tab[i].string_offset+string_tab,0);
	    fread(string,sizeof(char),20,fpin[file_index]);
	    printf("Symbol is ->%s<-\n",string);
	}
    }   
#endif
  	/* load globals into global symbol table if it has not been done */

    if(!glob_load[file_index]){
    	for(i=0;i<sym_ptr;i++){
	    if(sym_tab[i].class==C_EXTDEF || sym_tab[i].class==C_EXTLAB){
	    	string[0]=0;
    	    	fseek(fpin[file_index],sym_tab[i].string_offset+string_tab,0);
	    	fread(string,sizeof(char),MAX_SYM-1,fpin[file_index]);
		strncpy(global_sym_tab[glob_sym_ptr].symbol,string,MAX_SYM-1);
		global_sym_tab[glob_sym_ptr].symbol[MAX_SYM-1]=0;
		global_sym_tab[glob_sym_ptr].value=sym_tab[i].value;
		if(++glob_sym_ptr>=MAX_GLOB_SYM_ENTRIES){
		    printf("Global symbol table overflow\n");
		    exit(1);
		}
	    }
	}
	glob_load[file_index]=1;
    }
}

load_image_section(sec_tab_index,file_index,section_index,argv)
int sec_tab_index,file_index,section_index;
char *argv[];
{
    unsigned long size;

	/* Get to section raw data */

    if(  fseek(fpin[file_index]
	 ,section_header[file_index][section_index].raw_data_pointer,0) ){
	    printf("fseek error in file %s\n",argv[argv_index[file_index]]);
	    exit(1);
    }
    size=section_header[file_index][section_index].size;
    if(size == 0L) return;
    if( (sec_img_ptr+size) > MAX_SECTION_IMAGE_SIZE){
	printf("Internal section image table overflow\n");
	exit(1);
    }
    if(fread(&section_image[sec_img_ptr],sizeof(size),(int)size
	,fpin[file_index]) != (int)size){
	    printf("Error reading raw data for section %s in file %s\n"
	    	,sec_tab[sec_tab_index].name,argv[argv_index[file_index]]);
	    printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	    exit(1);
    }
    sec_img_ptr += size;
}

usage()
{
 printf("Usage: ln30 [options] [command_file] object_file1 object_file2 ...\n");
 printf("options:\n  -o output_filename\n  -m map_filename\n");
}

parse_command_string(line,s,sec_name,address,load_address,bind)
char s[],*sec_name,*bind;
unsigned long *address,*load_address;
int line;
{
    register int index=0,i;
    char astring[20],*sec_save=sec_name,*sptr=astring;

    sec_name[0]=0; *address=0; *bind=0;
    while(s[index] && (s[index]==' ' || s[index]=='\t')) index++;
    if(s[index]=='\n' || s[index]==0 || s[index]==';' || s[index]=='#'
						      || s[index]=='*') 
	return(0);  /* blank or comment */
    for(i=0; i<MAX_SEC_NAME && s[index]!='\t' && s[index]!=' ' 
			&& s[index]!='\n' && s[index]; i++){
	    *sec_name++ = s[index++];
    }
    *sec_name=0;
    if(i > MAX_SEC_NAME){
	printf(
	   "Warning: Truncated section name on line %d of command file to %s\n"
		,line,sec_save);
	num_warnings++;
    }
    while(s[index] && (s[index]==' ' || s[index]=='\t')) index++;
    if(s[index]=='\n' || s[index]==0 || s[index]==';'){/* No address binding */
	*bind=0;
	return(1);
    }
    for(i=0; i<20 && s[index]!='\t' && s[index]!=' ' 
			&& s[index]!='\n' && s[index]; i++){
	    *sptr++ = s[index++];
    }
    *sptr=0;
    if(i>=20){
	printf("Error: Address constant too long on line %d of command file\n"
		,line);
	printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	exit(1);
    }
    *bind=1;
    if(get_const32(astring,address)){
	printf("Error: Invalid address constant on line %d of command file\n"
		,line);
	printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	exit(1);
    }

	/* Look for optional load address (allow different load and run addr */

    while(s[index] && (s[index]==' ' || s[index]=='\t')) index++;
    if(s[index]=='\n' || s[index]==0 || s[index]==';'){/* No load address */
	return(1);
    }
    sptr=astring;
    for(i=0; i<20 && s[index]!='\t' && s[index]!=' ' 
			&& s[index]!='\n' && s[index]; i++){
	    *sptr++ = s[index++];
    }
    *sptr=0;
    if(i>=20){
	printf("Error: Load address value too long on line %d of command file\n"
		,line);
	printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	exit(1);
    }
    *bind=2;
    if(astring[0] == '.'){ /* use next available space */
	*bind=3;
	return(1);
    }
    if(get_const32(astring,load_address)){
	printf("Error: Invalid address constant on line %d of command file\n"
		,line);
	printf("\n%d Errors  %d Warnings\n",1,num_warnings);
	exit(1);
    }
    return(1);
}

get_const32(string,value)
char string[];
unsigned long *value;
{
    char c,*ptr=string;
    int i,len,type;
    unsigned long work;

    work=0L;  type=2;
    len=strlen(string);
    if(string[len-1]=='B' || string[len-1]=='b')
    	{type=0; string[len-1]=0; len--;} 
    else if(string[len-1]=='Q' || string[len-1]=='q')
	{type=1; string[len-1]=0; len--;} 
    else if(string[len-1]=='H' || string[len-1]=='h')
	{type=3; string[len-1]=0; len--;} 
    else if(string[0]=='0' && string[1]=='x')
	{type=3; string += 2; len-=2; }
    *value=0L;
    switch(type){
	case 0: /* Binary */
		if( len > 32 ) return(-2);
		for(i=0;i<len;i++){
		    if(string[i]!='0' && string[i]!='1') return(-1);
		    work=(work<<1)+(string[i]-'0');
		}
		*value=work;
		break;
	case 1: /* Octal */
		if(len>11) return(-2);
		for(i=0;i<len;i++){
		    c=string[i];
		    if(c<'0' || c>'7') return(-1);
		    work=(work<<3)+(string[i]-'0');
		}
		*value=work;
		break;
	case 2: /* Decimal */
		if(len>10) return(-2);
		for(i=0;i<len;i++){
		    c=string[i];
		    if(c<'0' || c>'9') return(-1);
		    work=( (work<<3) + (work<<1) ) + c-'0';
		}
		*value=work;
		break;
	case 3: /* Hex */
		if(len>1 && string[0]=='0'){len--; string++; }
		if(len>8) return(-2);
		for(i=0;i<len;i++){
		    c=string[i]; work=work<<4;
		    if(c>='0' && c<='9') work += (c-'0');
	  	    else{
			c=toupper(c);
			if(c>='A' && c<='F') work += (c-'A'+10);
			else return(-1);
		    }
		}
		*value=work;
		break;
    }
    return(0);
}

print_heading(fp,start_time)
FILE *fp;
char *start_time;
{
  fprintf(fp,"TMS320C30 Linker     Version %d.%d \t\t%s",MAJOR_VERSION
	,MINOR_VERSION,start_time);
  fprintf(fp,"(c) Copyright 1990-1992, Ted Rossin the Butt Hole not Inc.\n\n");
}

