/* ln30.h  <12-12-90>  <6-25-92>  TGR */

 /***************************************************************************** 
 *
 * $Id: ln30.h,v 1.1 1993/01/09 10:55:44 rossin Exp rossin $
 *
 * $Log:	ln30.h,v $
 * Revision 1.3  93/03/11  09:02:51  09:02:51  rossin (Ted Rossin)
 * Bumped minor rev to 1.4 to fix symbol table bug.
 * 
 * Revision 1.2  93/02/13  14:18:56  14:18:56  rossin (Ted Rossin)
 * Bumped minor revision for DOS port.
 * 
 * Revision 1.1  1993/01/09  10:55:44  rossin
 * Initial revision
 *
 *****************************************************************************/

#define MAJOR_VERSION	1
#define MINOR_VERSION	4

#define MAX_SYM		16

typedef struct{
    char symbol[MAX_SYM];
    unsigned long value;
} Global_Sym_Tab;

typedef struct{
    unsigned short section;
    unsigned short flags;
    unsigned long offset;
    char symbol[MAX_SYM];
} Global_Rel_Tab;

#define F_RELFLG	0x0001
#define F_EXEC		0x0002
#define F_LNNO		0x0004
#define F_LSYMS		0x0010
#define F_AR32WR	0x0040

typedef struct{
    unsigned short  magic;
    unsigned short  num_sec;
    long	    time;
    long	    sym_tab_start;
    long	    sym_tab_len;
    unsigned short  opt_head_size;
    unsigned short  flags;
} File_Header;

#define STYP_REG	0x0000
#define STYP_DSECT	0x0001
#define STYP_NOLOAD	0x0002
#define STYP_GROUP	0x0004
#define STYP_PAD	0x0008
#define STYP_COPY	0x0010
#define STYP_TEXT	0x0020
#define STYP_DATA	0x0040
#define STYP_BSS	0x0080
#define STYP_ALIGN	0x0100

typedef struct{
    char	    name[8];
    long	    physical_address;
    long	    virtual_address;
    long	    size;
    long	    raw_data_pointer;
    long	    relocation_pointer;
    long	    line_num_pointer;
    unsigned short  num_relocation_entries;
    unsigned short  num_line_num_entries;
    unsigned short  flags;
    char	    reserved;
    char	    memory_page_number;
} Section_Header;

#define R_RELLONG	0x0011
#define R_SECREL32	0x0030
#define R_RELWORD	0x0010
#define R_RELPAGE	0x0033
#define R_REL24		0x0005
#define R_PCRWORD	0x0013
#define R_PCRDWORD	0x0014
#define R_RESOLVED	0xFFFF
#define R_SECREL16	0x0031
#define R_SECREL24	0x0032

typedef struct{
    unsigned long   address;
    unsigned short  sym_index;
    unsigned short  reserved;
    unsigned short  type;
} Rel_Entry;

#define T_NULL		0

#define C_NULL		0
#define C_EXT		2
#define C_EXTDEF	5
#define C_STATLAB	20
#define C_EXTLAB	21

typedef struct{
    unsigned long   offset_mode;
    unsigned long   string_offset;
    long	    value;
    short	    section;
    unsigned short  type;
    unsigned char   class;
    unsigned char   aux_entries;
} Sym_Tab_Entry;
