/*
    main.c

    A sample Windows application

    Another fine Herman Rodent production

*/

#include "global.h"

//
// local data
//

static HWND hwndList;
static char szMsg[4096];
static LPSTR pLastMsg;

RIPMSG RIPTable[] = {
    ERR_GALLOC              ,"GlobalAlloc failed. This error value is sent by KERNEL.",
    ERR_GREALLOC            ,"GlobalReAlloc failed. This error value is sent by KERNEL.",
    ERR_GLOCK               ,"GlobalLock failed. This error value is sent by KERNEL.",
    ERR_LALLOC              ,"LocalAlloc failed. This error value is sent by KERNEL.",
    ERR_LREALLOC            ,"LocalReAlloc failed. This error value is sent by KERNEL.",
    ERR_LLOCK               ,"LocalLock failed. This error value is sent by KERNEL.",
    ERR_ALLOCRES            ,"AllocResource failed. This error value is sent by KERNEL.",
    ERR_LOCKRES             ,"LockResource failed. This error value is sent by KERNEL.",
    ERR_LOADMODULE          ,"LoadModule failed. This error value is sent by KERNEL.",
    ERR_CREATEDLG           ,"Dialog box could not be created because LoadMenu failed. This error value is sent by USER.",
    ERR_CREATEDLG2          ,"Dialog box could not be created because CreateWindow failed. This error value is sent by USER.",
    ERR_REGISTERCLASS       ,"RegisterClass failed because the class is already registered. This error value is sent by USER.",
    ERR_DCBUSY              ,"Device-context cache is full. This error value is sent by USER.",
    ERR_CREATEWND           ,"Window could not be created because the class was not found. This error value is sent by USER.",
    ERR_STRUCEXTRA          ,"Program is using unallocated space. This error value is sent by USER.",
    ERR_LOADSTR             ,"LoadString failed. This error value is sent by USER.",
    ERR_LOADMENU            ,"LoadMenu failed. This error value is sent by USER.",
    ERR_NESTEDBEGINPAINT    ,"Program contains nested BeginPaint functions. This error value is sent by USER.",
    ERR_BADINDEX            ,"Index to GetClassLong, GetClassWord, GetWindowLong, GetWindowWord, SetClassLong, SetClassWord, SetWindowLong, or SetWindowWord is invalid. This error value is sent by USER.",
    ERR_CREATEMENU          ,"Menu could not be created. This error value is sent by USER.",
    ERR_CREATEDC            ,"CreateCompatibleDC, CreateDC, or CreateIC failed. This error value is sent by GDI.",
    ERR_CREATEMETA          ,"CreateMetaFile failed. This error value is sent by GDI.",
    ERR_DELOBJSELECTED      ,"Program is trying to delete a bitmap that is selected into the device context. This error value is sent by GDI.",
    ERR_SELBITMAP           ,"Program is trying to select a bitmap that is already selected. This error value is sent by GDI.",
    ERR_BAD_VALUE           ,"A 16-bit signed or unsigned value is invalid.",
    ERR_BAD_FLAGS           ,"One or more bit flags are invalid.",
    ERR_BAD_INDEX           ,"Index is invalid or out of range.",
    ERR_BAD_SELECTOR        ,"Selector is invalid.",
    ERR_BAD_HANDLE          ,"Generic handle is invalid.",
    ERR_BAD_HINSTANCE       ,"Instance handle is invalid. This error value is sent by KERNEL.",
    ERR_BAD_HMODULE         ,"Module handle is invalid. This error value is sent by KERNEL.",
    ERR_BAD_GLOBAL_HANDLE   ,"Global handle is invalid. This error value is sent by KERNEL.",
    ERR_BAD_LOCAL_HANDLE    ,"Local handle is invalid. This error value is sent by KERNEL.",
    ERR_BAD_ATOM            ,"Atom is invalid. This error value is sent by KERNEL.",
    ERR_BAD_HFILE           ,"File handle is invalid. This error value is sent by KERNEL.",
    ERR_BAD_HWND            ,"Window handle is invalid. This error value is sent by USER.",
    ERR_BAD_HMENU           ,"Menu handle is invalid. This error value is sent by USER.",
    ERR_BAD_HCURSOR         ,"Cursor handle is invalid. This error value is sent by USER.",
    ERR_BAD_HICON           ,"Icon handle is invalid. This error value is sent by USER.",
    ERR_BAD_HDWP            ,"Handle to a window-position structure is invalid. This error value is sent by USER.",
    ERR_BAD_CID             ,"Communications identifier (CID) is invalid. This error value is sent by USER.",
    ERR_BAD_HDRVR           ,"Installable-driver handle is invalid. This error value is sent by USER.",
    ERR_BAD_GDI_OBJECT      ,"GDI object is invalid. This error value is sent by GDI.",
    ERR_BAD_HDC             ,"Device-context handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HPEN            ,"Pen handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HFONT           ,"Font handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HBRUSH          ,"Brush handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HBITMAP         ,"Bitmap handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HRGN            ,"Region handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HPALETTE        ,"Palette handle is invalid. This error value is sent by GDI.",
    ERR_BAD_HMETAFILE       ,"Metafile handle is invalid. This error value is sent by GDI.",
    ERR_BAD_DVALUE          ,"A 32-bit signed or unsigned value is invalid.",
    ERR_BAD_DFLAGS          ,"One or more 32-bit flags are invalid.",
    ERR_BAD_DINDEX          ,"A 32-bit index is invalid or out of range.",
    ERR_BAD_PTR             ,"Pointer is invalid.",
    ERR_BAD_FUNC_PTR        ,"Function pointer is invalid.",
    ERR_BAD_STRING_PTR      ,"Zero-terminated string pointer is invalid.",
    ERR_BAD_COORDS          ,"X- and y-coordinates are invalid. This error value is sent by GDI.",
    0                       ,NULL
    };


//
// local functions
//

static void Create(HWND hWnd, LPCREATESTRUCT lpCI);
static void Size(HWND hWnd, UINT uiX, UINT uiY);
static void Command(HWND hWnd, WPARAM wParam, LPARAM lParam);
static void MeasureItem(HWND hWnd, UINT uiCtl, LPMEASUREITEMSTRUCT lpMI);
static void DrawItem(HWND hWnd, UINT uiCtl, LPDRAWITEMSTRUCT lpDI);
static void InitMenuPopup(HMENU hMenu, UINT uiIndex, BOOL bSystem);
static void Paint(HWND hWnd, LPPAINTSTRUCT lpPS);
static void DrawListItem(HWND hWnd, LPDRAWITEMSTRUCT lpDI);

//
// Entry point
//

int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpszCmdLine,
                   int cmdShow)
{
    MSG msg;

    hAppInstance = hInstance;
    szAppName = "RipWatch";

    //
    // We don't allow multiple instances
    //

    if (hPrevInstance) {
        BringWindowToTop(FindWindow(NULL, szAppName));
        return 1;
    }

    if (!InitFirstInstance(hInstance)) {
        return 1;
    }

    //
    // Do the per instance initialization
    //

    if (!InitCurrentInstance(hInstance, lpszCmdLine, cmdShow)) {
        return 1;
    }

    //
    // Check for messages from Windows and process them.
    // If we have nothing else to do, maybe perform some idle function
    // 

    do {
        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {

            //
            // got a message to process
            //

            if (msg.message == WM_QUIT) break;

            //
            // Do the accelerator thing
            //

            if (!TranslateAccelerator(hwndMain, hAccTable, &msg)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }

        } else {

            //
            // perform some idle routine or just give up so Windows
            // can run till our next message.
            //

            WaitMessage();
        }
    } while (1);

    return (msg.wParam);
}
    
//
// main window message handler
//

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    LPSTR pM, pN;

    switch(msg) {
    case WM_CREATE:
        Create(hWnd, (LPCREATESTRUCT)lParam);
        break;

    case WM_SIZE:
        Size(hWnd, LOWORD(lParam), HIWORD(lParam));
        break;

    case WM_COMMAND:
        Command(hWnd, wParam, lParam); 
        break;

    case WM_MEASUREITEM:
        MeasureItem(hWnd, (UINT)wParam, (LPMEASUREITEMSTRUCT)lParam);
        return (LRESULT) TRUE;

    case WM_DRAWITEM:
        DrawItem(hWnd, (UINT)wParam, (LPDRAWITEMSTRUCT) lParam);
        break;

    case WM_PAINT:
        BeginPaint(hWnd, &ps);
        Paint(hWnd, &ps);
        EndPaint(hWnd, &ps);
        break;

    case WM_INITMENUPOPUP:
        InitMenuPopup((HMENU)wParam, LOWORD(lParam), (BOOL)HIWORD(lParam));
        break;

    case WM_DESTROY:
        Terminate();
        PostQuitMessage(0);
        break;

    case RW_MSG:
        pM = pN = szMsg;
        
        while (*pM) {
            while(*pN && (*pN != '\n') && (*pN != '\r')) pN++;
            if ((*pN == '\n') || (*pN == '\r')) {
                *pN = '\0';
                pN++;
                while ((*pN == '\r') || (*pN == '\n')) {
                    pN++; // skip any CRs or LFs 
                }
                Status(pM);
            } else {
                Status(pM);
            }
            pM = pN;
        }
        szMsg[0] = '\0';
        pLastMsg = szMsg;
        break;

    case RW_HOOK:
        HookAll(hAppInstance);
        break;

    default:
        return DefWindowProc(hWnd, msg, wParam, lParam);
        break;
    }
    return NULL;
}

//
// Process WM_CREATE message
//

static void Create(HWND hWnd, LPCREATESTRUCT lpCI)
{
    //
    // Create a listbox to fill the client area
    //

    hwndList = CreateWindow("Listbox",
                            "",
                            WS_CHILD | WS_VISIBLE | WS_VSCROLL
                             | LBS_HASSTRINGS | LBS_OWNERDRAWFIXED
                             | LBS_NOINTEGRALHEIGHT,
                            0,
                            0,
                            0,
                            0,
                            hWnd,
                            (HMENU)IDC_LIST,
                            hAppInstance,
                            (LPSTR)NULL
                            );

}

//
// Process WM_SIZE message
//

static void Size(HWND hWnd, UINT uiX, UINT uiY)
{
    if (hwndList) {
        MoveWindow(hwndList, 0, 0, uiX, uiY, TRUE);
    }

}

//
// Process WM_COMMAND messages
//

static void Command(HWND hWnd, WPARAM wParam, LPARAM lParam) 
{
    PRINTDLG pd;

    switch (wParam) {
    case IDM_SAVEAS:
        FileSave(FILE_SAVE_AS);
        break;

    case IDM_PRINT:
        memset(&pd, 0, sizeof(pd));
        pd.lStructSize = sizeof(pd);
        pd.hwndOwner = hWnd;
        pd.Flags = PD_RETURNDC;
        if (PrintDlg(&pd)) {
            Print(pd.hDC);
        }
        DeleteDC(pd.hDC);
        if (pd.hDevMode) GlobalFree(pd.hDevMode);
        if (pd.hDevNames) GlobalFree(pd.hDevNames);
        break;

    case IDM_PRINTSETUP:
        memset(&pd, 0, sizeof(pd));
        pd.lStructSize = sizeof(pd);
        pd.hwndOwner = hWnd;
        pd.Flags = PD_PRINTSETUP;
        PrintDlg(&pd);
        break;

    case IDM_EXIT:
        PostMessage(hWnd, WM_CLOSE, 0, 0l);
        break;

    case IDM_COPY:
        ClipCommand(hWnd, wParam);
        break;

    case IDM_HELPCONTENTS:
        Help(hWnd, wParam);
        break;

    case IDM_ABOUT:
        About(hWnd);
        break;

    default:
        break;
    }
}

//
// Process WM_DRAWITEM and WM_MEASUREITEM messages
//

static void MeasureItem(HWND hWnd, UINT uiCtl, LPMEASUREITEMSTRUCT lpMI)
{
    switch (uiCtl) {

    default:

        //
        // Return the height of the system font
        //

        lpMI->itemHeight = tmSysFont.tmHeight;
        break;
    }
}

static void DrawItem(HWND hWnd, UINT uiCtl, LPDRAWITEMSTRUCT lpDI)
{
    switch (uiCtl) {
    case IDC_LIST:
        DrawListItem(hWnd, lpDI);
        break;

    default:
        break;
    }
}

//
// Process WM_PAINT messages
//

static void Paint(HWND hWnd, LPPAINTSTRUCT lpPS)
{


}

//
// Process WM_INITMENUPOPUP messages
//

static void InitMenuPopup(HMENU hmenuPopup, UINT uiIndex, BOOL bSystem)
{
    //
    // See if there is anything in the clipboard which
    // we should enable the Paste item for
    //

    InitClipMenu(hmenuPopup);

}

//
// Show a message box
//

UINT cdecl Message(UINT uiBtns, LPSTR lpFormat, ...) 
{
    char buf[256];

    wvsprintf(buf, lpFormat, (LPSTR)(&lpFormat+1));
    MessageBeep(uiBtns ? uiBtns : MB_ICONEXCLAMATION);
    return (UINT) MessageBox(hwndMain, 
                             buf, 
                             szAppName, 
                             uiBtns ? uiBtns : MB_OK|MB_ICONEXCLAMATION);
}

//
// Display an item in the list box
//

static void DrawListItem(HWND hWnd, LPDRAWITEMSTRUCT lpDI)
{
    HBRUSH hbrBkGnd;
    RECT rc;
    HDC hDC;
    char buf[256];
    
    hDC = lpDI->hDC;
    rc = lpDI->rcItem;

    switch (lpDI->itemAction) {

    case ODA_SELECT:
    case ODA_DRAWENTIRE:

        //
        // erase the rectangle
        //

        hbrBkGnd = CreateSolidBrush(GetSysColor(COLOR_WINDOW));
        FillRect(hDC, &rc, hbrBkGnd);
        DeleteObject(hbrBkGnd);

            //
            // show the text in our standard font
            //
    
            SetBkMode(hDC, TRANSPARENT);
    
            SendMessage(lpDI->hwndItem, 
                        LB_GETTEXT, 
                        lpDI->itemID, 
                        (LPARAM)(LPSTR)buf);

            ExtTextOut(hDC, 
                       rc.left+2, rc.top,
                       ETO_CLIPPED,
                       &rc, 
                       buf,
                       lstrlen(buf), 
                       NULL);
    
        break;
    
    }
}

//
// function to add a string to the end of the list
//

void cdecl Status(LPSTR lpFormat, ...) 
{
    int i;
    char buf[256];

    if (!hwndList) return;
    if (!lpFormat || !lstrlen(lpFormat)) return;

    //
    // format the string
    //

    wvsprintf(buf, lpFormat, (LPSTR)(&lpFormat+1));

    //
    // stop the listbox repaints while we mess with it
    //

    SendMessage(hwndList, WM_SETREDRAW, (WPARAM) FALSE, (LPARAM) 0);

    //
    // get the item count
    //

    i = (int) SendMessage(hwndList, LB_GETCOUNT, (WPARAM) 0, (LPARAM) 0);
    if (i == LB_ERR) i = 0;

    //
    // scrub a few if we have too many
    //

    while (i >= MAXLISTLINES) {
        SendMessage(hwndList, LB_DELETESTRING, (WPARAM) 0, (LPARAM) 0);
        i--;
    }

    //
    // add the new one on at the end and scroll it into view
    //

    i = (int) SendMessage(hwndList, LB_ADDSTRING, (WPARAM) 0, (LPARAM) (LPSTR) buf);
    SendMessage(hwndList, LB_SETCURSEL, (WPARAM) i, (LPARAM) 0);

    //
    // enable the repaint now
    //

    SendMessage(hwndList, WM_SETREDRAW, (WPARAM) TRUE, (LPARAM) 0);
}

//
// Return the type of an error
//

LPSTR ErrorType(WORD wErr)
{
    static char ErrMsg[256];

    ErrMsg[0] = '\0';
    if (wErr & ERR_WARNING) lstrcat(ErrMsg, "WARNING ");
    if (wErr & ERR_PARAM) {
        switch (wErr & ERR_SIZE_MASK) {
        case ERR_BYTE:
            lstrcat(ErrMsg, "8 bit param.");
            break;

        case ERR_WORD:
            lstrcat(ErrMsg, "16 bit param.");
            break;

        case ERR_DWORD:
            lstrcat(ErrMsg, "32 bit param.");
            break;
        }
    }
    return ErrMsg;
}

//
// Lookup the text to an error 
//

LPSTR ErrorText(WORD wErr)
{
    PRIPMSG pRM;

    pRM = RIPTable;

    while (pRM->pMsg) {
        if (pRM->wErr == wErr) break;
        pRM++;
    }
    if (pRM->pMsg) return pRM->pMsg;
    return "Unknown";
}

// 
// Add a message to the queue.  We check to see that the same message is
// not already on the queue.  Some messages are sent to every hook
// so we don't want to repeat it if we have aready had it
//

void AddMsg(LPSTR pMsg)
{

    if (pLastMsg && !lstrcmp(pMsg, pLastMsg)) return;

    if (!lstrlen(szMsg)) {
        lstrcpy(szMsg, pMsg);
        pLastMsg = szMsg;
        PostMessage(hwndMain,
                    RW_MSG,
                    0,
                    0);
    } else {
        lstrcat(szMsg, "\n");
        pLastMsg = &szMsg[lstrlen(szMsg)];
        lstrcat(szMsg, pMsg);
    }
}


//
// Hook procedure
//

BOOL FAR PASCAL NotifyProc(WORD wID, DWORD dwData)
{
    NFYRIP FAR *pRIP;
    char buf[256];
    LPSTR p;
    NFYLOGERROR FAR *pLogErr;
    NFYLOGPARAMERROR FAR *pParmErr;

    switch (wID) {
    case NFY_RIP:
        pRIP = (NFYRIP FAR *) dwData;
        wsprintf(buf, 
                 "RIP %4.4XH at %4.4X:%4.4X\n(%s) %s",
                 pRIP->wExitCode,
                 pRIP->wCS,
                 pRIP->wIP,
                 ErrorType(pRIP->wExitCode),
                 ErrorText(pRIP->wExitCode));
        AddMsg(buf);
        return TRUE; // say we handled this one so it won't be passed on

    case NFY_OUTSTR:
        p = (LPSTR)dwData;
        // skip any leading CR LF junk
        while((*p == '\r') || (*p == '\n')) p++;
        if (!lstrlen(p)) return TRUE; // just ignore it
        wsprintf(buf, "MSG: %s", p);
        AddMsg(buf);
        break;

    case NFY_STARTTASK:
        wsprintf(buf, "New task: %4.4X:%4.4X", HIWORD(dwData), LOWORD(dwData));
        AddMsg(buf);
        PostMessage(hwndMain, RW_HOOK, 0, 0);
        break;

    case NFY_TASKIN:
        wsprintf(buf, "Task in: %4.4XH", GetCurrentTask());
        AddMsg(buf);
        break;

    case NFY_LOGERROR:
        pLogErr = (NFYLOGERROR FAR *) dwData;
        wsprintf(buf, 
                 "Error %4.4XH: (%s) %s", 
                 pLogErr->wErrCode,
                 ErrorType(pLogErr->wErrCode),
                 ErrorText(pLogErr->wErrCode));
        AddMsg(buf);
        break;

    case NFY_LOGPARAMERROR:
        pParmErr = (NFYLOGPARAMERROR FAR *) dwData;
        wsprintf(buf,
                 "Param error %4.4XH at %4.4X:%4.4X",
                 pParmErr->wErrCode,
                 HIWORD(pParmErr->lpfnErrorAddr),
                 LOWORD(pParmErr->lpfnErrorAddr));
        AddMsg(buf);
        break;

    case NFY_EXITTASK:
        wsprintf(buf, "Task exit. Code: %4.4XH", LOWORD(dwData));
        AddMsg(buf);
        break;

    default:
        break;
    }

    return FALSE; // say we didn't handle it
}

//
// Create a text image
//

LPSTR CreateTextImage()
{
    HANDLE hMem;
    LPSTR pImage = NULL;
    UINT uiLines, ui;
    UINT uiSize;

    //
    // Get the number of lines in the listbox
    //

    uiLines = (UINT) SendMessage(hwndList, LB_GETCOUNT, 0, 0);

    //
    // Get the length of the text in each one
    //

    uiSize = 0;
    for (ui=0; ui<uiLines; ui++) {
        uiSize += (UINT) SendMessage(hwndList, LB_GETTEXTLEN, ui, 0);
    }

    //
    // Allocate the memory
    //

    hMem = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT,
                       uiSize + 2 * uiLines);
    if (hMem) pImage = GlobalLock(hMem);
    if (!pImage) {
        Status("*** OUT OF MEMORY ***");
        return NULL;
    }

    //
    // Copy each line plus CR LF
    //

    for (ui=0; ui<uiLines; ui++) {
        SendMessage(hwndList, 
                    LB_GETTEXT, 
                    (WPARAM)ui, 
                    (LPARAM)(pImage+lstrlen(pImage)));
        lstrcat(pImage, "\r\n");
    }

    return pImage;
}

//
// Destroy a text image
//

void DeleteTextImage(LPSTR pImage)
{
    HANDLE hMem;

    if (!pImage) return;
    hMem = (HANDLE) HIWORD(pImage);
    GlobalUnlock(hMem);
    GlobalFree(hMem);
}
