/****************************************************************************
Programm:   MEM: Testroutines for a Memory Manager
File:      mem.c
Model:      medium
Env.:       Quick C for Windows 1.0
Author:      hb
****************************************************************************/
#pragma message  ("Modul: "__FILE__"  Version 1.0, Stand:  "__TIMESTAMP__)
/******* Includes ********/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "mem.h"
#include "memrc.h"
#include "memman.h"

/******* Global Variables *******/
HWND          hMain;
HANDLE        hInst;
long lMouse;

/***WinMain*************************************************************
Programm:   Mem
File:      Mem.c
Funktion:   Windows Hauptfunktion
Return:     msg.wParam an DefWndProc
***********************************************************************/
#pragma message   ("Compiling:         WinMain  ")
int PASCAL WinMain (hInstance, hPrevInstance, lpszCmdLine, nCmdShow)
HANDLE   hInstance,
         hPrevInstance;
LPSTR    lpszCmdLine;
int      nCmdShow;
{
   MSG         msg;
   HANDLE      hAccel;


   hInst = hInstance;

   if (hPrevInstance == NULL)
      if (!MemInit (hInst))
         return (FALSE);

   hMain= CreateWindow (APPLICATION,
                        NULL,
                        WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_MAXIMIZE,
                        CW_USEDEFAULT,
                        CW_USEDEFAULT,
                        CW_USEDEFAULT,
                        CW_USEDEFAULT,
                        NULL,
                        NULL,
                        hInst,
                        lpszCmdLine);
   ShowWindow (hMain, nCmdShow);
   UpdateWindow (hMain);

   hAccel = LoadAccelerators (hInstance, APPLICATION);

   while (GetMessage (&msg, NULL, 0, 0))
   {
      if (!TranslateAccelerator (hMain, hAccel, &msg))
      {
          TranslateMessage (&msg);
          DispatchMessage (&msg);
      }
   }
   return msg.wParam;
}

/***MemWndProc*******************************************************
Programm:   Mem
File:      Mem.c
Funktion:   Verarbeitet die Nachrichten des Hauptfensters
Return:     Fehlerkennung
Author:      hb
***********************************************************************/
#pragma message   ("Compiling:         MemWndProc  ")
long FAR PASCAL MemWndProc (hWnd, iMessage, wParam, lParam)
HWND           hWnd;
unsigned       iMessage;
WORD           wParam;
LONG           lParam;
{
   FARPROC        lpDialog;      /* Procedure Instance der Dialogboxen */
   PAINTSTRUCT    ps;
   HDC            hDC;
   int            nPos;
   RECT           rcClient;
   long           lScrollPos;
   char           szLine[MAXSTRLEN];


   switch (iMessage)
   {
      case WM_CREATE:
         SetScrollRange (hWnd, SB_HORZ, 0, 32767, FALSE);
      break;

      case WM_MOUSEMOVE:
         if (hHeap != NULL)
         {
            GetClientRect (hWnd, &rcClient);
            lScrollPos = (long) GetScrollPos (hWnd, SB_HORZ);
            lMouse = (lScrollPos + (long) LOWORD (lParam)) * 8L;
            wsprintf (szLine, "Mouse at offset: %ld         ", lMouse);
            if ((hDC = GetDC (hWnd)) != NULL)
            {
               TextOut (hDC, 0, 0, szLine, lstrlen (szLine));
               ReleaseDC (hWnd, hDC);
            }
         }
      break;

      case WM_LBUTTONUP:
         if (hHeap != NULL)
         {
            lScrollPos = (long) GetScrollPos (hWnd, SB_HORZ);
            lMouse = (lScrollPos + (long) LOWORD (lParam)) * 8L;
            lpDialog = MakeProcInstance (ViewDlgProc, hInst);
            DialogBox (hInst, "VIEWBOX", hWnd, lpDialog);
            FreeProcInstance (lpDialog);
         }
      break;

      case WM_HSCROLL:
         nPos = GetScrollPos (hWnd, SB_HORZ);
         switch (wParam)
         {
            case SB_LINEUP:
               nPos -=20;
            break;

            case SB_LINEDOWN:
               nPos +=20;
            break;

            case SB_PAGEUP:
               nPos -=160;
            break;

            case SB_PAGEDOWN:
               nPos +=160;
            break;

            case SB_THUMBPOSITION:
               nPos = LOWORD (lParam);
            break;

            default:
            break;
         }
         if (nPos < 0) nPos = 0;
         if (nPos > 32767) nPos = 32767;
         if (nPos != GetScrollPos (hWnd, SB_HORZ))
         {
            SetScrollPos (hWnd, SB_HORZ, nPos, TRUE);
            InvalidateRect (hWnd, NULL, TRUE);
         }
      break;

      case WM_PAINT:
         hDC = BeginPaint (hWnd, &ps);
         if (hHeap != NULL)
         {
            DrawHeap (hWnd, hDC);
         }
         EndPaint (hWnd, &ps);
      break;

      case WM_COMMAND :
         switch (wParam)
         {
            case IDM_CREATEHEAP:
               lpDialog = MakeProcInstance (CreateHeapDlgProc, hInst);
               DialogBox (hInst, "CREATEHEAPBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_ALLOCMEM:
               lpDialog = MakeProcInstance (AllocMemDlgProc, hInst);
               DialogBox (hInst, "ALLOCMEMBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_REALLOCMEM:
               lpDialog = MakeProcInstance (ReAllocMemDlgProc, hInst);
               DialogBox (hInst, "REALLOCMEMBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_FREEMEM:
               lpDialog = MakeProcInstance (FreeMemDlgProc, hInst);
               DialogBox (hInst, "FREEMEMBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_DESTROYHEAP:
               lpDialog = MakeProcInstance (DestroyHeapDlgProc, hInst);
               DialogBox (hInst, "DESTROYHEAPBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_WALKHEAP:
               lpDialog = MakeProcInstance (WalkHeapDlgProc, hInst);
               DialogBox (hInst, "WALKHEAPBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
            break;

            case IDM_SHAKEHEAP:
               lpDialog = MakeProcInstance (ShakeHeapDlgProc, hInst);
               DialogBox (hInst, "SHAKEHEAPBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_MELTFREE:
               MeltFreeList ();
               InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_EXIT:
               SendMessage (hWnd, WM_CLOSE, 0, 0L);
            break;

            case IDM_ABOUT:
               lpDialog = MakeProcInstance (AboutDlgProc, hInst);
               DialogBox (hInst, "ABOUTBOX", hWnd, lpDialog);
               FreeProcInstance (lpDialog);
            break;
         }
      break;

      case WM_CLOSE:
         DestroyWindow (hWnd);
      break;

       case WM_QUERYENDSESSION:
          return (1L);
       break;

       case WM_DESTROY:
            PostQuitMessage (0);
       break;

       default :
            return DefWindowProc (hWnd, iMessage, wParam, lParam);
   }
   return (0L);
}

/***MemInit **************************************************************
Programm:   Mem
File:      Mem.c
Make:       mem.
Funktion:   registriert die window-Klasse und initialisiert alle Variablen
Author:      hb
****************************************************************************/
#pragma message   ("Compiling:         MemInit  ")
BOOL FAR PASCAL MemInit (hInstance)
HANDLE       hInstance;
{
   WNDCLASS      wndclass;

   wndclass.style         = CS_HREDRAW | CS_VREDRAW;
   wndclass.lpfnWndProc   = MemWndProc;
   wndclass.cbClsExtra    = 0;
   wndclass.cbWndExtra    = 0;
   wndclass.hInstance     = hInstance;
   wndclass.hIcon         = LoadIcon (hInstance,  APPLICATION);
   wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
   wndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
   wndclass.lpszMenuName  = APPLICATION;
   wndclass.lpszClassName = APPLICATION;
   if (!RegisterClass ((LPWNDCLASS) &wndclass))
      return(FALSE);
   return (TRUE);
}
/***CreateHeapDlgProc**************************************************
Program:     MEM
File:        mem.c
Function:    CreateHeapDlgProc processes the CreateHeap Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       CreateHeapDlgProc ")
BOOL FAR PASCAL CreateHeapDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   int           nError,
                 nHandles;
   long          lSize;
   char          szLine[MAXSTRLEN];

   switch (iMessage)
   {
      case WM_INITDIALOG:
         SetDlgItemText (hDlg, IDD_SIZE, "100000");
         SetDlgItemText (hDlg, IDD_COUNT, "1000");
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;

            case IDD_OK:
               GetDlgItemText (hDlg, IDD_SIZE, szLine, MAXSTRLEN);
               sscanf (szLine, "%ld", &lSize);
               GetDlgItemText (hDlg, IDD_COUNT, szLine, MAXSTRLEN);
               sscanf (szLine, "%d", &nHandles);
               nError = CreateHeap (lSize, nHandles);
               if (nError == 0)
                  wsprintf (szLine, "CreateHeap: Heap successfully created");
               else if (nError == IDE_REALMODE)
                  wsprintf (szLine, "CreateHeap: ERROR! Cant create heap in real mode");
               else if (nError == IDE_ONLYONEHEAP)
                  wsprintf (szLine, "CreateHeap: ERROR! Heap already exists");
               else if (nError == IDE_NOMEMAVAIL)
                  wsprintf (szLine, "CreateHeap: ERROR! not enuogh global memory to create heap");
               else if (nError == IDE_MEMERROR)
                  wsprintf (szLine, "CreateHeap: ERROR! Cant lock heap");
               SetDlgItemText (hDlg, IDD_STATUS, szLine);
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***AllocMemDlgProc**************************************************
Program:     MEM
File:        mem.c
Function:    AllocMemDlgProc processes the AllocMem Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       AllocMemDlgProc ")
BOOL FAR PASCAL AllocMemDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   int           nError;
   long          lSize;
   int           nLen;
   char          szLine[MAXSTRLEN];
   char          szFill[MAXSTRLEN];
   char          szSize[MAXSTRLEN];
   LPSTR         lp;
   long          lOffset;

   switch (iMessage)
   {
      case WM_INITDIALOG:
         SetDlgItemText (hDlg, IDD_FILL, "A");
         SetDlgItemText (hDlg, IDD_SIZE, "128");
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;

            case IDD_OK:
               GetDlgItemText (hDlg, IDD_FILL, szFill, MAXSTRLEN);
               GetDlgItemText (hDlg, IDD_SIZE, szSize, MAXSTRLEN);
               sscanf (szSize, "%ld", &lSize);
               GetDlgItemText (hDlg, IDD_TEXT, szLine, MAXSTRLEN);
               if ((nLen = lstrlen (szLine)) > 0)
               {
                  lp = AllocMem (nLen+1);    /* Len + terminating NULL */
                  if (lp != NULL)
                  {
                     lstrcpy (lp, szLine);
                     lOffset = GetOffset (lp);
                     sprintf (szLine, "Alloc successfull! Size=%d, Pointer=%Fp, Offset=%ld",
                              nLen, lp, lOffset);
                     SetDlgItemText (hDlg, IDD_STATUS, szLine);
                  }
                  else
                     SetDlgItemText (hDlg, IDD_STATUS, "Alloc failed!");
               }
               else
               {
                  lp = AllocMem (lSize);
                  if (lp != NULL)
                  {
                     lmemfill (lp, szFill[0], lSize);
                     lOffset = GetOffset (lp);
                     sprintf (szLine, "Alloc successfull! Size=%ld, Pointer=%Fp, Offset=%ld",
                              lSize, lp, lOffset);
                     SetDlgItemText (hDlg, IDD_STATUS, szLine);
                  }
                  else
                     SetDlgItemText (hDlg, IDD_STATUS, "Alloc failed!");
               }
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***FreeMemDlgProc**************************************************
Program:     MEM
File:        mem.c
Function:    FreeMemDlgProc processes the FreeMem Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       FreeMemDlgProc ")
BOOL FAR PASCAL FreeMemDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   char          szLine[MAXSTRLEN];
   LPSTR         lp;
   long          lOffset;
   int           nError;
   WORD          wIndex;

   switch (iMessage)
   {
      case WM_INITDIALOG:
         ShowHeapList (hDlg, IDD_LIST);
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;

            case IDD_OK:
               GetDlgItemText (hDlg, IDD_LIST, szLine, MAXSTRLEN);
               if (sscanf (szLine, "%ld", &lOffset) > 0)
               {
                  lp = GetPointer (lOffset);
                  nError = FreeMem (lp);
                  wsprintf (szLine, "Free: Error=%d", nError);
                  SetDlgItemText (hDlg, IDD_STATUS, szLine);
                  if (nError == IDE_OK)
                  {
                     if ((wIndex = (WORD) SendDlgItemMessage (hDlg, IDD_LIST,
                                          CB_GETCURSEL, 0, 0L)) != CB_ERR)
                        SendDlgItemMessage (hDlg, IDD_LIST, CB_DELETESTRING, wIndex, 0L);
                  }
               }
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***DestroyHeapDlgProc**********************************************
Program:     MEM
File:        mem.c
Function:    DestroyHeapDlgProc processes the DestroyHeap Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       DestroyHeapDlgProc ")
BOOL FAR PASCAL DestroyHeapDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   int           nError;
   char          szLine[MAXSTRLEN];

   switch (iMessage)
   {
      case WM_INITDIALOG:
         SetDlgItemText (hDlg, IDD_STATUS, "");
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;

            case IDD_OK:
               nError = DestroyHeap ();
               if (nError == IDE_OK)
                  wsprintf (szLine, "Heap destroyed!", nError);
               else
                  wsprintf (szLine, "There was no proper heap", nError);
               SetDlgItemText (hDlg, IDD_STATUS, szLine);
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***WalkHeapDlgProc**********************************************
Program:     MEM
File:        mem.c
Function:    WalkHeapDlgProc processes the WalkHeap Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       WalkHeapDlgProc ")
BOOL FAR PASCAL WalkHeapDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   switch (iMessage)
   {
      case WM_INITDIALOG:
         WalkHeap (hDlg, IDD_FREELIST, IDD_HEAPLIST, IDD_STATUS);
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***ShakeHeapDlgProc**********************************************
Program:     MEM
File:        mem.c
Function:    ShakeHeapDlgProc processes the ShakeHeap Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       ShakeHeapDlgProc ")
BOOL FAR PASCAL ShakeHeapDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   char        szSize[MAXSTRLEN];
   long        lRuns;

   switch (iMessage)
   {
      case WM_INITDIALOG:
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;

            case IDD_OK:
               GetDlgItemText (hDlg, IDD_COUNT, szSize, MAXSTRLEN);
               sscanf (szSize, "%ld", &lRuns);
               Shake (hDlg, IDD_STATUS, lRuns);
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***ViewDlgProc***************************************************
Program:     MEM
File:        mem.c
Function:    ViewDlgProc processes the View Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       ViewDlgProc ")
BOOL FAR PASCAL ViewDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   char        szSize[MAXSTRLEN];
   HWND        hParent;
   RECT        rcClient;

   switch (iMessage)
   {
      case WM_INITDIALOG:
         ViewHeap (hDlg, IDD_LIST, lMouse);
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
/***ReAllocMemDlgProc***************************************************
Program:     MEM
File:        mem.c
Function:    ViewDlgProc processes the View Dialogbox
Author:      hb
****************************************************************************/
#pragma message ("Compiling:       ReAllocMemDlgProc ")
BOOL FAR PASCAL ReAllocMemDlgProc (hDlg, iMessage, wParam, lParam)
HWND     hDlg;
unsigned iMessage;
WORD     wParam;
LONG     lParam;
{
   char          szLine[MAXSTRLEN],
                 szSize[MAXSTRLEN];
   LPSTR         lp,
                 lpNew;
   long          lOffset,
                 lSize;
   int           nError;
   WORD          wIndex;

   switch (iMessage)
   {
      case WM_INITDIALOG:
         ShowHeapList (hDlg, IDD_LIST);
      break;

      case WM_COMMAND:
         switch (wParam)
         {
            case IDD_CANCEL:
               EndDialog (hDlg, FALSE);
               return (TRUE);
            break;

            case IDD_OK:
               GetDlgItemText (hDlg, IDD_LIST, szLine, MAXSTRLEN);
               GetDlgItemText (hDlg, IDD_SIZE, szSize, MAXSTRLEN);
               if (sscanf (szLine, "%ld", &lOffset) > 0 &&
                   sscanf (szSize, "%ld", &lSize) > 0)
               {
                  lp = GetPointer (lOffset);
                  lpNew = ReAllocMem (lp, lSize);
                  if (lpNew == NULL && lSize != 0L)
                     wsprintf (szLine, "ReAllocMem failed!");
                  else if (lp != NULL && lpNew == NULL && lSize == 0L)
                     wsprintf (szLine, "ReAllocMem freed block (Size=0)!");
                  else if (lp != NULL && lpNew != lp && lpNew != NULL)
                     wsprintf (szLine, "ReAllocMem moved block to new location!");
                  else
                     wsprintf (szLine, "ReAllocMem succeded!");
                  SetDlgItemText (hDlg, IDD_STATUS, szLine);
                  SendDlgItemMessage (hDlg, IDD_LIST, CB_RESETCONTENT, 0, 0L);
                  ShowHeapList (hDlg, IDD_LIST);
               }
            break;
         }
      break;

      default:
         return (FALSE);
   }
   return (TRUE);
}
