// midisx.h

#define NOCOMM // suppress non-standard definitions which cause warnings

#ifndef _WINDOWS
#define _WINDOWS
#endif

#define WINVER 0x030a

#include <windows.h>    

#include "midi.h" 
#include "menu.h"
#include "data.h"
#include "dialog.h"
#include "display.h"
                             
#define ID_MIDISX_ICO                   100

// dialog control ID's  
#define IDC_COMMAND_STRING              150
#define IDC_INPUT_BUFFER_SIZE           151

// menu ID's
#define IDM_FILE_SAVE                   200
#define IDM_FILE_EXIT                   201
#define IDM_INPUT                       300 // base menu id for output devices
#define IDM_INPUT_ALWAYS_KEEP_OPEN      321
#define IDM_OUTPUT                      400 // base menu id for input devices 
#define IDM_OUTPUT_ALWAYS_KEEP_OPEN     421
#define IDM_SYSEX_COMMAND_STRING        500
#define IDM_SYSEX_INPUT_BUFFER          501
#define IDM_SEND                        600 
#define IDM_ABORT                       610
#define IDM_HELP_MIDISX_HELP            700
#define IDM_HELP_ABOUT                  701
                                 
// global variables    
HMENU hMenu;              // handle of application menu

MIDIINFO MidiInInfo;      // current MIDI input device information
MIDIINFO MidiOutInfo;     // current MIDI output device information
              
#define COMMAND_STRING_SIZE 128            
char achCommandString[COMMAND_STRING_SIZE]; // user input ASCII command string

#define SYSEX_STRING_SIZE 48
BYTE abSysExCommand[SYSEX_STRING_SIZE];     // binary system exclusive string
int cbSysExCommand;                         // length of binary string

#define INPUT_BUFFER_SIZE 4096              // default size of input buffer     
#define INPUT_BUFFER_MIN 16                 // minimum size of input buffer
#define INPUT_BUFFER_MAX 0xFFFE             // maximum size of input buffer is
                                            // limited by capacity of _lwrite                                           
UINT cbInputBuffer;                         // size of input buffer
HANDLE hInputBuffer;                        // handle to input buffer
LPBYTE lpInputBuffer;                       // pointer to input buffer 
BOOL fUnsavedData;                          // input buffer saved to file?

// procedures                   
int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);                       
BOOL InitApplication(HINSTANCE);                                     
LONG FAR PASCAL __export MainWndProc(HWND, unsigned int, WORD, LONG);

