/* 
	mikee.h
*/

#ifndef	MIKEEDEF

#if __STDC__
#define _Cdecl
#else
#define _Cdecl	cdecl
#endif

/*
	mouse buttons identifiers
*/
#define	LEFT_BUTTON      1
#define	RIGHT_BUTTON     2
#define	MIDDLE_BUTTON    3
/*
	key scancodes
*/
#define  UP_ARROW		0x4800
#define  DN_ARROW		0x5000
#define  LT_ARROW		0x4B00
#define  RT_ARROW		0x4D00
#define  ENTER			0x1C0D
#define  ESC  			0x011B
/*
	mouse event mask
*/
#define	MSM_MOVED        1    
#define	MSM_L_PRESSED    2    
#define	MSM_L_RELEASED   4    
#define	MSM_R_PRESSED    8    
#define	MSM_R_RELEASED  16    
#define	MSM_M_PRESSED   32    
#define	MSM_M_RELEASED  64
/*
	other mouse constants
*/
#define	MOUSE_XMAX	640
#define	MOUSE_YMAX	480
#define	MOUSE_STEPX	8
#define	MOUSE_STEPY	4
#define	MOUSE_MASK	MSM_MOVED + MSM_L_PRESSED + MSM_R_PRESSED

extern unsigned	mouse_mask;
extern unsigned	mouse_left;
extern unsigned	mouse_right;
extern char			mouse_lastx;
extern char			mouse_lasty;
extern int			mouse_stepx;
extern int			mouse_stepy;

/*
	function prototypes / macros
*/
int		mouse_open(void);
void		mouse_close(void);
#define	mouse_off()			mouse_mask = 0
#define	mouse_on()	   	mouse_mask = MOUSE_MASK
#define	mouse_move_off()	mouse_mask &= ~MSM_MOVED
#define	mouse_move_on()	mouse_mask |= MSM_MOVED
#define	mouse_keys_off()	mouse_mask &= ~MSM_L_PRESSED & ~MSM_R_PRESSED
#define	mouse_keys_on()	mouse_mask |= MSM_L_PRESSED | MSM_R_PRESSED
#define	mouse_fast()		mouse_stepx = MOUSE_STEPX, mouse_stepy = MOUSE_STEPY
#define	mouse_slow()		mouse_stepx = MOUSE_STEPX*20, mouse_stepy = MOUSE_STEPY*20
#define	putkey(key)			kbplace(1,(char)(key & 0xff),(char)(key>>8))

int	far _Cdecl msm_init(void);
void	far _Cdecl msm_term(void);
void	far _Cdecl msm_setcurpos(unsigned curposx,unsigned curposy);
void	far _Cdecl msm_setareax(unsigned minx,unsigned maxx);
void	far _Cdecl msm_setareay(unsigned miny,unsigned maxy);
void	far _Cdecl msm_signal(unsigned mask,
			void (*func)(unsigned mask,unsigned state,unsigned curposx,unsigned curposy),
			void *stack);
int	far _Cdecl kbplace(int where, char value, char scan);

#define	MIKEEDEF	1
#endif

