// COPYRIGHT:
//
//   (C) Copyright Microsoft Corp. 1992.  All rights reserved.
//
//   You have a royalty-free right to use, modify, reproduce and
//   distribute the Sample Files (and/or any modified version) in
//   any way you find useful, provided that you agree that
//   Microsoft has no warranty obligations or liability for any
//   Sample Application Files which are modified.

#include "minmax.h"

int Dlg1_Do(HWND hwndOwner)
{
    int result;
    DLGPROC pfndp;

    pfndp = (DLGPROC)MakeProcInstance((FARPROC)Dlg1_OldDlgProc, g_hinst);
    result = DialogBoxParam(g_hinst, MAKEINTRESOURCE(IDR_DLG1), hwndOwner, pfndp, 0L);
    FreeProcInstance((FARPROC)pfndp);
    return result;
}

BOOL CALLBACK Dlg1_OldDlgProc(HWND hwnd, WORD msg, WPARAM wParam, LPARAM lParam)
{
    return SetDlgMsgResult(hwnd, msg, Dlg1_DlgProc(hwnd, msg, wParam, lParam));
}

LRESULT Dlg1_DlgProc(HWND hwnd, WORD msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg)
    {
	ON_WM_INITDIALOG(Dlg1_OnInitDialog, hwnd, wParam, lParam);
	ON_WM_COMMAND(Dlg1_OnCommand, hwnd, wParam, lParam);
    default:
	return DefDialogProc(hwnd, msg, wParam, lParam);
    }
}

BOOL Dlg1_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    return TRUE;
}

VOID Dlg1_OnCommand(HWND hwndDlg, WORD id, HWND hwndCtl, WORD code)
{
    HWND hwndEdit1  = GetDlgItem(hwndDlg, CTL_EDIT1);
    HWND hwndOK     = GetDlgItem(hwndDlg, CTL_OK);
    HWND hwndCancel = GetDlgItem(hwndDlg, CTL_CANCEL);

    if (id == CTL_OK && code == BN_CLICKED)
    {
	EndDialog(hwndDlg, TRUE);
    }
    else if (id == CTL_CANCEL && code == BN_CLICKED)
    {
	Edit_SetText(hwndEdit1, "*** Cancel ***");
    }
    else if (id == CTL_EDIT1 && code == EN_CHANGE)
    {
	if (Edit_GetTextLength(hwndEdit1) == 0)
	    Button_Enable(hwndOK, FALSE);
	else
	    Button_Enable(hwndOK, TRUE);
    }
    else if (id >= CTL_RED && id <= CTL_GREEN && code == BN_CLICKED)
    {
	CheckRadioButton(hwndDlg, CTL_RED, CTL_GREEN, id);
    }
    else if (id >= CTL_PURPLE && id <= CTL_SIENNA && code == BN_CLICKED)
    {
	HWND hwndCheck = GetDlgItem(hwndDlg, id);

	Button_SetCheck(hwndCheck, !Button_GetCheck(hwndCheck));
    }
}
