//	FILE: MORECALC.CPP
//
//	This program is contains the source code for the program
//	MORECALC.CPP. It is example code from:
//
//		Object Oriented Programming With Turbo C++
//
//	Published by:
//		Wordware Publishing, Inc.
//		1506 Capital Avenue
//		Plano, Texas 75074
//
//
#include <iostream.h>
#include <fstream.h>
#include <process.h>
#include <string.h>
#include <conio.h>

//		FUNCTION PROTOTYPES
void startup();
void outer();
void no_more();
void display(char*);
void do_page_break();
int  get_line(char*,int);

ifstream input_file;		     // must be global because of no_more()
char file_name[40];
int  init_calc      = 1;
int  LINES_PER_PAGE = 20;

const BUF_LEN       = 256;

main(int argc, char* argv[])
{
	char buffer[BUF_LEN];
	int  status;
			/*
			|  The following two lines were used
			|  during testing.
			*/
	if(argc != 2){
		cerr << "USAGE: MORECALC filename \n";
		exit(-1);
	}
	strcpy(file_name,argv[1]);
	input_file.open(file_name,ios::nocreate);
	if (!input_file){
		cerr << "Cannot open input file: " << argv[1] << "\n";
		exit(-1);
	}

	textmode(LASTMODE);
	clrscr();
	for(;;){
		status = get_line(buffer,BUF_LEN);
		if(status){		// 0 means eof
			display(buffer);
		}else{
			no_more();	// done, so quit
		}
	}
}
/*****************************************************/
void no_more()
{
	input_file.close();
	exit(0);
}
/*****************************************************/
int get_line(char* line,int max_len)
{
	int  status=1;
	char ch;

	for(int i=0;i<max_len;i++){
		if(!input_file.get(ch))   status=0;
		*line++ = ch;
		if(ch == '\n'){
			break;
		}
	}
	*line++ = '\0';
	return(status);
}
/*****************************************************/
void display(char* buffer)
{
	static int line_ct = 0;

	cout << buffer;
	line_ct++;
	if(line_ct > LINES_PER_PAGE){
		do_page_break();
		line_ct = 0;
	}
}
/*****************************************************/
void do_page_break()
{
	char answer;

	cout << "\n" << "Continue (Y or N or C)? ";
	cin >> answer;

	switch(answer){
	case 'Y':
	case 'y':
		    break;
	case 'N':
	case 'n':
		    exit(0);
		    break;
	case 'C':
	case 'c':
		    if(init_calc){      // Test first time
			 startup();
			 init_calc = 0;
		    }
		    outer();
		    break;
	}
	clrscr();
	cout << "FILE: " << file_name << "\n\n";
}
