******************************************************************
**								**
** File:  moveit.s      <6-06-91>  <4-19-92> TGR		**
**								**
******************************************************************

	.sect	"vectors"

reset		.word	start	;Reset
int0		.word	0	;External Interrupt 0
int1		.word	0	;External Interrupt 1
int2		.word	0	;External Interrupt 2
int3		.word	0	;External Interrupt 3
xint0		.word	0	;Serial Port 0 transmit buffer empty
rint0		.word	0	;Serial Port 0 recieve buffer empty
xint1		.word	0	;Serial Port 1 transmit buffer empty	
rint1		.word	0	;Serial Port 1 recieve buffer empty
tint0		.word	0	;Timer 0 Interrupt
tint1		.word	0	;Timer 1 Interrupt
dint		.word	0	;DMA Controller Interrupt

		.data

stack		.word	0001E00h	;Stack grows to higher addresses
pbctrl		.word	0808064h	;address of the main bus control
xbctrl		.word	0808060h	;address of the iobus contrl

start_addr	.word	0001D00h

run_addr	.word	begin		;Internal RAM #0
first_addr	.word	begin_load	;First address to transfer
last_addr	.word	end_load	;Last address to transfer


	.global	start,last_addr

	.text

start	ldp	0, dp 		;set data pointer to external RAM
	ldi	@pbctrl, ar0	;get control port address
	ldi	*ar0, ar1	;get current settings
	and	0f007h, ar1	;change to zero waits
	sti	ar1, *ar0	;zero wait states on main
	ldi	@xbctrl, ar0
	ldi	*ar0, ar1	;get current settings
	and	0f007h, ar1	;change to zero waits
	sti	ar1, *ar0	;zero wait states on main
	ldi	@stack, sp 	;Set up stack pointer
	ldi	2,iof		;Set flag 0 to output

*************************************************
*	Copy section "inside" to internal RAM	*
*************************************************

	ldi	@first_addr,ar0	;Fetch Source Address
	ldi	@run_addr,ar1	;Fetch Destination Address
	ldi	@last_addr,r0	;Fetch last address 
	subi3	ar0,r0,rc	;Load up repeat count with amout to move

	rptb	copy
	ldi	*ar0++,r0	;Fetch source data
copy:	sti	r0,*ar1++	;Shove into destination

	br	begin		;Execute code at destination



*************************************************
*	This section will run from internal RAM	*
*************************************************

	.sect	"inside"
	
	.label	begin_load	;Load address of section
begin:	ldi	@start_addr,ar0 ;ar0 is the dest pointer
	ldi	0FFh,r0
	ldi	3F00h,r1
loop:
	addi3	r0,r1,r2
	sti	r2,*ar0++	;Write to memory
	subi	1,r0		;Decrement counter
	bne	loop

done:   br	done
	.label	end_load	;Last load address of section
	

