/* parse.c  <9-15-90>  <3-24-92> TGR */

 /***************************************************************************** 
 *
 * $Id$
 *
 * $Log:	parse.c,v $
 * Revision 1.3  93/03/10  11:06:49  11:06:49  rossin (Ted Rossin)
 * Fixed bug of not dealing with spaces and tabs before and after parameters.
 * 
 * Revision 1.2  93/03/05  13:26:21  13:26:21  rossin (Ted Rossin)
 * Fixed symbol truncation bug that caused an error instead of a warning.
 * Also fixed warning messages in assembler listing output.
 * 
 * 
 * Revision 1.1  93/01/09  11:08:18  11:08:18  rossin (Ted Rossin)
 * Initial revision
 * 
 *****************************************************************************/

#include "port.h"
#include <ctype.h>
#ifdef MAC
#include <string.h> 
#endif
#include "as30.h"

extern char *sym,*op,*parms;
extern char *sym2,*op2,*parms2;

extern char *global_list[MAX_SYM];
extern Sym_tab *sym_tab;
extern Image *image;
extern Sec_loc_cnt *sec_loc_cnt;
extern Rel_tab *rel_tab;
extern int fp_stack_pointer;

static char err[100];

parse_line(pass,line_num,s,symbol,mnemonic,args)
int pass,line_num;
char *s,*symbol,*mnemonic,*args;
{
    register int index=0,i;
    int cut=0,dont_bitch;
    char *sym_save=symbol;

    if(s[0]=='*' || s[0]==';' || s[0]==0 || s[0]=='\n') return(0);
    if(s[0]==' ' || s[0]=='\t'){  /* No symbol */
    	*symbol=0;
	while(s[index] && (s[index]==' ' || s[index]=='\t')) index++;
	if(s[index]=='\n' || s[index]==0 || s[index]==';') 
	    return(0);  /* blank or comment */
    }
    else{	/* Symbol present */
	for(index=0;index<MAX_SYM-1 && s[index]!='\t' && s[index]!=' ' 
			&& s[index]!='\n' && s[index]; index++){
	    *symbol++ = s[index];
	}
	dont_bitch = (s[index]==':')?1:0;
	if(!isspace(s[index]) && s[index]) index = -1;
	if( *(symbol-1) == ':') *(symbol-1)=0; else *symbol=0;
   	sym_save[MAX_SYM-1]=0;
	if(index == -1){  /* symbol truncated */
	    if(!dont_bitch){
	    	sprintf(err,"%02d %04d: Warning: label truncated to %s"
		    ,fp_stack_pointer,line_num,sym_save);
	    	if(pass==1) log_warning(err);
	    }
	    for(;s[index]!=' ' && s[index]!='\t' && s[index];index++);
	}
    }
    while(s[index] && (s[index]==' ' || s[index]=='\t')) index++;
    if(s[index]==0 || s[index]==';' || s[index]=='\n'){
    	*mnemonic = *args = 0;
	return(1);
    }
    for(i=0;i<MAX_SYM-1 && s[index]!='\t' && s[index]!=';' && s[index]!=' ' 
		 && s[index] && s[index]!='\n';i++){
	*mnemonic++ = s[index++];
    }
    *mnemonic=0;
    if(i==MAX_SYM-1){
	sprintf(err,"%02d %04d: Mnemonic field is too long"
	    ,fp_stack_pointer,line_num);
	if(pass==1) log_error(err);
	return(-1);
    }
    while(s[index] && (s[index]==' ' || s[index]=='\t')) index++;
    if(s[index]==0 || s[index]==';' || s[index]=='\n'){
	*args=0;
	return(1);
    }

    for(i=0;i<MAX_LINE-1 && s[index]!=';' && s[index]!='\n' && s[index] ;){ 
	*args++ = s[index++];
    }
    *args=0;
    if(i==MAX_LINE-1){
	sprintf(err,"%02d %04d: Argument field is too long"
	    ,fp_stack_pointer,line_num);
	if(pass==1) log_error(err);
	return(-1);
    }
    return(1);
}
