/* pop_gen.c  <11-25-90> <1-02-93> TGR */

 /***************************************************************************** 
 *
 * $Id: pop_gen.c,v 1.2 1993/03/04 22:14:22 rossin Exp $
 *
 * $Log:	pop_gen.c,v $
 * Revision 1.4  93/03/05  14:28:02  14:28:02  rossin (Ted Rossin)
 * Fixed .global and .bss from bitching about symbols that are MAX_SYM-1
 * in width.
 * 
 * Revision 1.3  93/03/05  13:26:24  13:26:24  rossin (Ted Rossin)
 * Fixed symbol truncation bug that caused an error instead of a warning.
 * Also fixed warning messages in assembler listing output.
 * 
 * 
 * Revision 1.2  93/03/05  08:37:31  08:37:31  rossin (Ted Rossin)
 * Changed truncator assignments to use MAX_SYM-1 instead of hardcode 15
 * 
 * Revision 1.1  1993/01/09  11:08:18  rossin
 * Initial revision
 *
 *****************************************************************************/

#include <stdio.h>
#include "port.h"

#ifdef MAC
#include <string.h>
#endif 
#include "as30.h"

#define BSS				2
#define DO_NOT_PUT_IN_OBJECT_MODULE	-1
#define C_STATLAB	20
#define C_NULL		0

extern char *sym,*op,*parms;
extern char *sym2,*op2,*parms2;

extern char *global_list[MAX_SYM];
extern Sym_tab *sym_tab;
extern Image *image;
extern Sec_loc_cnt *sec_loc_cnt;
extern Rel_tab *rel_tab;

extern char pseudo_op_table[][10];
extern int current_section;
extern long image_count;
extern Image *img_ptr;
extern int global_ptr;
extern int rel_tab_ptr;
extern int sym_ptr;
extern int obj_sym_tab_ptr;
extern int symbol_just_entered;
extern int pseudo_op_ptr;
extern int fp_stack_pointer;
Pop_data *pseudo_op_image;

static char warning[100];

extern char file_name_stack[][MAX_LINE];
extern FILE *sfp;
extern FILE *fp_stack[];
extern int fp_stack_pointer,changed_file;
extern int conditional_state;
extern int generate_cond_code;

decode_pseudo_op(line_num,op_code,parameters,error)
unsigned int line_num;
char *op_code,*parameters,*error;
{
    int i,pseudo_num = -1,return_val=0,len,section,index,found;
    int constant_parm,overrun;
    unsigned long value;
    char c,*ptr,sym[MAX_SYM+1];

    for(i=0;i<NUM_PSEUDO_OPS;i++){
	if(!strcmp(op_code,pseudo_op_table[i])){
	    pseudo_num = i;
	    break;
	}
    }
    if(pseudo_num == -1){
	pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
	pseudo_op_image[pseudo_op_ptr].type = 0;
        pseudo_op_image[pseudo_op_ptr].address = value;

	if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
	    printf("Too many pseudo ops\n");
	    exit(1);
	}
	sprintf(error,"Invalid pseudo op %s",op_code);
	return(-1);
    }
    switch(pseudo_num){
	case 15: /* .if */
		c=parameters[0];
    		if( (c>='0' && c<='9') || c=='-'){/*Constant*/
		    if(get_const(0,4,parameters,&value)){
                        sprintf(error,
			    "Invalid constant specified");
                    	return(-1);
                    }
		}
		else{ /* symbol */
		   for(i=found=0;i<sym_ptr;i++){
			if(!strcmp(sym_tab[i].symbol,parameters)){ 
                	    found=1;
                	    break;
            		}
        	    }

		    if(!found){
                        sprintf(error,
			    "symbol \"%s\" not previously defined",parameters);
                    	return(-1);
		    }
		    value=sym_tab[i].add;
		}
		if(conditional_state){
		    sprintf(error,
			  "Can't handle nested .if statements (maybe later)");
                    return(-1);
		}
		conditional_state=1;  /* .if encountered */
		generate_cond_code=(value)?1:0;

		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type = 0;
                pseudo_op_image[pseudo_op_ptr].address = value;

		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		break;
	case 7:  /* .else */
		if(conditional_state != 1){
		    sprintf(error,
			  ".else detected without previous .if");
                    return(-1);
		}
		conditional_state=2;  /* .else encountered */
		generate_cond_code=(generate_cond_code)?0:1;
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type = 0;

		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		break;
	case 9:  /* .endif */
		if(!conditional_state){
		    sprintf(error,
			  ".endif detected without previous .if or .else");
                    return(-1);
		}
		conditional_state=0;  /* out of .if .endif clause */
		generate_cond_code=1;
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type = 0;

		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		break;
	case 4:  /* .copy */
	case 16: /* .include */
		changed_file=1;
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type=0;
		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		if(parameters[0] != '"'){
		    sprintf(error,"File name must be a string");
		    return(-1);
		}
		parameters++;  len=strlen(parameters);
		if(parameters[len-1]!='"'){
		    sprintf(error,"Non terminated string");
		    return(-1);
		}
		parameters[len-1]=0;
		if(--fp_stack_pointer < 0){
		    printf("Too many levels of nested .include or .copy\n");
		    exit(1);
		}
		if( (sfp=fopen(parameters,"r")) == NULL){
		    printf("Can't open %s for read\n",parameters);
		    exit(1);
		}
		strcpy(file_name_stack[fp_stack_pointer],parameters);
		fp_stack[fp_stack_pointer]=sfp;
		break;
	case 3:  /* .byte */
		if( eval_line(parameters,line_num,error,0,1)) return(-1);
		break;
	case 13: /* .global */
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type = 0;
		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		if(eval_global_line(parameters,line_num,error)) return(-1);
		break;
	case 05: /* .data */
		current_section=1;
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type = 1;
		pseudo_op_image[pseudo_op_ptr].address
			= sec_loc_cnt[current_section].lc;
		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		break;
	case 12: /* .float */
		if(eval_line(parameters,line_num,error,1,4)) return(-1);
		break;
	case 14: /* .hword */
		if( eval_line(parameters,line_num,error,0,2)) return(-1);
		break;
	case 29: /* .sect */
		if(parameters[0]!='"'){
		    sprintf(error,"Section Name must be a string");
		    pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		    pseudo_op_image[pseudo_op_ptr].type=1;
		    pseudo_op_image[pseudo_op_ptr].address=0;
		    if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    	printf("Too many pseudo ops\n");
		    	exit(1);
		    }
		    return(-1);
		}
		parameters++;  len=strlen(parameters);
		if(parameters[len-1]!='"'){
		    sprintf(error,"Non terminated string");
		    pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		    pseudo_op_image[pseudo_op_ptr].type=1;
		    pseudo_op_image[pseudo_op_ptr].address=0;
		    if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    	printf("Too many pseudo ops\n");
		    	exit(1);
		    }
		    return(-1);
		}
		if(len>8){
		    sprintf(error,"Section name must be 8 characters or less");
		    pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		    pseudo_op_image[pseudo_op_ptr].type=1;
		    pseudo_op_image[pseudo_op_ptr].address=0;
		    if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    	printf("Too many pseudo ops\n");
		    	exit(1);
		    }
		    return(-1);
		}
		parameters[len-1]=0;
		for(i=0;i<MAX_SECTIONS;i++){  /* old section */
		    if(!strcmp(parameters,sec_loc_cnt[i].name)){
			current_section=i;
		        pseudo_op_image[pseudo_op_ptr].file_number
							    =fp_stack_pointer;
			pseudo_op_image[pseudo_op_ptr].type=1;
			pseudo_op_image[pseudo_op_ptr].address
			    = sec_loc_cnt[current_section].lc;
			if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    	    printf("Too many pseudo ops\n");
		    	    exit(1);
			}
			return(0);
		    }
		    else
			if(sec_loc_cnt[i].name[0] == 0) break;
		}
		for(i=0;i<MAX_SECTIONS;i++){  /* new section: find space */
		    if(sec_loc_cnt[i].name[0]==0){
			strcpy(sec_loc_cnt[i].name,parameters);
			sec_loc_cnt[i].loadable=1;
			current_section=i;
    			sym_tab[sym_ptr].obj_index=obj_sym_tab_ptr++;
			strcpy(sym_tab[sym_ptr].symbol,parameters);
			sym_tab[sym_ptr].add=0L;
			sym_tab[sym_ptr].section=i;
			sym_tab[sym_ptr].flags=0;
			if(++sym_ptr >= MAX_SYM_ENTRIES){
		    	    printf("Symbol table overflow\n");
		    	    exit(1);
	   		}
		        pseudo_op_image[pseudo_op_ptr].file_number
							    =fp_stack_pointer;
			pseudo_op_image[pseudo_op_ptr].type=1;
			pseudo_op_image[pseudo_op_ptr].address
			    = sec_loc_cnt[current_section].lc;
			if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    	    printf("Too many pseudo ops\n");
		    	    exit(1);
			}
			return(0);
		    }
		}
		sprintf(error,"Too many sections used");
		return(-1);
	case 35: /* .usect */
		index = -1;

		    /* Get section name */

		if(parameters[0]!='"'){
		    sprintf(error,"Section Name must be a string");
		    return(-1);
		}
		ptr=sym;
		for(i=1;parameters[i] != '"' && parameters[i] && i<MAX_SYM;i++)
		    *ptr++ = parameters[i];
		if(i>8){
		    sprintf(error,"Section name must be 8 characters or less");
		    return(-1);
		}
		*ptr=0;
		if(parameters[i]!='"'){
		    sprintf(error,"Non terminated string");
		    return(-1);
		}
		i++;	/* Get past quote */
		while(parameters[i]==' ' || parameters[i]=='\t') i++;
		if(parameters[i]!=','){
		    sprintf(error,"Comma missing before size field");
		    return(-1);
		}
		i++;	/* Get past comma */
		while(parameters[i]==' ' || parameters[i]=='\t') i++;
		if(eval_const(4,&parameters[i],error,&value))
		    return(-1);
		if(value <= 0){
		    sprintf(error,"Invalid size specified");
		    return(-1);
		}

		section = -1;
		for(i=0;i<MAX_SECTIONS;i++){  /* old section */
		    if(!strcmp(sym,sec_loc_cnt[i].name)){
			section=i;
		    }
		    else
			if(sec_loc_cnt[i].name[0] == 0) break;
		}
		if(section == -1){	/* new section: find space */
		  for(i=0;i<MAX_SECTIONS && section == -1;i++){  
		    if(sec_loc_cnt[i].name[0]==0){
			strcpy(sec_loc_cnt[i].name,sym);
			sec_loc_cnt[i].loadable=0;   /* Non loadable section */
			sec_loc_cnt[i].lc=0;
			section=i;
			index = -2;
    			sym_tab[sym_ptr].obj_index=obj_sym_tab_ptr++;
			strcpy(sym_tab[sym_ptr].symbol,sym);
			sym_tab[sym_ptr].add=0L;
			sym_tab[sym_ptr].section=i;
			sym_tab[sym_ptr].obj_index=i;
		    	sym_tab[sym_ptr].flags=C_NULL;

			if(++sym_ptr >= MAX_SYM_ENTRIES){
		    	    printf("Symbol table overflow\n");
		    	    exit(1);
	   		}
		    }
		  }
		}
		if( section == -1){
		    sprintf(error,"Too many sections used");
		    return(-1);
		}
		if(symbol_just_entered){ /* Fix symbol table */
		    sym_tab[sym_ptr+index].section=section;
		    sym_tab[sym_ptr+index].add=sec_loc_cnt[section].lc;
		}

		    /* update lc with space requested */

        	img_ptr->address=sec_loc_cnt[section].lc;
    		img_ptr->line_num=line_num;  
    		img_ptr->section=section;  
    		img_ptr->data=value;
		img_ptr->file_number=fp_stack_pointer;
    		inc_image_pointer();
		sec_loc_cnt[section].lc += value;
		return(0);
		break;
	case 2: /* .bss symbol,size */
		ptr=sym;  overrun=0;
		for(i=0;parameters[i] != ' ' && parameters[i] != ',' 
			&& parameters[i] != '\t' && i<(MAX_SYM-1);i++)
		    *ptr++ = parameters[i];
		if(parameters[MAX_SYM-1] != ' ' && parameters[MAX_SYM-1] != ',' 
			&& parameters[MAX_SYM-1] != '\t') overrun=1;
		*ptr=0;
		if(i==(MAX_SYM-1) && overrun){
		    sprintf(warning,"%02d %04d: Warning: symbol truncated to %s"
			,fp_stack_pointer,line_num,sym);
		    log_warning(warning);
		}
		while(parameters[i]!=',' && parameters[i]!='\n'
			&& parameters[i]) i++;
		if(parameters[i] != ','){
		    sprintf(error,"Size not specified");
		    return(-1);
		}
		i++;	/* Get past comma */
		while(parameters[i]==' ' || parameters[i]=='\t') i++;
		if(eval_const(4,&parameters[i],error,&value))
		    return(-1);
		if(value <= 0){
		    sprintf(error,"Invalid size specified");
		    return(-1);
		}

		  /* place symbol in symbol table and update location counter*/

		strcpy(sym_tab[sym_ptr].symbol,sym);
		sym_tab[sym_ptr].add = sec_loc_cnt[BSS].lc;
		sym_tab[sym_ptr].section = BSS;
		sym_tab[sym_ptr].obj_index = DO_NOT_PUT_IN_OBJECT_MODULE;
		if(++sym_ptr >= MAX_SYM_ENTRIES){
		    printf("Symbol table overflow\n");
		    exit(1);
	   	}
        	img_ptr->address=sec_loc_cnt[BSS].lc;
    		img_ptr->line_num=line_num;  
    		img_ptr->section=BSS;  
    		img_ptr->data=value;
		img_ptr->file_number=fp_stack_pointer;
    		inc_image_pointer();
		sec_loc_cnt[BSS].lc += value;
		return(0);
		break;
	case 33: /* .text */
		current_section=0;
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type=1;
		pseudo_op_image[pseudo_op_ptr].address
			= sec_loc_cnt[current_section].lc;
		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		break;
	case 17: /* .int */
	case 21: /* .long */
	case 37: /* .word */
		if( eval_line(parameters,line_num,error,0,4)) return(-1);
		break;
	case 30: /* .set */
		constant_parm=0;
		c=parameters[0];
    		if( (c>='0' && c<='9') || c=='-'){/*Constant*/
		    if(get_const(0,4,parameters,&value)){
                        sprintf(error,
			    "Invalid constant specified for size field");
                    	return(-1);
                    }
		    constant_parm=1;
		}
		else{ /* symbol */
		   for(i=found=0;i<sym_ptr;i++){
			if(!strcmp(sym_tab[i].symbol,parameters)){ 
                	    found=1;
                	    break;
            		}
        	    }

		    if(!found){
                        sprintf(error,
			    "symbol \"%s\" not previously defined",parameters);
                    	return(-1);
		    }
		    value=sym_tab[i].add;
		}
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type = 2;
		pseudo_op_image[pseudo_op_ptr].value = value;
		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		if(!symbol_just_entered){
		    sprintf(error,"Label is required for .set pseudo op.");
		    return(-1);
		}
		if(constant_parm){
		    sym_tab[sym_ptr-1].section=SET_SYMBOL; 
		    sym_tab[sym_ptr-1].add=value; /* overwrite previous label */
		}
		else{ /* Copy symbol table entry */
		    sym_tab[sym_ptr-1].add=sym_tab[i].add; 
		    sym_tab[sym_ptr-1].section=sym_tab[i].section; 
		    sym_tab[sym_ptr-1].obj_index=sym_tab[i].obj_index; 
		    sym_tab[sym_ptr-1].flags=sym_tab[i].flags; 
		}
		break;
	case 18: /* .label */
		pseudo_op_image[pseudo_op_ptr].file_number=fp_stack_pointer;
		pseudo_op_image[pseudo_op_ptr].type=1;
		pseudo_op_image[pseudo_op_ptr].address
			= sec_loc_cnt[current_section].lc;
		if(++pseudo_op_ptr >= MAX_PSEUDO_OPS){
		    printf("Too many pseudo ops\n");
		    exit(1);
		}
		ptr=sym;  overrun=0;
		for(i=0;parameters[i] != ' ' && parameters[i] != ';' 
			&& parameters[i] != '\t' && parameters[i] != '\n' 
			&& parameters[i] && i<(MAX_SYM-1);i++)
		    *ptr++ = parameters[i];
		if(parameters[MAX_SYM-1] != ' ' && parameters[MAX_SYM-1] != ';' 
			&& parameters[MAX_SYM-1] != '\t'
			&& parameters[MAX_SYM-1] != '\n'
			&& parameters[MAX_SYM-1]) overrun=1;
		*ptr=0;
		if(i==(MAX_SYM-1) && overrun){
		    sprintf(warning,"%02d %04d: Warning: symbol truncated to %s"
			,fp_stack_pointer,line_num,sym);
		    log_warning(warning);
		}
		strcpy(sym_tab[sym_ptr].symbol,sym);
 		sym_tab[sym_ptr].add=sec_loc_cnt[current_section].lc;
		sym_tab[sym_ptr].section=current_section;
		sym_tab[sym_ptr].obj_index = DO_NOT_PUT_IN_OBJECT_MODULE;
		sym_tab[sym_ptr].flags = C_STATLAB;  /* Static .label */
		if(++sym_ptr >= MAX_SYM_ENTRIES){
		    printf("Symbol table overflow\n");
		    exit(1);
	   	}
		break;
	default:  /* Not implemented */
	        sprintf(error,"pseudo_op \"%s\" is not implemented"
		    ,pseudo_op_table[pseudo_num]);
		return(-1);
    }
    return(return_val);
}

eval_global_line(parameters,line_num,error)
char *parameters,*error;
int line_num;
{
    char expr[100],*ptr=expr;

    for( ; *parameters; parameters++){
	if(*parameters != ','){
	    *ptr++ = *parameters;
    	}
    	else{  /* put symbol into global list */
	    *ptr=0;  ptr=expr;  
	    if(strlen(expr) > (MAX_SYM-1)){
		sprintf(warning,"%02d %04d: Warning: symbol %s truncated to "
		    ,fp_stack_pointer,line_num,expr);
		expr[MAX_SYM-1]=0;
		strcat(warning,expr);
		log_warning(warning);
	    }
	    strcpy(global_list[global_ptr],expr);
	    if(++global_ptr >= MAX_GLOBALS){
		sprintf(error,"Too many globals defined (%d is max)\n"
		,MAX_GLOBALS);
		return(-1);
	    }
    	}
    }
    *ptr=0;
    if(expr[0]){
	if(strlen(expr) > (MAX_SYM-1)){
	    sprintf(warning,"%02d %04d: Warning: symbol %s truncated to "
		,fp_stack_pointer,line_num,expr);
	    expr[MAX_SYM-1]=0;
	    strcat(warning,expr);
	    log_warning(warning);
	}
	strcpy(global_list[global_ptr],expr);
	if(++global_ptr >= MAX_GLOBALS){
	    sprintf(error,"Too many globals defined (%d is max)\n",MAX_GLOBALS);
	    return(-1);
	}
    }
    return(0);
}

eval_const(num_bytes,expr,error,value)
int num_bytes;
char *expr,*error;
unsigned long *value;
{
    int return_val=0;
    int i,found;
    unsigned long tmp;

    if( (expr[0]>='0' && expr[0]<='9') || expr[0]=='-'){	/* Constant */
	return_val=get_const(0,num_bytes,expr,&tmp);
	*value=tmp;
	if(return_val){
	    if(return_val == -1)
		sprintf(error,"Invalid Constant");
	    else
		sprintf(error,"Constant too large");
	 }
    }
    else{	/* Symbol, Charactor or String */
	if(expr[0]=='\''){ /* Character */
	    *value=(unsigned long)expr[1];
	}
	else if(expr[0]=='"'){ /* String */
	    *value=0L;
	}
	else{ /* Symbol (search through .set list) */
	    for(i=found=0;i<sym_ptr;i++){
		if(!strcmp(sym_tab[i].symbol,expr)){ 
                    found=1;
                    break;
            	}
            }
	    if(!found){
                 sprintf(error,"symbol \"%s\" not previously defined"
		    ,expr);
                 return(-1);
	    }
	    *value=sym_tab[i].add;
	}
    }
    return(0);
}
