/* A sample multitasking program. */

#include "stdio.h"

/*******************************************************
   Include these definitions in any file that 
   uses the multitasking kernel.  You may want to
   put these into a header file which you simply include.
*********************************************************/

typedef int (far *taskptr) (void);

int make_task(taskptr task, unsigned stck, 
              int id);
void interrupt multitask(void);
void init_tasks(void);
void kill_task(int id);
void interrupt task_switch(void);
void set_semaphore(unsigned *sem), mono_task(void);
void clear_semaphore(unsigned *sem);
void semblock(int id, unsigned *sem);
void stop_tasking(void), msleep(int ticks);
void suspend(int id), resume(int id);
void task_status(void), resume_tasking(void);

void mputnum(int num), mputs(char *s);
char mgetche(void);
void moutchar(int x, int y, char ch);
void mxyputs(int x, int y, char *str);

/**************************************************/


void f2(void), f1(void), f3(void);
void f4(void), f5(void);

int i=0, j=0, k=0, l=0, m=0;

main(void)
{
  init_tasks(); 

  make_task((taskptr) f1, 1024, 0);
  make_task((taskptr) f2, 1024, 1);
  make_task((taskptr) f3, 1024, 2);
  make_task((taskptr) f4, 1024, 3);
  make_task((taskptr) f5, 1024, 4);

  multitask();
  printf("done\n");
  printf("counters: %d %d %d %d %d", i, j, k, l, m);
  task_status();

  return 0;
}

void f1(void)
{
  mxyputs(20, 0, "starting task 0");
  for(;;i++) {
    mputnum(i);
  }
}

void f2(void)
{
  char ch;

  mxyputs(20, 1, "starting task 1");
  for(;;j++) {
    mputs("type a key ('q' to quit)");
    ch = mgetche();
    if(ch=='q') kill_task(1);
    mputnum(ch);
  }
}

void f3(void)
{
  mxyputs(20, 2, "starting task 2");
  for(; k<30000; k++) {
     moutchar(k%24, k%24, 'A'+(k%26));
  }
  kill_task(2);
}

void f4(void)
{
  mxyputs(20, 3, "starting task 3");
  for(; l<30000; l++) {
    moutchar(79-l%24, l%24, 'A'+(l%26));
  }
  kill_task(3);
}

void f5(void)
{
  mxyputs(20, 4, "starting task 4");
  msleep(200);
  m++;
  kill_task(0);
  kill_task(4);
}
