

/* This program saves what is currently on the screen
   in the disk file specified on the command line.

   It assumes that the computer is using an 80-column
   text video mode.
*/

#include "dos.h"
#include "stdio.h"
#include "stdlib.h"

void save_screen(char *fname), goto_xy(int x, int y);

main(int argc, char *argv[])
{
  if(argc!=2) {
    printf("usage: screen <filename>");
    exit(1);
  }
  save_screen(argv[1]);

  return 0;
}

/* Save the contents of the screen to a disk file. */
void save_screen(char *fname)
{
  FILE *fp;
  union REGS r;
  register char x, y;

  if(!(fp=fopen(fname, "w"))) {
    printf("cannot open file");
    exit(1);
  }

  for(y=0; y<25; y++)
    for(x=0; x<80; x++) {
      goto_xy(x, y);
      r.h.ah = 8; /* read a character */  
      r.h.bh = 0; /* video page */
      int86(0x10, &r, &r);
      putc(r.h.al, fp); /* write the character */
    }
  fclose(fp);
}

/* Send the cursor to the specified X,Y position. */
void goto_xy(int x, int y)
{
  union REGS r;

  r.h.ah = 2; /* cursor addressing function */
  r.h.dl = x; /* column coordinate */
  r.h.dh = y; /* row coordinate */
  r.h.bh = 0; /* video page */
  int86(0x10, &r, &r);
}

