
/* A simple graphics presentation program. */

#include "stdio.h"
#include "dos.h"
#include "stdlib.h"
#include "conio.h"

void load_pic(char *fname);
void palette(int pnum);
void mode(int mode_code);
void goto_xy(int x, int y);

main(int argc, char *argv[])
{
  if(argc!=2) {
    printf("usage: show <filename>");
    exit(1);
  }

  mode(4);
  palette(0);

  load_pic(argv[1]);

  getch();
  mode(3);

  return 0;
}

/* Load the video graphics display. */
void load_pic(char *fname)
{
  FILE *fp;
  register int i;

  /* pointer to mode 4 graphics RAM */
  char far *ptr = (char far *) 0xB8000000; 

  if(!(fp=fopen(fname, "rb"))) {
    printf("Cannot open file\n");
    return ;
  }

  /* load image from file */
  for(i=0; i<8152; i++) { 
    *ptr = getc(fp); /* even byte */
    *(ptr+8152) = getc(fp); /* odd byte */
    ptr++;
  }

  fclose(fp);
}

/* Set the palette. */
void palette(int pnum)
{
  union REGS r;

  r.h.bh = 1;   /* code for palette select */
  r.h.bl = pnum;
  r.h.ah = 11;  /* set palette function */
  int86(0x10, &r, &r);
}

/* Set the video mode. */
void mode(int mode_code)
{
  union REGS r;

  r.h.al = mode_code;
  r.h.ah = 0;
  int86(0x10, &r, &r);
}

/* Send the cursor to the specified X,Y position. */
void goto_xy(int x, int y)
{
  union REGS r;

  r.h.ah = 2; /* cursor addressing function */
  r.h.dl = x; /* column coordinate */
  r.h.dh = y; /* row coordinate */
  r.h.bh = 0; /* video page */
  int86(0x10, &r, &r);
}

