#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

#define TRUE 1
#define DATA "done"
#define PROG "/net/wolf/c60c-3/sp91/labc-3id/C/ipc/sw2"

/*
 * This program uses select() to check that someone is trying to connect
 * before calling accept(). 
 */

main(argc, argv)
     int argc;
     char *argv[];
{
  int sock, length;
  struct sockaddr_in server;
  int msgsock;
  char buf[1024];
  int rval;
  fd_set ready;
  struct timeval to;

  char command[120];
  char hname[80];
  
  struct hostent *hp, *gethostbyname();

  if(argc < 2) {
    perror("not enough args");
    exit(1);
  }

  (void) gethostname(hname, 80);
  /* Create socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) {
    perror("opening stream socket");
    exit(1);
  }
  /* Name socket using wildcards */
  server.sin_family = AF_INET;
  server.sin_addr.s_addr = INADDR_ANY;
  server.sin_port = 0;
  if (bind(sock, &server, sizeof(server))) {
    perror("binding stream socket");
    exit(1);
  }
  /* Find out assigned port number and print it out */
  length = sizeof(server);
  if (getsockname(sock, &server, &length)) {
    perror("getting socket name");
    exit(1);
  }
  printf("Socket has port #%d\n", ntohs(server.sin_port));
  
  /*  addition  */
  hp = gethostbyname(argv[1]);
  if (hp == 0) {
    fprintf(stderr, "%s: unknown host\n", argv[1]);
    exit(2);
  }
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  /*  end addition  */
  
  /* Start accepting connections */
  listen(sock, 5);

  sprintf(command, "rsh %s '%s %s %d' &",
	  argv[1], PROG, hname, ntohs(server.sin_port));
  printf("%s\n", command);
  system(command);
  
  FD_ZERO(&ready);
  FD_SET(sock, &ready);
  to.tv_sec = 30;
  if (select(sock + 1, &ready, 0, 0, &to) < 0) {
    perror("select");
  }
  if (FD_ISSET(sock, &ready)) {
    msgsock = accept(sock, (struct sockaddr *)0, (int *)0);
    if (msgsock == -1)
      perror("accept");
    else {
      bzero(buf, sizeof(buf));
      if ((rval = read(msgsock, buf, 1024)) < 0)
	perror("reading stream message");
      else if (rval == 0)
	printf("Connection broken\n");
      else {
	printf("-->%s\n", buf);
	/*  execute the XOpenDisplay here  */
	write(msgsock, DATA, sizeof(DATA));
      }
    }
    close(msgsock);
  }
  else printf("Connection timed out\n");
    
  printf("Read exiting\n");
}
