#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

#define DATA "bogus"
  
  /*
   * This program creates a socket and initiates a connection with the socket
   * given in the command line.  One message is sent over the connection and
   * then the socket is closed, ending the connection. The form of the command
   * line is streamwrite hostname portnumber 
   */
  
main(argc, argv)
     int argc;
     char *argv[];
{
  int sock;
  struct sockaddr_in server;
  struct hostent *hp, *gethostbyname();
  char buf[1024];

  char command[80];

  int msgsock;
  int rval;
  fd_set ready;
  struct timeval to;
  
  if(argc < 3) {
    perror("not enough command line arguments");
    exit(1);
  }
  
/*  socket setup  */
  /* Create socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) {
    perror("opening stream socket");
    exit(1);
  }
  /* Connect socket using name specified by command line. */
  server.sin_family = AF_INET;
  hp = gethostbyname(argv[1]);
  if (hp == 0) {
    fprintf(stderr, "%s: unknown host\n", argv[1]);
    exit(2);
  }
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  server.sin_port = htons(atoi(argv[2]));
  
  if (connect(sock, &server, sizeof(server)) < 0) {
    perror("connecting stream socket");
    exit(1);
  }


/*  set up clock, attempt to open display, if opened display,
 *  do xhost +.  Regardless, return sucess code.
 *  If successful, wait 5 seconds for reply.  After this, 
 *  whether server has replied or not, shut down
 */

  sprintf(buf, "success code");
  if (write(sock, buf, sizeof(buf)) < 0)
    perror("writing on stream socket");

  FD_ZERO(&ready);
  FD_SET(sock, &ready);
  to.tv_sec = 5;
  if (select(sock + 1, &ready, 0, 0, &to) < 0) {
    perror("select");
  }
  if (FD_ISSET(sock, &ready)) {
    bzero(buf, sizeof(buf));
    if ((rval = read(sock, buf, 1024)) < 0)
      perror("reading stream message");
    else if (rval == 0)
      printf("Ending connection\n");
    else {
      printf("Received-->%s\n", buf);
    }
  }
  else 
    printf("No messages received - exiting\n");
  close(sock);

  printf("Write exiting\n");

/*
 *  do all the xhost -ing here, if necessary, then shut down
 */
}
