/*
|	FILE: UNTIL.H
|
|	This program is contains the source code for the program
|	CALC.CPP. It is code from:
|
|		Writing Your Own Application Language
|
|	Published by:
|		Wordware Publishing, Inc.
|		1506 Capital Avenue
|		Plano, Texas 75074
|
|	Written by:
|		Norman E. Smith, CDP
|		Copyright 1992 
|		All Rights Reserved
|
|	Right to use, copy, and modify this code is granted
|	for personal non-commercial use, provided that this
|	copyright disclosure remains on ALL copies. Any other 
|	use, reproduction, or distribution requires the written 
|	consent of the author.
*/



const int TIBSIZE   = 256;
const int PADSIZE   = 128;
const int PSTACKSIZE= 64;
const int RSTACKSIZE= 32;
const int PFA_SIZE  = 100;
const NUM_FILES     = 2;
const TRUE          = 1;
const FALSE         = 0;
const BLANK         = ' ';


#ifdef until

// ********************************************************
//		CONSTANST FOR BUFFER SIZES AND SUCH
//
/**********************************************************
|		STARTUP DATA STRUCTURE
*/
const char CALC_VERSION[]     = "1.2";
const int  Vers               = 1;
const char DATE[]             = "JANUARY 1992";
// ********************************************************
//		UNTIL REGISTERS
//
FILE *FD[NUM_FILES];
long INPUT_SOURCE;	// Where the compiler reads from
long this_file;
long tib_len;
long pfa_offset;
long SP;		// Param Stack Pointer
long RS;                // Return Stack Pointer
long START = 1;		// Startup flag
long IN;
long STATE;		// compile state 0=Interpret 1=compile
static long INPUT_SOURCE;	// Where the compiler reads from

// ****************************************************************
//			Buffers and other Data Structures
//
char tib[TIBSIZE];
char pad[PADSIZE];
long pstack[PSTACKSIZE];
long rstack[RSTACKSIZE];

// ************************************************************
//			OTHER STUFF
//
int I;
union cell_types{
	char  C;
	short S;
	int   I;
	long  L;
	void  *P;
} cell;

long ABORT;
long QUIT;
char PROMPT[20]     = "CALC> ";
char the_cold_msg[] = "Cold Start...\n";

/*************************************************************
|               VECTORED WORDS
*/
char *(*READ_WA)();

/*************************************************************
|
*/
struct NameField {
	int  len;
	int  immediate;
	int  smudge;
	char *name;
};

struct DictHeader {
	void (*CFA)();		// ptr to primitive function
	union pfa_type{
		DictHeader **Waddr;
		long       lvalue;
		char       cvalue;
		long       *l_ptr;
		char       *c_ptr;
	} PFA;			// ptr to list of words to execute
	NameField  *NFA;	// ptr to name string
	DictHeader *LFA;	// points to next word in dict.
};

DictHeader **IP;		// Instrcution Pointer
DictHeader *DP;			// Dictionary Pointer
DictHeader *WA;			// Word Address Register
DictHeader *pfa_list[PFA_SIZE];	// Temp area to compile list of pfa's
DictHeader *LIT_WA;		// lit Word Address
DictHeader *ZERO_BRAN_WA;
DictHeader *BRANCH_WA;
DictHeader *QUOTE_WA;
DictHeader *DOT_QUOTE_WA;
DictHeader *LOOP_WA;
DictHeader *DO_WA;
DictHeader *I_WA;
DictHeader *NAME0_WA;

#else

// ********************************************************
//		UNTIL REGISTERS
//
extern FILE *FD[];
extern long INPUT_SOURCE;	// Where the compiler reads from
extern long this_file;
extern long tib_len;
extern long pfa_offset;
extern long SP;		// Param Stack Pointer
extern long RS;                // Return Stack Pointer
extern long START;		// Startup flag
extern long IN;
extern long STATE;		// compile state 0=Interpret 1=compile
extern long INPUT_SOURCE;	// Where the compiler reads from
// extern static long INPUT_SOURCE;	// Where the compiler reads from

/**********************************************************
|		STARTUP DATA STRUCTURE
*/
extern const char CALC_VERSION[];
extern const int  Vers;
extern const char DATE[];
// ****************************************************************
//			Buffers and other Data Structures
//
extern char tib[TIBSIZE];
extern char pad[PADSIZE];
extern long pstack[PSTACKSIZE];
extern long rstack[RSTACKSIZE];

// ************************************************************
//			OTHER STUFF
//
extern int I;
union cell_types{
	char  C;
	short S;
	int   I;
	long  L;
	void  *P;
} extern cell;

extern long ABORT;
extern long QUIT;
// extern static long QUIT;
// extern static long ABORT;
extern char PROMPT[20];
extern char the_cold_msg[];

/*************************************************************
|               VECTORED WORDS
*/
extern char *(*READ_WA)();

/*************************************************************
|
*/
struct NameField {
	int  len;
	int  immediate;
	int  smudge;
	char *name;
};

struct DictHeader {
	void (*CFA)();		// ptr to primitive function
	union pfa_type{
		DictHeader **Waddr;
		long       lvalue;
		char       cvalue;
		long       *l_ptr;
		char       *c_ptr;
	} PFA;			// ptr to list of words to execute
	NameField  *NFA;	// ptr to name string
	DictHeader *LFA;	// points to next word in dict.
};

extern DictHeader **IP;			// Instrcution Pointer
extern DictHeader *DP;			// Dictionary Pointer
extern DictHeader *WA;			// Word Address Register
extern DictHeader *pfa_list[];		// Temp area to compile list of pfa's
extern DictHeader *LIT_WA;		// lit Word Address
extern DictHeader *ZERO_BRAN_WA;
extern DictHeader *BRANCH_WA;
extern DictHeader *QUOTE_WA;
extern DictHeader *DOT_QUOTE_WA;
extern DictHeader *LOOP_WA;
extern DictHeader *DO_WA;
extern DictHeader *I_WA;
extern DictHeader *NAME0_WA;
#endif


// ********************************************************
//		FUNCTION PROTOTYPES
void cold();
NameField *CreateNFA(char*);
void Create();
void Compile_colon();
void Compile_variable();
void Compile_constant();
void do_variable();
void do_constant();
void do_primitive();
void do_colon(DictHeader *);
void do_colon();
void do_word(DictHeader *);
void drop();
void word();
void build_pfa_list();
int  prim_find();
void minus_find();
void to_null();
void counted_to_null(char *,char *);
void null_to_counted(char *, char*);
void build_primitive(char*, void(*)());
void build_iprim(char*, void(*)());
void exec_word();
void store();
void times();
void divide();
void prim_dup();
void swap();
void plus();
void minus();
void one_minus();
void less_than();
void greater_than();
void equals();
void dot();
DictHeader* set_WA(char*);
void immediate();
void words();
void zero();
void one();
void two();
void three();
void prompt();
void bye();
void abort_F();
void abort_quote();
void read_next_line();
char *read_stdin();
char *read_include();
void close_include();
void number();
void outer();
void cr();
void make_prims();
void dot_s();
void gdot_s();
void addr_tib();
void count();
void next_word();
void dot_paren();
void parens();
void semi();
void rfetch();
void to_r();
void r_from();
void literal();
void do_lit();
void type();
void mod();
void state();
void dot_quote();
void quote();
void rot();
void Compile_i();
void do_i();
void do_do();
void do_loop();
void zero_bran();
void branch();
void Compile_dot_quote();
void Compile_quote();
void Compile_abort_quote();
void Compile_if();
void Compile_endif();
void Compile_else();
void Compile_do();
void Compile_loop();
void startup();
void do_autoload();
void help();
void tabs_to_blanks(char* string);
void pushsp(long);
long popsp();
void pushrs(long);
long poprs();
void cls();
void do_create();
void fetch();
void question();
