/*
|	FILE: USER.CPP
|
|	This program is contains the source code for the program
|	CALC.CPP. It is code from:
|
|		Writing Your Own Application Language
|
|	Published by:
|		Wordware Publishing, Inc.
|		1506 Capital Avenue
|		Plano, Texas 75074
|
|	Written by:
|		Norman E. Smith, CDP
|		Copyright 1992 
|		All Rights Reserved
|
|	Right to use, copy, and modify this code is granted
|	for personal non-commercial use, provided that this 
|	copyright disclosure remains on ALL copies. Any other 
|	use, reproduction, or distribution requires the written 
|	consent of the author.
*/

#include <stdio.h>

#define until
#include "until.h"
/***********************+------------+****************************
|			| make_prims |
|			+------------+
|
|  NOTE: The way words are linked, the dict order is "bottom-up"
|	 in terms of search order. The order has no affect on
|	 run-time. More fequently used words should be at the
|	 end of the list to speed up compilation.
*/
void make_prims()
{
	build_primitive("i",do_i);
	build_primitive("create",do_create);
	build_primitive("lit",do_lit);
	build_primitive("var",Compile_variable);
	build_primitive("const",Compile_constant);
	build_primitive("=",dot);
	build_primitive("cr",cr);
	build_primitive("==",equals);
	build_primitive(">",greater_than);
	build_primitive("<",less_than);
	build_primitive("-",minus);
	build_primitive("+",plus);
	build_primitive("?",question);
	build_primitive("swap",swap);
	build_primitive("dup",prim_dup);
	build_primitive("rot",rot);
	build_primitive("/",divide);
	build_primitive("*",times);
	build_primitive("->",store);
	build_primitive("<-",fetch);
	build_primitive("drop",drop);
	build_primitive("macros",words);
	build_primitive("0",zero);
	build_primitive("1",one);
	build_primitive("2",two);
	build_primitive("3",three);
	build_primitive("abort",abort_F);
	build_primitive("s?",dot_s);
	build_primitive(".s",gdot_s);
	build_primitive("cls",cls);
	build_primitive("rem",mod);
	build_primitive("0bran",zero_bran);
	build_primitive("branch",branch);
	build_primitive("quote",quote);
	build_primitive(".quote",dot_quote);
	build_primitive("do_do",do_do);
	build_primitive("do_loop",do_loop);
	build_primitive("exit",bye);
	build_primitive("help",help);

	build_iprim("m{",Compile_colon);
	build_iprim("}m",semi);
	build_iprim("{",parens);
	build_iprim("if",Compile_if);
	build_iprim("else",Compile_else);
	build_iprim("endif",Compile_endif);
	build_iprim("\"",Compile_dot_quote);
	build_iprim("(",Compile_do);
	build_iprim(")",Compile_loop);

	LIT_WA        = set_WA("lit");
	ZERO_BRAN_WA  = set_WA("0bran");
	BRANCH_WA     = set_WA("branch");
	QUOTE_WA      = set_WA("quote");
	DOT_QUOTE_WA  = set_WA(".quote");
	DO_WA         = set_WA("do_do");
	LOOP_WA       = set_WA("do_loop");
	I_WA          = set_WA("i");
}
