/* WordUp Graphics Toolkit
   Copyright 1992 Chris Egerter
*/

typedef unsigned char far * block;

#define false 0
#define true 1

#define up 0
#define down 1
#define left 2
#define right 3

#define vertical 0
#define horizontal 1

extern unsigned char currentcolor;
extern block abuf;
extern int but,mx,my;

typedef struct {
	unsigned char r,g,b;
	} color;

extern void vga256(void);

// drawing functions
extern void wbar(int,int,int,int);
extern void wbutt(int,int,int,int);
extern void wcircle(int,int,int);
extern void wcls(int);
extern void wfill_circle(int,int,int);
extern int  wgetpixel(int,int);
extern void wline(int,int,int,int);
extern void wputpixel(int,int);
extern void wrectangle(int,int,int,int);


// block functions

extern void  wcopyscreen(int,int,int,int,block ,int,int,block );
extern void  wflipblock(block ,int);
extern void  wfreeblock(block );
extern int   wgetblockheight(block);
extern int   wgetblockwidth(block);
extern block wloadblock(char *);
extern block wloadpak(char *);
extern int   wloadpcx256(char *,color *);
extern block wnewblock(int,int,int,int);
extern void  wnormscreen(void);
extern void  wputblock(int,int,block ,int);
extern void  wresize(int,int,int,int,block);
extern int   wsaveblock(char *,block );
extern int   wsavepak(char *,block );
extern void  wsetscreen(block);
extern void  wvertres(block,int,int);



// mouse functions
extern int  minit(void);
extern void moff(void);
extern void mon(void);
extern void mouseshape(int,int,void far *);
extern void mread(void);
extern void msetbounds(int, int, int, int);
extern void msetspeed(int,int);			
extern void msetthreshhold(int);		 
extern void noclick(void);



// palette functions
extern void wcolrotate(int,int,int,color[256]);
extern void wfade_out(int,int,int,color[256]);
extern void wfade_in(int,int,int,color[256]);
extern void wloadpalette(char[12],color *);
extern void wsavepalette(char[12],color *);
extern void wsetcolor(int);
extern void wsetpalette(int,int,color *);
extern void wsetrgb(int,int,int,int,color *);


// text functions
extern void wflashcursor(void);
extern void woutchar(int, int, int);
extern void wouttextxy(int,int,char *);
extern void wsetcursor(int,int);
extern int  wstring (int, int, char *, char *, int);
extern void wtextbackground(unsigned char);
extern void wtextcolor(unsigned char);
extern void wtextgrid(int);
extern void wtexttransparent(int);
extern int curspeed,xc,yc;

// fill routines
extern void  wregionfill(int,int);			// fills an area

// special FX
extern void wfade(block ,int *,int);
extern void wwipe(int,int,int,int,block);		// wipe

// misc
extern void wclip(int,int,int,int);
extern void wretrace(void);

