'ͻ
' Source File    X10_EXMP.BAS                                              
'                                                                          
' System         X-10 Professional Developers Library for QuickBasic 4.5   
'                                                                          
' Purpose        Example X-10 program for:  Morrison, Dale & Jeanie        
'                                           Kent, WA                       
'                                                                          
' Author         Dale Morrison                                             
' Copyright      Smart Home Technology, 1993                               
'ͼ
'
'Ŀ
' Load the file containing declarations and constants for the X10_PDLB.LIB  
'
'$INCLUDE: '\BC7\X10_PDLB\X10_PDLB.BI'

'Ŀ
' Your basic clear the screen command                                       
'
CLS

'Ŀ
' Define your custom variables that are initialized in the Startup procedure
'
DIM SHARED JrIsWorking%, CancelBedtime%

'Ŀ
' Define the interrupt address for the x10 driver                           
'
Addr523% = &H60

'Ŀ
' Open communications to the resident TW523 driver                          
'
OpenTW523 SinglePhase

'Ŀ
' Do your Startup procedure to initialize your modules and variables        
'
Startup

'Ŀ
' Start a timer to be used for saving the status of the modules             
'
StartTimer 0, 60

'Ŀ
' Now check to see if there was a power outage since the last boot up       
'
IF PowerOutage% THEN
    LoadStatus
    PlayCatchup
END IF

'
'Ŀ
' Start the loop to monitor your schedule until a keypress                  
'
DO

    'Ŀ
    ' Get the current system time based on the 24 hour clock, ie: 23:00     
    '
    X10Time$ = GetTime$

    'Ŀ
    ' Get the next received X-10 command from the driver, Null if none      
    '
    X10Cmd$ = GetX10Cmd$

    IF PowerOutage% THEN
        LOCATE , 1
        PRINT TIME$ + "  " + DATE$;
        LOCATE , 1
    END IF

    'Ŀ
    ' The part of your schedule that deals with time of day events          
    '

    IF X10Time$ = "05:00" THEN                  ' Dales wakeup time
        TurnModule "F01", xOn                   '       Coffee pot on
        IF X10Time$ < Dawn$ THEN                '       If its still dark
            TurnAllModules "O", xOff            '           Outside lights off
            DimModule "E05", 8                  '           Stove light to 8
        END IF
    END IF

    IF X10Time$ = Dawn$ THEN                    ' First morning light
        TurnAllModules "E", xOff                '       Inside lights off
        TurnAllModules "O", xOff                '       Outside lights off
    END IF

    IF X10Time$ = "20:00" THEN                  ' Boys strip to underware time
        FlashModule "E02", 15                   '       Flash table lamp
    END IF

    IF X10Time$ = "20:15" THEN                  ' Boys pajamas time
        FlashModule "E03", 15                   '       Flash living ovhd
    END IF

    IF X10Time$ = "20:30" THEN                  ' Boys get toys for bed
        TurnModule "E06", xOn                   '       Playroom light on
    END IF

    IF X10Time$ = "21:00" THEN                  ' Boys already in bed
        TurnModule "E06", xOff                  '       Playroom light off
        TurnModule "F01", xOff                  '       Coffee pot off
    END IF

    IF X10Time$ = "21:30" THEN                  ' Dales Bedtime
        SelectModule "E01"                      '       Living room flourescents
        SelectModule "E03"                      '       Living room ovhd lights
        SelectModule "E04"                      '       Kitchen stove light
        SelectModule "E05"                      '       Kitchen ovhd lights
        SelectModule "E06"                      '       Playroom lights
        TurnSelModules xOff                     '       Turn them all off
        DimModule "E02", 10                     '       Living table lamp to 10
        TurnModule "E05", xOn                   '       Kitchen ovhd lights on
        DimModule "G03", 5                      '       Master bed lights to 5
    END IF
    '

    IF X10Time$ = Dusk$ THEN                    ' Its now dark outside
        TurnAllModules "O", xOn                 '       Outside lights on
    END IF

    IF X10Time$ = "23:50" THEN                  ' 10 minutes before jr comes home
        DimModule "E02", 8                      '       Living table lamp to 8
        DimModule "E05", 9                      '       Kitchen ovhd lights to 9
        Pause 10                                '       Let house adjust
        TurnModule "O01", xOff                  '       Front porch light off
        Pause 3                                 '       Force motion light on
        TurnModule "O01", xOn                   '       Front porch light on
        ResetMotion% = Yes
    END IF

    IF X10Time$ = "00:01" THEN                  ' Its a new day so set variables
        LoadSunTimes                            '       Load the sun time variables
        DayOfWeek$ = GetDow$                    '       Get the day of the week
        X10Date$ = DATE$                        '       Get todays date

        IF DayOfWeek$ = "Sun" OR DayOfWeek$ = "Mon" THEN    ' If jr does not work today
            JrIsWorking% = No                               '   Set flag saying such
            CancelBedtime% = Yes                            '   and cancel dales bedtime
        ELSE                                                ' If jr does work today
            JrIsWorking% = Yes                              '   Set flag saying such
            CancelBedtime% = No                             '   dont cancel dales bedtime
        END IF

        DisplayX10Globals

        PRINT "    Jr is working: ";
        IF JrIsWorking% THEN PRINT "Yes" ELSE PRINT "No"
        PRINT

    END IF

    IF X10Time$ = "00:30" AND ResetMotion% THEN ' Jr is home by now
        TurnModule "O01", xOff                  '       Front porch light off
        Pause 10                                '       Force back to sense motion
        TurnModule "O01", xOn                   '       Front porch light on
        ResetMotion% = No
    END IF

    IF X10Time$ = "02:00" THEN                  ' Safety reasons
        TurnAllModules "E", xOff                '       All inside lights off
        TurnAllModules "F", xOff                '       All appliance modules off
        TurnAllModules "G", xOff                '       All bedroom lights off
    END IF

    'Ŀ
    ' The part of your schedule that deals with the received X-10 commands  
    '

    IF X10Cmd$ = "G01 Off" THEN                 ' Master bedroom ctrler
        TurnAllModules "E", xOff                '       All insides lights off
        TurnAllModules "G", xOff                '       Master bed lights off
    END IF
    '

    IF X10Cmd$ = "G01 On" THEN                  ' Master bedroom ctrler
        TurnAllModules "E", xOn                 '       All inside lights on
        TurnAllModules "G", xOn                 '       All master bed lights on
        TurnAllModules "O", xOn                 '       All outside lights on
    END IF

    IF X10Cmd$ = "G04 Off" THEN                 ' Master bedroom ctrler
        JrIsWorking% = No                       '       Jr is not working today
    END IF

    IF X10Cmd$ = "G04 On" THEN                  ' Master bedroom ctrler
        CancelBedtime% = Yes                    '       Cancel dales bedtime
    END IF

    IF X10Cmd$ = "H04 On" THEN                  ' Living room sundowner ctrler
        DimModule "E02", 8                      '       Living table lamp to 8
        StartTimer 1, 10                        '       Start a 10 minute timer
    END IF

    IF X10Cmd$ = "H03 On" THEN                  ' Living room sundowner ctrler
        TurnAllModules "O", xOn                 '       Outside lights on
    END IF

    IF X10Cmd$ = "H03 Off" THEN                 ' Living room sundowner ctrler
        TurnAllModules "O", xOff                '       Outside lights off
    END IF

    'Ŀ
    ' The part of your schedule that would deal with any expired timers     
    '

    IF TimerExpired%(0) THEN                    ' Time to save status of modules
        SaveStatus                              '       Save status to disk
        StartTimer 0, 60                        '       Set timer for next save
    END IF

    IF TimerExpired%(1) THEN                    ' Our 10 minute timer expired
        DimModule "E02", 16                     '       Living table lamp to 16
    END IF

    'Ŀ
    ' Put any other conditions in this area.  Its wide open what you can do 
    '

    IF MID$(X10Date$, 1, 5) = "04-04" AND X10Time$ = "02:00" THEN
        SetDaylightTime
    END IF

    IF MID$(X10Date$, 1, 5) = "10-25" AND X10Time$ = "02:00" THEN
        SetStandardTime
    END IF

    KeyHit$ = UCASE$(INKEY$)
    '

    IF KeyHit$ = "T" THEN
        DisplayX10Globals
        PRINT "    Jr is working: ";
        IF JrIsWorking% THEN PRINT "Yes" ELSE PRINT "No"
        PRINT
        INPUT "Enter new time (00:00): ", Newtime$
        IF LEN(Newtime$) = 5 THEN
            TIME$ = Newtime$
            PRINT "Time has been reset to: " + Newtime$
        END IF
    END IF
    
'Ŀ
' End of the schedule loop.  If the user pressed the x key then exit        
'
LOOP UNTIL KeyHit$ = "X"

'Ŀ
' Make sure you close the communications to the TW523 driver before quitting
'
CloseTW523

'Ŀ
' Now you can safely quit the application                                   
'
END '

'ͻ
' Sub Program    Startup                                                   
'                                                                          
' Purpose        To initialize all of your X-10 modules to a known state.  
'                Usually this would be to turn all modules to Off.         
'                This is where you would also do any first time            
'                initialization of any variables you will be using.        
'                                                                          
' Syntax         Startup                                                   
'                                                                          
' Parameters     None                                                      
'                                                                          
' Example        Startup                                                   
'                                                                          
' Assumes        Nothing                                                   
'                                                                          
' Side Effects   Depends on what you do inside the procedure               
'                                                                          
' Returns        Nothing                                                   
'                                                                          
' LIB Calls      None                                                      
'                                                                          
'͹
' Notes:                                                                    
'                                                                           
'ͼ
'
'
'
SUB Startup
'

    'Ŀ
    ' Define the addresses of your plug-in lamp modules                     
    '
    LampModules$ = "E02E05"

    'Ŀ
    ' Initialize the variables for sunrise/sunset calcs.    ie: for Seattle 
    '
    SetMapCoord 122.2, 47.37, 8, "04-04", "10-25"

    'Ŀ
    ' Load the times for the variables Dawn$, Sunrise$, Sunset$ and Dusk$   
    '
    LoadSunTimes

    'Ŀ
    ' Initialize the day of the week and date variables                     
    '
    DayOfWeek$ = GetDow$
    X10Date$ = DATE$

    'Ŀ
    ' Initialize whether we are currently in Daylight or Standard time      
    '
    SetDaylightFlag
    '
    'Ŀ
    ' Do you want to display what is being transmitted and received?        
    '
    ShowTransmit% = Yes

    'Ŀ
    ' Turn all modules off, including appliance modules                     
    '
    TurnAllModules "D", xOff
    TurnAllModules "E", xOff
    TurnAllModules "F", xOff
    TurnAllModules "G", xOff
    TurnAllModules "O", xOff
    
    'Ŀ
    ' Do your custom variable initializations, ie: your days off            
    '
    IF DayOfWeek$ = "Sun" OR DayOfWeek$ = "Mon" THEN
        JrIsWorking% = No
        CancelBedtime% = Yes
    ELSE
        JrIsWorking% = Yes
        CancelBedtime% = No
    END IF

    DisplayX10Globals

    PRINT "    Jr is working: ";
    IF JrIsWorking% THEN PRINT "Yes" ELSE PRINT "No"
    PRINT
    
END SUB

