/*
ͻ
 Source File    X10_PDLC.H                                                
                                                                          
 System         X-10 Professional Developers Library for C                
                                                                          
 Purpose        Header file to use with the X10_PDLC.OBJ / .LIB           
                                                                          
 Author         Dale Morrison                                             
 Copyright      Smart Home Technology, 1993                               
ͼ


/*
Ŀ
 Declaration of global constant variables                                  

*/

const int     AllLightsOff = 17;
const int     TurnOn = 19;
const int     AllLightsOn = 21;
const int     HailAck = 22;
const int     BrightenIt = 23;
const int     TurnOff = 27;
const int     AllUnitsOff = 29;
const int     HailReq = 30;
const int     DimIt = 31;
const int     SinglePhase = 0;
const int     TriplePhase = 2;
const int     True = 1;
const int     False = 0;
const int     Yes = 1;
const int     No = 0;
const int     xOn = 1;
const int     xOff = 0;

/*
Ŀ
 Declaration of global variables                                           

*/

int     Addr523 = 0x61;
int     daylight = 0;
char    X10Cmd[30];
char    X10Date[11];
char    X10Time[9];
char    X10Dow[4];
char    Dawn [6];
char    Sunrise [6];
char    Sunset [6];
char    Dusk [6];
int     ShowTransmit;
int     PowerOutage;
char	*LampModules;

/*
Ŀ
 Function prototypes                                                       

*/

void   add_to_time(char *Time, int Min, char *NewTime);
void   cancel_timer (int Num);
void   close_tw523();
void   dim_module (char *UnitAddr, int Level);
void   dim_sel_modules (int Level);
void   display_x10_globals();
int    dow_is(char *string);
int    dow_is_not(char *string);
void   flash_module (char *UnitAddr, int Times);
void   flash_sel_modules (int Times);
void   flush_tw523();
void   force_module (char *UnitAddr, int OnOff);
void   force_sel_modules (int OnOff);
void   get_dow();
int    get_module_status (char *UnitAddr);
void   get_x10cmd();
void   get_x10date();
void   get_x10time();
void   load_sun_times();
int    load_status();
void   open_tw523 (int Phase);
void   pause(int Secs);
void   play_catchup();
int    query_tw523();
void   repeat_x10cmd (int Times);
void   save_status();
void   select_module (char *UnitAddr);
void   send_x10cmd (char House, int Cmd);
void   send_x10select ();
void   set_heartbeat (int Row, int Col);
void   set_map_coord(float Lng, float Lat, float Tz, char *Sdt, char *Edt);
void   set_mods_to_status();
void   set_time(char *New_time);
void   start_timer (int Num, int Minutes);
int    time_is(char *string);
int    time_is_after(char *string);
int    time_is_before(char *string);
int    time_is_not(char *string);
int    timer_expired (int Num);
void   turn_all_modules (char *House, int OnOff);
void   turn_module (char *UnitAddr, int OnOff);
void   turn_sel_modules (int OnOff);
void   update_module_status (char *UnitAddr, int Steps);
void   update_selected_status (int Steps);
int    x10cmd_is(char *string);

/*
Ŀ
 End of file: X10_PDLC.H                                                   

*/
