/*-----------------------------------------------------------------------
;
; XCBITMAP - header file
;
;   This module was written by Matthew MacKenzie
;   matm@eng.umd.edu
;
;
; ****** XLIB - Mode X graphics library                ****************
; ******                                               ****************
; ****** Written By Themie Gouthas                     ****************
; ****** Aeronautical Research Laboratory              ****************
; ****** Defence Science and Technology Organisation   ****************
; ****** Australia                                     ****************
;
; egg@dstos3.dsto.gov.au
; teg@bart.dsto.gov.au
;
;
;  Terminology & notes:
;         VRAM ==   Video RAM
;         SRAM ==   System RAM
;         X coordinates are in pixels unless explicitly stated
;
;----------------------------------------------------------------------*/

#ifndef _XCBITMAP_H_
#define _XCBITMAP_H_

extern int x_compile_bitmap (      /* Compile a linear bitmap to generate */
              WORD logical_width,   /* machine code to plot it at any      */
              char far * bitmap,    /* required screen coordinates FAST.   */
              char far * output);

extern void x_put_cbitmap (         /* Displays a compiled bitmap generated */
              WORD XPos,            /* by x_compile_bitmap                  */
              WORD YPos,
              WORD PageOffset,
              char far * CompiledBitmap);

#endif


