/*-----------------------------------------------------------------------
;
; XDETECT - header file
;
;
;
; ****** XLIB - Mode X graphics library                ****************
; ******                                               ****************
; ****** Written By Themie Gouthas                     ****************
; ****** Aeronautical Research Laboratory              ****************
; ****** Defence Science and Technology Organisation   ****************
; ****** Australia                                     ****************
;
; egg@dstos3.dsto.gov.au
; teg@bart.dsto.gov.au
;
;  Terminology & notes:
;         VRAM ==   Video RAM
;         SRAM ==   System RAM
;         X coordinates are in pixels unless explicitly stated
;
;-----------------------------------------------------------------------*/

#ifndef _XDETECT_H_
#define _XDETECT_H_

#define I8086   0
#define I80186  1
#define I80286  2
#define I80386  3

#define NoGraphics 0
#define MDA        1
#define CGA        2
#define EGAMono    3
#define EGAColor   4
#define VGAMono    5
#define VGAColor   6
#define MCGAMono   7
#define MCGAColor  8

/* FUNCTIONS =========================================================== */

extern int x_graphics_card();    /* Detect installed Graphics card type */
extern int x_processor();        /* Detect installed Graphics card type */


#endif


